/***************************************************************************
    file	         : kb_myadvanced.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	<qlayout.h>
#include	<qcheckbox.h>
#include	<qlineedit.h>
#include	<qlabel.h>
#include	<qpushbutton.h>

#include	"kb_classes.h"
#include	"kb_database.h"
#include	"kb_dom.h"


class	RKTabWidget	;


/*  KBMyAdvanced							*/
/*  ------------							*/
/*  This is the advanced options dialog for MySQL. It has the following	*/
/*  server-specific pages						*/
/*									*/
/*	* General options						*/

class	KBMyAdvanced : public KBDBAdvanced
{
	bool		m_ignoreCharset		;
	bool		m_foundRows		;
	bool		m_compressed		;

	QCheckBox	*m_cbIgnoreCharset	;
	QCheckBox	*m_cbFoundRows		;
	QCheckBox	*m_cbCompressed		;

public	:

	KBMyAdvanced	()	;
virtual~KBMyAdvanced	()	;

	virtual	void		load		(const QDomElement &) ;
	virtual	void		save		(QDomElement	   &) ;
	virtual	void		setupDialog	(RKTabWidget	   *) ;
	virtual	void		saveDialog	() ;
	virtual	KBDBAdvanced	*copy		() ;

	friend	class	KBMySQL	;
}	;
