/***************************************************************************
    file	         : kb_factory.cpp
    copyright            : (C) 1999,2000,2001 by Mike Richardson
			   (C) 2000,2001 by theKompany.com
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *     This program is licensed under the terms contained in the file      *
 *     LICENSE which is contained with the source code distribution.       *
 *                                                                         *
 ***************************************************************************/



#include	"kb_odbc.h"
#include	"kb_odbcadv.h"

/*  ------------------------------------------------------------------	*/

#if		__KB_LICENSE
#include	"kb_additional.h"
#include	"kb_trial.txt"
#endif

/*  ------------------------------------------------------------------	*/


using	namespace ODBC_NS ;



KBFACTORY
(	KBODBCFactory,
	"driver_odbc"
)

KBFACTORYIMPL
(	KBODBCFactory,
	driver_odbc
)


QObject	*KBODBCFactory::create
	(	QObject		  *parent,
		cchar		  *object,
		cchar		  *,
		const QStringList &
	)
{
	if ((parent != 0) && !parent->inherits ("QWidget"))
	{
		fprintf	(stderr, "KBODBCFactory: parent does not inherit QWidget\n") ;
		return	0  ;
	}

	if (strcmp (object, "advanced") == 0) return new KBODBCAdvanced () ;

#if	__KB_LICENSE
	KBPageSwitchLoader __kbtp_odbc (trialInfo) ;
	if (!__kbtp_odbc.ok()) return 0 ;
#endif
	if (strcmp (object, "driver"  ) == 0) return new KBODBC () ;
	return	0 ;
}

QString	KBODBCFactory::ident ()
{
	return	QString("ODBC: %1%2 %3")
			.arg(__KB_BUILD_RELEASE)
			.arg(__KB_BUILD_BUILD  )
			.arg(__KB_BUILD_TIME   )
			;
}
