/***************************************************************************
    file	         : kb_quickdlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	__KB_QUICKDLG_H
#define	__KB_QUICKDLG_H

#include	<qdict.h>

#include	"kb_prompt.h"
#include	"kb_classes.h"
#include	"kb_dialog.h"

class	KBFileList	;
class	KBScriptList	;
class	KBLocation	;

class	RKComboBox	;
class	RKPushButton	;
class	QLabel		;

class	KBDBDlgPluginItem	;


class	KBQuickDlg : public KBDialog
{
	Q_OBJECT

	RKComboBox			*m_cbType	;
	RKComboBox			*m_cbServer	;
	RKComboBox			*m_cbObject	;
	RKPushButton			*m_bOpen	;
	RKPushButton			*m_bCreate	;
	RKPushButton			*m_bRename	;
	RKPushButton			*m_bDelete	;
	RKPushButton			*m_bSaveToFile	;
	RKPushButton			*m_bSaveToWeb	;
	RKPushButton			*m_bCopy	;
	RKPushButton			*m_bCancel	;
	QLabel				*m_graphic	;

	KBDBInfo			*m_dbInfo	;
	const QValueList<KBDBDlgPluginItem>
					&m_allParts	;

protected slots :

	void		userChange	() ;
	void		objectChange	() ;
	void		clickDelete	() ;
	void		clickCreate	() ;
	void		clickRename	() ;
	void		clickCancel	() ;
	void		clickSaveToFile	() ;
	void		clickSaveToWeb	() ;
	void		clickOpen	() ;
	void		clickCopy	() ;

public	:

	KBQuickDlg
	(
		KBDBInfo			*,
		QValueList<KBDBDlgPluginItem>	&
	)	;

	const KBDBDlgPluginItem	&getResults	(QString &, QString &) ;

	enum	Option
	{	Cancelled,
		Open,
		Create,
		Rename,
		Delete,
		Copy,
		SaveToFile,
		SaveToWeb
	}	;

	static	bool	copyObjects
			(	KBLocation		&location
			)	;
	static	bool	renameObject
			(	KBLocation		&location
			)	;
	static	bool	deleteObject
			(	KBLocation		&location
			)	;

	static	KBMessageBoxYNAC::ActRC
			saveObjToFile
			(	KBLocation		&location,
				const QString		&path,
				KBMessageBoxYNAC::ActRC	actRC
			)	;

	static	KBMessageBoxYNAC::ActRC
			saveObjToWeb
			(	KBLocation		&location,
				KBFileList		*list,
				const QString		&dir,
				KBMessageBoxYNAC::ActRC	actRC
			)	;

	static	bool	saveObjToFile
			(	KBLocation		&location
			)	;
	static	bool	saveAllToFile
			(	KBLocation		&location
			)	;
	static	bool	saveObjToWeb
			(	KBLocation		&location,
				KBFileList		*list
			)	;
	static	bool	saveAllToWeb
			(	KBLocation		&location,
				KBFileList		*list
			)	;
}	;

#endif	// __KB_QUICKDLG_H
