/***************************************************************************
    file	         : kb_rtbuild.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_RTBUILD_H
#define	__KB_RTBUILD_H

#include	<qcombobox.h>
#include	<qlineedit.h>
#include	<qpushbutton.h>
#include	<qprocess.h>
#include	<qtextview.h>

#include	"kb_dialog.h"


/*  KBRTBuild								*/
/*  ---------								*/
/*  This dialog is used to interface to the database packager primarily	*/
/*  used to build runtime packages for the Zaurus.			*/

class	KBRTBuild : public KBDialog
{
	Q_OBJECT

	QString		m_dir		;
	QString		m_name		;

	QComboBox	m_type		;
	QLineEdit	m_release	;
	QLineEdit	m_maintainer	;
	QLineEdit	m_target	;

	QTextView	m_status	;

	QPushButton	m_bBrowse	;
	QPushButton	m_bOK		;
	QPushButton	m_bCancel	;

	QProcess	*m_process	;
	QString		m_statusText	;

	void		addText		(const QString &) ;

protected slots :

	void		slotClickBrowse	() ;
	void		slotClickOK	() ;
	void		slotClickCancel	() ;
	void		slotReadStdout	() ;
	void		slotReadStderr	() ;
	void		slotProcExited	() ;

public	:

	KBRTBuild	(const QString &, const QString &) ;
	~KBRTBuild	() ;
}	;

#endif	// __KB_RTBUILD_H
