/***************************************************************************
    file	         : kb_serverdlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_SERVERDLG_H
#define	__KB_SERVERDLG_H


#include	<qdict.h>
#include	<qlabel.h>
#include	<qcheckbox.h>
#include	<qlayout.h>
#include	<qgroupbox.h>
#include	<qdialog.h>

#include	"kb_classes.h"
#include	"kb_serverinfo.h"
#include	"kb_serverdata.h"
#include	"kb_dbdlg.h"

#include	"tk_messagebox.h"
#include	"tk_filedialog.h"
#include	"rk_vbox.h"

class	RKComboBox	;
class	RKLineEdit	;
class	RKPushButton	;
class	RKListBox	;
class	RKTabWidget	;
class	QSpinBox	;

/*  KBServerDlg								*/
/*  -----------								*/
/*  This dialog box is used to configure named server connections in	*/
/*  terms of host, database name, user and passord, and so forth.	*/
/*  push-buttons.							*/

class	KBServerDlg : public KBDialog
{
	Q_OBJECT

	KBDriverDetailsList	&m_drvList		;
	KBServerData		*m_serverData		;

	RKTabWidget		*m_tabber		;
	int			n_fixedTabs		;

	RKLineEdit		*m_serverName		;
	RKComboBox		*m_dbType		;
	RKLineEdit		*m_hostName		;
	RKComboBox		*m_dbName		;
	RKLineEdit		*m_userName		;
	RKLineEdit		*m_password		;
	RKLineEdit		*m_portNumber		;
	RKLineEdit		*m_socketName		;
	RKLineEdit		*m_flags		;
	QCheckBox		*m_showPwd		;
	QCheckBox		*m_disabled		;
	QCheckBox		*m_autostart		;

	RKPushButton		*m_bDatabases		;

	QCheckBox		*m_noRekallTables	;
	QCheckBox		*m_showAllTables	;
	QCheckBox		*m_cacheTables		;
	QCheckBox		*m_nullUserPwd		;
	QCheckBox		*m_pkReadOnly		;
	QCheckBox		*m_fakeKeys		;
	QCheckBox		*m_readOnly		;
	RKComboBox		*m_showTests		;
	RKLineEdit		*m_autoForm		;
	RKComboBox		*m_dataEncoding		;
	RKComboBox		*m_objEncoding		;
	RKLineEdit		*m_webDirectory		;
	RKPushButton		*m_webBrowse		;
	QSpinBox		*m_cacheSize		;
	RKLineEdit		*m_appFont		;
	RKLineEdit		*m_skinSuffix		;
	RKTextEdit		*m_initSQL		;
	RKTextEdit		*m_comment		;

#ifdef	Q_OS_LINUX
	RKLineEdit		*m_sshTarget		;
#endif

	bool		showServerData		(bool)	;
	void		setEnabledAll		(bool, uint) ;

private slots :

	void		showPassword		(bool)	;
	void		typeChange		()	;
	void		showDatabases		()	;
	void		webBrowse		()	;
	void		setAppFont		()	;

public	:

	KBServerDlg	(KBServerData *, KBDriverDetailsList &)	;
       ~KBServerDlg	() ;

	int		exec			(bool)	;
	virtual	void	accept			()	;
	void		save			()	;
}	;

#endif	// __KB_SERVERDLG_H
