/***************************************************************************
    file	         : kb_servertab.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_SERVERTAB_H
#define	_KB_SERVERTAB_H


#include	<qdict.h>
#include	<qlabel.h>
#include	<qcheckbox.h>
#include	<qlayout.h>
#include	<qgroupbox.h>
#include	<qdialog.h>

#include	"kb_classes.h"
#include	"kb_serverinfo.h"
#include	"kb_serverdata.h"

#include	"tk_messagebox.h"
#include	"tk_filedialog.h"
#include	"rk_vbox.h"


class	RKComboBox		;
class	RKLineEdit		;
class	RKPushButton		;
class	RKListBox		;
class	KBDBaseDlg		;
class	QTextBrowser		;

class	KBServerTabIface	;

/*  KBServerTab								*/
/*  -----------								*/

class	KBServerTab : public RKVBox
{
	Q_OBJECT

	KBDBaseDlg		*m_dbaseDlg	;
	KBServerTabIface	*m_dcopIface	;

	RKListBox		*m_serverList	;
	QTextBrowser		*m_details	;

	RKPushButton		*m_bNew		;
	RKPushButton		*m_bEdit	;
	RKPushButton		*m_bDelete	;

	KBDBInfoData		*m_dbInfo	;
	KBDriverDetailsList	m_drvList	;

	void		editServer		(bool)	;

	void		showServerInfo		(KBServerData  *) ;
	void		showServer   		(int)	;

	void		loadDBInfo		()	;
	bool		autoStartForm		(KBServerInfo   *, KBLocation &) ;

private slots :

	void		clickEdit		()	;
	void		clickNew		()	;
	void		clickDelete		()	;
	void		showServer		()	;

public	:

	KBServerTab (QWidget *, KBDBaseDlg *, KBDBInfoData *, KBaseGUI *) ;
       ~KBServerTab () ;

	bool		autoStart 		(KBLocation &) ;
	void		showRawSQL		(KBaseApp   *) ;
#if	! __KB_RUNTIME
	void		dumpDatabase		(KBaseApp   *) ;
	void		loadDatabase		(KBaseApp   *) ;
#endif

	QStringList	listServers		() ;
}	;

#endif	// _KB_SERVERTAB_H
