/***************************************************************************
    file	         : rekall.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/



#include	<stdio.h>
#include	<stdlib.h>
#include	<qglobal.h>

/*  myMsgHandler: Local QT error message handler			*/
/*  type	: QtMsgType	: Message type				*/
/*  msg		: const char *	: Message text				*/
/*  (returns)	: void		:					*/

static	void	myMsgHandler
	(	QtMsgType	type,
		const char	*msg
	)
{
	extern	FILE     *kbDPrintfGetStream () ;
	FILE	*fd	= kbDPrintfGetStream () ;

	switch (type)
	{
		case QtDebugMsg   :
			fprintf	(fd, "Debug: %s\n",   msg) ;
			break	;

		case QtWarningMsg :
			fprintf	(fd, "Warning: %s\n", msg) ;
			break	;

		case QtFatalMsg	  :
			fprintf	(fd, "Fatal: %s\n",   msg) ;
			abort	() ;
			break	;

		default	:
			fprintf	(fd, "Unknown: %s\n", msg) ;
			abort	() ;
			break	;
	}
}

/*  main	: Main routine						*/
/*  argc	: int		: Argument count			*/
/*  argv	: char *[]	: Argument vector			*/
/*  (returns)	: int		: Exit code				*/

int	main
	(	int	argc,
		char	*argv[]
	)
{
	extern	int	rekallMain (int, char *[]) ;
	extern	void    registerAllNodes() ;
	extern	void	kbWizardDummy	() ;

	qInstallMsgHandler (myMsgHandler) ;
	registerAllNodes   () ;

	kbWizardDummy	   () ;

	return	rekallMain (argc, argv) ;
}
