/***************************************************************************
    file	         : kb_svrchooser.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_SVRCHOOSER_H
#define	__KB_SVRCHOOSER_H

#include	<qmap.h>

#include	"kb_classes.h"
#include	"kb_type.h"
#include	"kb_value.h"
#include	"kb_location.h"
#include	"kb_dialog.h"

#include	"kb_dblink.h"
#include	"kb_dbinfo.h"

#include 	"libapp_exports.h"

class	QLabel		;
class	QCheckBox	;
class	RKComboBox	;
class	RKPushButton	;
class	RKListBox	;

/*  KBSvrChooserDlg							*/
/*  ---------------							*/
/*  This class provies a simple server/document selection dialog, based	*/
/*  on the chooser class above.						*/

class	LIBAPP_API KBSvrChooserDlg : public KBDialog
{
	Q_OBJECT

	RKComboBox		*m_cbServer	;
	QCheckBox		*m_cOver	;
	RKListBox		*m_lbOut	;
	RKListBox		*m_lbIn		;
	RKPushButton		*m_bAdd		;
	RKPushButton		*m_bAddAll	;
	RKPushButton		*m_bRemove	;

	RKPushButton		*m_bOK		;
	RKPushButton		*m_bCancel	;

	QMap<QString,QString>	m_extnMap	;

protected slots :

//	void		clickOK	    ()	;
//	void		clickCancel ()	;
	void		clickAdd    ()  ;
	void		clickRemove ()	;

	void		inHighlight ()	;
	void		outHighlight()	;

public	slots	:

	void		clickAddAll ()	;

public	:

	KBSvrChooserDlg		(KBDBInfo *, const QString &, bool = false, bool = true) ;

	void		getInfo		(QString &, QStringList &, bool &) ;
	void		addEntry	(const QString &, const QString & = QString::null) ;
	void		selectEntry	(const QString &) ;
	QString		extensionFor	(const QString &) ;
}	;

#endif	// __KB_SVRCHOOSER_H
