/***************************************************************************
    file	         : kb_classes.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_CLASSES_H
#define	__KB_CLASSES_H


#include	<stdio.h>

#include	<qglobal.h>
#include	<qdict.h>
#include	<qstring.h>

#include 	"libcommon_exports.h"

#define		KB_HEXVER		0x00020000

class	KBaseApp	;
class	KBaseGUI	;
class	KBasePart	;
class	KBFormCopier	;

class	KBControl	;

class	KBNode		;
class	KBNodeMonitor	;
class	KBForm		;
class	KBReport	;
class	KBComponent	;
class	KBCompLink	;
class	KBLayout	;
class	KBDocRoot	;
class	KBParam		;
class	KBModule	;
class	KBImport	;
class	KBScript	;
class	KBScriptCode	;
class	KBScriptObject	;
class	KBConfig	;
class	KBOverride	;
class	KBObject	;
class	KBItem		;
class	KBField		;
class	KBBlock		;
class	KBFormBlock	;
class	KBReportBlock	;
class	KBFramer	;
class	KBHeader	;
class	KBFooter	;
class	KBContainer	;
class	KBTabberPage	;
class	KBTabber	;
class	KBStackPage	;
class	KBStack		;
class	KBNavigator	;
class	KBButton	;
class	KBLabel		;
class	KBGraphic	;
class	KBLink		;
class	KBChoice	;
class	KBCheck		;
class	KBPixmap	;
class	KBTestSuite	;
class	KBMorph		;
class	KBRowMark	;
class	KBGrid		;
class	KBHidden	;
class	KBMemo		;
class	KBSummary	;
class	KBSpinBox	;
class	KBData		;
class	KBAttr		;
class	KBAttrStr	;
class	KBAttrInt	;
class	KBAttrUInt	;
class	KBAttrBool	;
class	KBAttrDict	;
class	KBEvent		;
class	KBEmitter	;
class	KBSlot		;
class	KBTest		;
class	KBParamSet	;

class	KBWriter	;
class	KBWidgetWriter	;
class	KBPrinterWriter	;

class	KBQuery		;
class	KBTable		;
class	KBQryExpr	;
class	KBQueryDlg	;

class	KBQryBase	;
class	KBQryData	;
class	KBQryDesign	;
class	KBQryTable	;
class	KBQryQuery	;
class	KBQrySQL	;
class	KBQryNull	;
class	KBQryLevel	;

class	KBDisplay	;
class	KBScriptIF	;
class	KBObjBase	;

class	KBTableList	;
class	KBFileList	;
class	KBFormList	;
class	KBReportList	;
class	KBQueryList	;
class	KBScriptList	;

class	KBServerDlg	;
class	KBDBaseDlg	;
class	KBDBInfo	;
class	KBDBLink	;
class	KBServerInfo	;
class	KBDBAdvanced	;

class	KBNotifier	;
class	KBCallback	;

class	KBValue		;
class	KBType		;
class	KBShared	;
class	KBDateTime	;

struct	KBDataArray	;
class	KBDataBuffer	;

class	KBPopupMenu	;
class	KBResizeWidget	;

class	QXmlAttributes	;


class	KBFactory	;
class	KBPartFactory	;


class 	LIBCOMMON_API	KB
{
public	:

	enum	TableType
	{	IsTable		= 0x01,
		IsView		= 0x02,
		IsSequence	= 0x04,
		IsAny		= 0xff
	}	;

	enum	CtrlAlign
	{	AlignTop	= 1,
		AlignLeft	= 2,
		AlignBottom	= 3,
		AlignRight	= 4,
		SameHeight	= 5,
		SameWidth	= 6,
		SameSize	= 7
	}	;

	enum	Action
	{	Null		= 0,
		First		= 1,
		Previous	= 2,
		Next		= 3,
		Last		= 4,
		Add		= 5,
		Save		= 6,
		Delete		= 7,
		Query		= 8,
		Execute		= 9,
		Cancel		= 10,
		Insert		= 11,
		PrevBack	= 12,
		NextForw	= 13,
		Reset		= 14,
		GotoQRow	= 15,
		SyncAll		= 16,
		Store		= 17,
		PrevPage	= 18,
		NextPage	= 19,
		Reload		= 20,
		Scroll		= 21,
		SaveAsNew	= 22,
		SaveUnchecked	= 23
	}	;

	enum	IType
	{
		ITUnknown	= 0,	/* Type not known		*/
		ITRaw		= 1,	/* Value to be used raw		*/
		ITFixed		= 2,	/* Value is fixed point		*/
		ITFloat		= 3,	/* Value is floating point	*/
		ITDecimal	= 4,	/* Value is decimal(n,m)	*/
		ITDate		= 5,	/* Value is date		*/
		ITTime		= 6,	/* Value is time		*/
		ITDateTime	= 7,	/* Value is date/time		*/
		ITString	= 8,	/* Value is a string		*/
		ITBinary	= 9,	/* Value is binary data		*/
		ITBool		= 10,	/* Value is boolean		*/
		ITDriver	= 11,	/* Value is driver-specific	*/

					/* Internal use only ....	*/
		ITNode		= 100	/* Value is KBNode object	*/
	}	;

	enum	RState
	{
		RSUnknown,		/* Row state not known		*/
		RSInSync,		/* In sync with server		*/
		RSDeleted,		/* Row marked deleted		*/
		RSInserted,		/* Row has been inserted	*/
		RSChanged		/* Row contents changed		*/
	}	;

	enum	ScriptRC
	{	ScriptOK,		/* Script exited correctly	*/
		ScriptEventError,	/* Error in event		*/
		ScriptSlotError,	/* Error in slot		*/
		ScriptGlobalError	/* Error elsewhere		*/
	}	;

	enum	ShowAs
	{	ShowAsUnknown,		/* Indeterminate state		*/
		ShowAsData,		/* Show document in data view	*/
		ShowAsPrint,		/* Print document		*/
		ShowAsPreview,		/* Preview document		*/
		ShowAsReport,		/* Print report			*/
		ShowAsDesign		/* Show document in design view	*/
	}	;

	enum	ShowRC
	{	ShowRCOK,		/* Document shown OK		*/
		ShowRCModal,		/* Document shown modally	*/
		ShowRCData,		/* Document shown in data view	*/
		ShowRCError,		/* Error showing document	*/
		ShowRCCancel,		/* User cancelled		*/
		ShowRCReport,		/* Report printed		*/
		ShowRCDesign		/* Document shown in design	*/
	}	;

	enum	ShowMode
	{	ShowAuto,		/* Show in requested state	*/
		ShowNormal,		/* Show in normal state		*/
		ShowModal		/* Show in modal state		*/
	}	;

	enum	MarkOp
	{	MarkOpSet,		/* Mark specified row		*/
		MarkOpSetAll,		/* Mark all rows		*/
		MarkOpToggle,		/* Toggle mark on specified row	*/
		MarkOpRange,		/* Set mark on range of rows	*/
		MarkOpClear		/* Clear all marks		*/
	}	;

	enum	ObjType
	{
		ObjUnknown	= 0,
		ObjForm		= 1,
		ObjReport	= 2
	}	;

private :

}	;

typedef	unsigned int	uint	  ;
typedef	const char	cchar	  ;



#define	DELOBJ(p)	if (p) { delete p ; p = 0 ; }

/*  TITER(Type,Ptr,Action)						*/
/*  This macro is like kb_node.h/CITER, except that an explicit list	*/
/*  is given.								*/


#define	TITER(Type,List,Ptr,Action) \
	{	QPtrListIterator<KBNode> __iter (List) ;		\
		KBNode *__##Ptr ;					\
		KB##Type *Ptr ;						\
		while ((__##Ptr = __iter.current()) != 0)		\
		{	__iter += 1 ;					\
			if ((Ptr = __##Ptr->is##Type()) != 0)		\
			{	Action ;				\
			}						\
		}							\
	}

/*  LITER(Type,List,Ptr)						*/
/*  Another convenience macro. Iterates through a list of sepecified	*/
/*  type for a named pointer variable, applyting action.		*/


#define	LITER(Type,List,Ptr,Action) \
	{	QPtrListIterator<Type> __iter (List)  ; 		\
		Type *Ptr ;						\
		while ((Ptr = __iter.current()) != 0)			\
		{	__iter += 1 ;					\
			Action ;					\
		}							\
	}

/*  LITER(Type,List,Ptr)						*/
/*  Another convenience macro, similar to LITER, but iterates through	*/
/*  a dictionary.							*/


#define	DITER(Type,Dict,Ptr,Action) \
	{	QDictIterator<Type> __iter (Dict)  ; 			\
		Type *Ptr ;						\
		while ((Ptr = __iter.current()) != 0)			\
		{	__iter += 1 ;					\
			Action ;					\
		}							\
	}


#define	OBJECTTABNAME	"RekallObjects"

#if	__KB_KDE
#include		<klocale.h>
#define	TR(x)		i18n(x)
#endif

#if	__KB_TKC
#define	TR(x)		QObject::trUtf8(x, "")
#endif

#define	__TR(x)		x

#include	"kb_error.h"

#if	__KB_DPRINTF
#define	DPRINTF(x)	kbDPrintf	x
#else
#define	DPRINTF(x)
#endif

#define	XPRINTF(x)	kbDPrintf	x

extern	LIBCOMMON_API	void	kbDPrintf		(const char *, ...)	;
extern	LIBCOMMON_API	void	kbDPrintfSetStream	(const char *)		;
extern	LIBCOMMON_API	void	kbDPrintfSetStream	(FILE *)		;
extern	LIBCOMMON_API	FILE	*kbDPrintfGetStream	()			;

#endif	// __KB_CLASSES_H
