/***************************************************************************
    file	         : kb_dom.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef		__KB_DOM_H
#define		__KB_DOM_H

#ifdef		QT_NO_DOM
#undef		QT_NO_DOM
#undef		QDOM_H
#endif		// QT_NO_DOM

#include	<qdom.h>

#include	"kb_classes.h"
#include 	"libcommon_exports.h"

/*  DOMITER_BEGIN/END							*/
/*  -----------------							*/
/*  These are convenience macros used to iterate through the child	*/
/*  elements of a specified element, with a given tag.			*/

#define	DOMITER_BEGIN(root,tag,child)	\
	{										\
	for (QDomNode n = root.firstChild() ; !n.isNull() ; n = n.nextSibling())	\
	{	QDomElement child = n.toElement() ;					\
		if (child.tagName() != tag) continue ;

#define	DOMITER_ELEM_BEGIN(root,child)	\
	{										\
	for (QDomNode n = root.firstChild() ; !n.isNull() ; n = n.nextSibling())	\
	{	QDomElement child = n.toElement() ;					\
		if (child.isNull()) continue ;

#define	DOMITER_END	\
	}		\
	}



/*  KBDomDocument							*/
/*  -------------							*/
/*  Simple helper class around QDomDocument to provide some extra	*/
/*  methods.								*/

class	LIBCOMMON_API KBDomDocument : public QDomDocument
{
	KBError		m_error	;

public	:

	KBDomDocument		()	;
	KBDomDocument		(const QString &) ;

	bool	loadFile	(const QString &, const char *, const char * = 0) ;

	inline	const KBError	&lastError ()
	{
		return	m_error	;
	}
}	;

#endif		// __KB_DOM_H
