/***************************************************************************
    file	         : kb_dprintf.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	"stdio.h"
#include	"stdarg.h"

#include	"libcommon_exports.h"

#include	"kb_dprintf.h"


static	FILE	*stream	;

/*  kbDPrintfGetStream							*/
/*		: Get debug output stream				*/
/*  (returns)	: FILE *	:					*/

FILE	LIBCOMMON_API
	*kbDPrintfGetStream	()
{
	/* If the stream has not been set up then it defaults to	*/
	/* statndard error.						*/
	return	stream == 0 ? stderr : stream ;
}

void	LIBCOMMON_API
	kbDPrintf
	(	const char	*format,
		...
	)
{
	va_list	 aptr ;
	va_start (aptr, format) ;
	vfprintf (kbDPrintfGetStream(), format, aptr) ;
}

void	LIBCOMMON_API
	kbDPrintfSetStream
	(	const char	*s
	)
{
	stream	= fopen (s, "w") ;
}

void	LIBCOMMON_API
	kbDPrintfSetStream
	(	FILE		*s
	)
{
	stream	= s	;
}

