/***************************************************************************
    file	         : kb_file.cpp
    copyright            : (C) 1999,2000,2001,2002,2003,2004 by Mike Richardson
			   (C) 2001,2002,2003,2004 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<errno.h>
#include	<string.h>

#include	"kb_classes.h"
#include	"kb_file.h"

#include	<qobject.h>

static	cchar	*errorString ()
{
#ifdef	Q_OS_WIN32
	return	0	;
#endif
#ifdef	Q_OS_LINUX
	return	strerror(errno)	;
#endif
#ifdef	Q_OS_MACX
	return	strerror(errno)	;
#endif
}


/*  KBFile								*/
/*  KBFile	: Constructor for file object				*/
/*  (returns)	: KBFile	:					*/

KBFile::KBFile ()
{
}


/*  KBFile								*/
/*  KBFile	: Constructor for file object				*/
/*  name	: const QString & : File name				*/
/*  (returns)	: KBFile	  :					*/

KBFile::KBFile
	(	const QString	&name
	)
	:
	QFile	(name)
{
}

/*  KBFile								*/
/*  open	: Open the file						*/
/*  mode	: int		: Opening mode				*/
/*  (returns)	: bool		: Success				*/

bool	KBFile::open
	(	int		mode
	)
{
	if (! QFile::open (mode))
	{
		m_error	= KBError
			  (	KBError::Error,
			  	QString(TR("Unable to open '%1'")).arg(name()),
				errorString(),
				__ERRLOCN
			  )	;
		return	false	;
	}

	return	true	;
}

