/***************************************************************************
    file	         : kb_file.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	__KB_FILE_H
#define	__KB_FILE_H

#include	<qfile.h>

#include 	"libcommon_exports.h"
#include	"kb_error.h"


/*  KBFile								*/
/*  ------								*/
/*  This class is a simple wrapper around QFile which stores a KBError	*/
/*  error in the event that the file cannot be opened.			*/

class	LIBCOMMON_API	KBFile : public QFile
{
	KBError		m_error	;

public	:

	KBFile	()			;
	KBFile	(const QString &)	;

	bool	open	(int)		;

	const KBError	&lastError ()
	{
		return	m_error	;
	}
}	;

#endif	// __KB_FILE_H
