/***************************************************************************
    file	         : kb_notifier.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	"kb_classes.h"

#if	 	__KB_AUTOMOC
#include 	"kb_notifier.moc"
#else
#include	"kb_notifier.h"
#endif



/*  KBNotifier								*/
/*  KBNotifier	: Constructor for notifier object			*/
/*  (returns)	: KBNotifier	:					*/

KBNotifier::KBNotifier ()
	:
	QObject	(0)
{
}

/*  KBNotifier								*/
/*  nServerChanged							*/
/*		: Server has changed					*/
/*  location	: const KBLocation & : Location information		*/
/*  (returns)	: void		     :					*/

void	KBNotifier::nServerChanged
	(	const KBLocation &location
	)
{
	emit	sServerChanged (location) ;
}

/*  KBNotifier								*/
/*  nTablesChanged							*/
/*		: Tables have changed					*/
/*  location	: const KBLocation & : Location information		*/
/*  (returns)	: void		     :					*/

void	KBNotifier::nTablesChanged
	(	const KBLocation &location
	)
{
	emit	sTablesChanged (location) ;
}

/*  KBNotifier								*/
/*  nObjectChanged							*/
/*		: Object has changed					*/
/*  location	: const KBLocation & : Location information		*/
/*  (returns)	: void		     :					*/

void	KBNotifier::nObjectChanged
	(	const KBLocation &location
	)
{
	emit	sObjectChanged (location) ;
}

/*  KBNotifier								*/
/*  nSkinChanged: Skin has changed					*/
/*  location	: const KBLocation & : Location information		*/
/*  (returns)	: void		     :					*/

void	KBNotifier::nSkinChanged
	(	const KBLocation &location
	)
{
	emit	sSkinChanged (location) ;
}

/*  KBNotifier								*/
/*  nOptionsChanged							*/
/*		: Options have changed					*/
/*  (returns)	: void		     :					*/

void	KBNotifier::nOptionsChanged ()
{
	emit	sOptionsChanged	() ;
}


/*  KBNotifier								*/
/*  self	: Access singleton object				*/
/*  (returns)	: KBNotifier *	: Notifier				*/

KBNotifier *KBNotifier::self ()
{
	static	KBNotifier *kbNotifier = 0 ;
	if (kbNotifier == 0) kbNotifier = new KBNotifier () ;
	return	kbNotifier ;
}
