/***************************************************************************
    file	         : kb_shared.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_SHARED_H
#define	_KB_SHARED_H

#include	"kb_classes.h"	
#include	"libcommon_exports.h"


/*  KBShared								*/
/*  --------								*/
/*  This is like the QShared class except that (a) there is a virtual	*/
/*  destructor and the deref method is virtual and (b) the deref method	*/
/*  does automatic deletion when the count falls to zero.		*/

class	LIBCOMMON_API	KBShared
{
	uint		m_count	;

public	:

			KBShared	()	;
			KBShared	(bool)	;
	virtual	       ~KBShared	()	;

	void		ref   		()	;
	virtual void	deref 		()	;
}	;

class	LIBCOMMON_API	KBSharedNode : public KBShared
{
	KBNode		*m_node	;

public	:

	inline	KBSharedNode
		(	KBNode	*node
		)
		:
		m_node	(node)
	{
	}

	inline	KBNode	*node	()
	{
		return	m_node	;
	}
}	;

#endif	// _KB_SHARED_H
