/***************************************************************************
    file	         : __FNAME__
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	"kb_classes.h"
#include	"kb_extra.h"
#include	"kb_macro.h"
#include	"kb_macrodef.h"

#define		__DEBUG_EXTRA	(0)
#if		__DEBUG_EXTRA
#include	"kb_dprintf.h"
#endif


class	QStringList	;


KBFACTORYIMPL
(	KBExtraFactory,
	plugin_extra
)


QObject	*KBExtraFactory::create
	(	QObject		  *,
		cchar		  *,
		cchar		  *,
		const QStringList &
	)
{
	DPRINTF		(("KBExtraFactory::create: CALLED\n")) ;

	MACRODECL	(standard,	OpenForm 	)
	MACRODECL	(standard,	CloseForm	)
	MACRODECL	(standard,	Navigate	)
	MACRODECL	(standard,	ReloadForm	)
	MACRODECL	(standard,	SetField	)
	MACRODECL	(standard,	GetField	)
	MACRODECL	(standard,	OpenQuery 	)
	MACRODECL	(standard,	CloseQuery	)
	MACRODECL	(standard,	OpenReport 	)
	MACRODECL	(standard,	CloseReport	)
	MACRODECL	(standard,	OpenTable 	)
	MACRODECL	(standard,	CloseTable	)
	MACRODECL	(standard,	MessageBox	)
	MACRODECL	(standard,	CancelBox	)
	MACRODECL	(standard,	PromptBox	)
	MACRODECL	(standard,	SQL		)

	MACRODECL	(tests,		VerifyValue	)
	MACRODECL	(tests,		VerifyRegexp	)
	MACRODECL	(tests,		VerifyChoices	)
	MACRODECL	(tests,		VerifyText	)
	MACRODECL	(tests,		VerifyState	)
	MACRODECL	(tests,		VerifyStack	)
	MACRODECL	(tests,		UpdateValue	)
	MACRODECL	(tests,		KeyNavigation	)
	MACRODECL	(tests,		MouseNavigation	)
	MACRODECL	(tests,		MouseClick	)
	MACRODECL	(tests,		PopupResult	)
	MACRODECL	(tests,		RaisePage	)

	return	0	;
}

QString	KBExtraFactory::ident ()
{
	return	QString("Extra: %1%2 %3")
			.arg(__KB_BUILD_RELEASE)
			.arg(__KB_BUILD_BUILD  )
			.arg(__KB_BUILD_TIME   )
			;
}
