/***************************************************************************
    file	         : kb_ascii.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_ASCII_H
#define		__KB_ASCII_H

#include	<qstring.h>
#include	<qevent.h>

#include	"kb_classes.h"
#include 	"libkbase_exports.h"


class	QColor	;
class	QSize	;
class	QRect	;
class	QDate	;
class	QTime	;

/*  KBAscii							*/
/*  -------							*/
/*  This is just a helper class, mainly for debugging, which	*/
/*  will return string representations of assorted objects.	*/

class	LIBKBASE_API	KBAscii
{
public	:

	static	QString	text	(const QColor &) ;
	static	QString	text	(const QPoint &) ;
	static	QString	text	(const QSize  &) ;
	static	QString	text	(const QRect  &) ;
	static	QString	text	(const QDate  &) ;
	static	QString	text	(const QTime  &) ;
	static	QString	text	(cchar *,  uint) ;
	static	QString	text	(QEvent::Type  ) ;

	static	inline	QString	text
		(	const QString	&s
		)
	{
		return	s	;
	}
}	;

#define	_TEXT(o)	(cchar *)KBAscii::text(o)

#endif	// __KB_ASCII_H
