/***************************************************************************
    file	         : kb_attralign.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_ATTRALIGN_H
#define	__KB_ATTRALIGN_H

#include	"libkbase_exports.h"
#include	"kb_attr.h"

#if		! __KB_RUNTIME
#include	"kb_attritem.h"
#endif

/*  KBAttrAlign								*/
/*  -----------								*/
/*  This class handles attributes which describe alignment. The basic	*/
/*  case is horizontal/vertical, while for KBLabel we also allow rich	*/
/*  text as an option.							*/

class	LIBKBASE_API	KBAttrAlign : public KBAttrInt
{
public	:

	KBATTRCTRDEF (KBAttrAlign, KBAttrInt)
	KBATTRINTDEF (KBAttrAlign, KBAttrInt)
	KBATTRDLGDEF

#if	! __KB_RUNTIME
	virtual	QString		displayValue	(const QString &) ;
#endif
	virtual	KBAttr		*replicate	(KBNode  * ) ;
}	;

#define	RICHTEXT	0x1001
#define	Horizontal_Mask	(Qt::AlignHorizontal_Mask)
#define	Vertical_Mask	(Qt::AlignVertical_Mask)

#endif	// __KB_ATTRALIGN_H
