/***************************************************************************
    file	         : kb_attrgeomdlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_ATTRTGEOMDLG_H
#define	_KB_ATTRTGEOMDLG_H

#if	! __KB_RUNTIME

class	QSpinBox	;
class	RKComboBox	;
class	RKGridBox	;

#include	"libkbase_exports.h"

#include	"kb_classes.h"
#include	"kb_attrdlg.h"
#include	"kb_propdlg.h"
#include	"kb_attrgeom.h"



/*  KBAttrGeomItem							*/
/*  --------------							*/
/*  Attribute item class for use in property dialogs, customised to	*/
/*  handle the geometry attribute.					*/

class	LIBKBASE_API	KBAttrGeomItem : public KBAttrItem
{
	KBAttrGeom		*m_attrGeom	;
	KBObject		*m_parent	;

	KBAttrGeom::KBAttrGeomValues
				m_d		;

	QRect			convGeometry
				(	int,
					int,
					int,
					int,
					KBAttrGeom::FloatMode,
					KBAttrGeom::FloatMode
				)	;
public	:

	KBAttrGeomItem		(KBAttrGeom *)	;
	~KBAttrGeomItem		()		;

	virtual	QString		displayValue	() ;
	virtual	void		clear		() ;
	virtual	void		save		() ;

	virtual	KBAttrDlg	*getAttrDlg	(QWidget *, QDict<KBAttrItem> &) ;

	friend	class		KBAttrGeomDlg	;
}	;


/*  KBAttrGeomDlg							*/
/*  --------------							*/
/*  Dialog component for geometry settings				*/

class	LIBKBASE_API	KBAttrGeomDlg : public KBAttrDlg
{
	Q_OBJECT

	KBAttrGeomItem		*m_attrItem	;

	QSpinBox		*m_x		;
	QSpinBox		*m_y		;
	QSpinBox		*m_w		;
	QSpinBox		*m_h		;
	RKComboBox		*m_xmode	;
	RKComboBox		*m_ymode	;
	RKPushButton		*m_fill		;

	QSpinBox		*m_minw		;
	QSpinBox		*m_maxw		;
	QSpinBox		*m_minh		;
	QSpinBox		*m_maxh		;
	QCheckBox		*m_byChars	;

	RKComboBox		*m_manage	;
	QSpinBox		*m_nRows	;
	QSpinBox		*m_nCols	;
	QSpinBox		*m_margin	;
	QSpinBox		*m_spacing	;

	RKComboBox		*m_valign	;
	RKComboBox		*m_halign	;

	RKComboBox		*m_overflow	;

	bool			m_pid		;
	uint			m_mask		;
	bool			m_locked	;

	QSpinBox		*makeSpinBox	(uint, const QString &, RKGridBox *, int, int)	;
	RKComboBox		*makeComboBox	(uint, const QString &, RKGridBox *)		;

	void			saveSpinBox	(QSpinBox *, int &) ;

protected slots :

	void			manageChanged	() ;
	void			fillParent	() ;

public	:

	KBAttrGeomDlg		(QWidget *, KBAttrGeom *, KBAttrGeomItem *, QDict<KBAttrItem> &) ;

	virtual	bool		init		(const QString &) ;
	virtual	bool		init		() ;
	virtual	void		save		() ;
	virtual QString		value		() ;
}	;


#endif	// ! __KB_RUNTIME
#endif	// _KB_ATTRGEOMDLG_H
