/***************************************************************************
    file	         : kb_attrimage.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	"kb_classes.h"
#include	"kb_docroot.h"
#include	"kb_location.h"
#include	"kb_attrimage.h"

#if		! __KB_RUNTIME

#include	"kb_attrimagedlg.h"


/*  KBAttrImage								*/
/*  getAttrDlg	: Get dialog component for frame			*/
/*  parent	: QWidget *		: Parent widget			*/
/*  item	: KBAttrItem *		: Assicated item		*/
/*  attrDict	: QDict<KBAttrItem> &	: Attribute dictionary		*/
/*  (returns)	: KBAttrDlg *		: Actually KBAttrFrameDlg	*/

KBAttrDlg *KBAttrImage::getAttrDlg
	(	QWidget			*parent,
		KBAttrItem		*item,
		QDict<KBAttrItem>	&attrDict
	)
{
	return	new KBAttrImageDlg (parent, this, item, attrDict) ;
}

#endif

int	KBAttrImage::dummy ()
{
	return	0	;
}

/*  ------------------------------------------------------------------	*/

QPixmap	KBAttrImage::pixmapFromLocation
	(	KBDocRoot	*docRoot,
		const QString	&name,
		const QString	&extn,
		KBError		&pError
	)
{
	KBLocation location
	(	docRoot->getDBInfo(),
		"graphic",
		docRoot->getDocLocation().server(),
		name,
		extn
	)	;

	KBError	   error	;
	QByteArray data		;

	if (!location.contents (data, pError))
		return	QPixmap	() ;

	return	QPixmap	(data)	;
}

