/***************************************************************************
    file	         : kb_attrimage.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB__ATTRIMAGE_H
#define	_KB__ATTRIMAGE_H

#include	"libkbase_exports.h"
#include	"kb_attr.h"

#if		! __KB_RUNTIME
#include	"kb_attritem.h"
#endif

#include	<qpixmap.h>

class		KBDocRoot ;


/*  KBAttrImage								*/
/*  -----------								*/
/*  Special attribute class for the image in a graphic object. Used to	*/
/*  provide a customised property dialog component.			*/

class	LIBKBASE_API	KBAttrImage : public KBAttrStr
{
	class	KBAttrImageExtra
	{
	public	:

		uint		m_images	;
		cchar		**m_legends	;

		inline	KBAttrImageExtra ()
		{
			m_images	= 1	;
			m_legends	= 0	;
		}
	}	;

	KBAttrImageExtra	m_extra	;

public	:

	inline	void	setNumImages
		(	uint	images
		)
	{
		m_extra.m_images = images	;
	}
	inline	uint	numImages ()
	{
		return	m_extra.m_images	;
	}

	inline	void	setLegends
		(	cchar	**legends
		)
	{
		m_extra.m_legends = legends	;
	}
	inline	cchar	**legends ()
	{
		return	m_extra.m_legends	;
	}

	KBATTRCTRDEF (KBAttrImage, KBAttrStr)
	KBATTRDLGDEF

	static	QPixmap	pixmapFromLocation
			(	KBDocRoot	*,
				const QString	&,
				const QString	&,
				KBError		&
			)	;
}	;

#endif	// _KB__ATTRIMAGE_H
