/***************************************************************************
    file	         : kb_attrimagedlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_ATTRTIMAGEDLG_H
#define	_KB_ATTRTIMAGEDLG_H

#if	! __KB_RUNTIME

#include	"libkbase_exports.h"

#include	"kb_classes.h"
#include	"kb_attrdlg.h"
#include	"kb_propdlg.h"
#include 	"kb_attrimage.h"

class	RKLineEdit	;
class	RKComboBox	;
class	QGroupBox	;
class	QLabel		;

/*  KBAttrImageDlgBase							*/
/*  ------------------							*/
/*  Base dialog component for selecting images, handles loading images	*/
/*  into the gallery.							*/

class	LIBKBASE_API	KBAttrImageBaseDlg : public KBAttrDlg
{
	Q_OBJECT

protected	:

	uint			m_count		;
	QPtrList<RKLineEdit  >	m_images	;
	QPtrList<RKComboBox  >	m_lists		;
	QPtrList<RKPushButton>	m_shows		;
	QGroupBox		*m_previewGroup	;
	QLabel			*m_previewImage	;

	void			makeSelectors	(RKBox *, uint, const char **) ;
	void			loadImageList	() ;
	void			previewImage	(const QString &) ;

protected slots :

	void			slotListActive	() ;
	void			slotPreview	() ;
	void			slotClickLoad	() ;

public	:

	KBAttrImageBaseDlg	(QWidget *, KBAttr *, KBAttrItem *, QDict<KBAttrItem> &) ;
}	;

/*  KBAttrImageDlg							*/
/*  --------------							*/
/*  DIalog component for selecting images, also handles loading images	*/
/*  into the gallery.							*/

class	LIBKBASE_API	KBAttrImageDlg : public KBAttrImageBaseDlg
{
	Q_OBJECT

public	:

	KBAttrImageDlg		(QWidget *, KBAttrImage *, KBAttrItem *, QDict<KBAttrItem> &) ;

	virtual	bool		init		(const QString &) ;
	virtual	QString		value		() ;
}	;


#endif	// ! __KB_RUNTIME
#endif	// _KB_ATTRIMAGEDLG_H
