/***************************************************************************
    file	         : kb_attrnoupdate.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	"kb_attrnoupdate.h"

#if		! __KB_RUNTIME

#include	"kb_attrnoupdatedlg.h"


/*  KBAttrNoupdate							*/
/*  getAttrDlg	: Get dialog component for noUpdate property		*/
/*  parent	: QWidget *		: Parent widget			*/
/*  item	: KBAttrItem *		: Associated item		*/
/*  attrDict	: QDict<KBAttrItem> &	: Attribute dictionary		*/
/*  (returns)	: KBAttrDlg *		: Actually KBAttrNoupdateDlg	*/

KBAttrDlg
	*KBAttrNoupdate::getAttrDlg
	(	QWidget			*parent,
		KBAttrItem		*item,
		QDict<KBAttrItem>	&attrDict
	)
{
	return	new KBAttrNoupdateDlg (parent, this, item, attrDict) ;
}

/*  KBAttrNoupdate							*/
/*  displayValue: Get display text for value				*/
/*  value	: const QString & : Actual value			*/
/*  (returns)	: QString	  : Display text for value		*/

QString	KBAttrNoupdate::displayValue
	(	const QString	&value
	)
{
	if (value == "No" ) return TR("Updates database"  	) ;
	if (value == "Yes") return TR("Does not update database") ;
	if (value == "Ver") return TR("Value verified only"	) ;
	return	TR(value) ;
}

#endif

uint	KBAttrNoupdate::getFlags ()
{
	QString	v = getValue() ;

	if (v == "No"	) return ANO_NO		;
	if (v == "Yes"	) return ANO_YES	;
	if (v == "Ver"	) return ANO_VERIFY	;
	return	ANO_NO ;
}


int	KBAttrNoupdate::dummy ()
{
	return	0	;
}
