/***************************************************************************
    file	         : kb_attrnuupdate.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_ATTRNOUPDATE_H
#define	__KB_ATTRNOUPDATE_H

#include	"libkbase_exports.h"
#include	"kb_attr.h"

#if		! __KB_RUNTIME
#include	"kb_attritem.h"
#endif


/*  KBAttrNoupdate							*/
/*  -------------							*/
/*  This class handles the no-update attribute. It maintains backward	*/
/*  compatability with earlier releases. Values	are:			*/
/*	0	- Default	: Normal update				*/
/*	1	- NoUpdate	: Control does not update database	*/
/*	2	- Validate Only	: No update but is validated		*/

class	LIBKBASE_API	KBAttrNoupdate : public KBAttrStr
{
public	:

	KBATTRCTRDEF (KBAttrNoupdate, KBAttrStr)
	KBATTRDLGDEF

	uint			getFlags	() ;

#if	! __KB_RUNTIME
	virtual	QString		displayValue	(const QString &) ;
#endif
}	;

#define	ANO_NO		0x00
#define	ANO_YES		0x01
#define	ANO_VERIFY	0x02

#endif	// __KB_ATTRNOUPDATE_H
