/***************************************************************************
    file	         : kb_attrnoupdatedlg.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/



#include	"rk_vbox.h"
#include	"rk_combobox.h"

#include	"kb_classes.h"
#include	"kb_attr.h"
#include	"kb_attrnoupdate.h"
#include	"kb_node.h"


#if		__KB_AUTOMOC
#include 	"kb_attrnoupdatedlg.moc"
#else
#include 	"kb_attrnoupdatedlg.h"
#endif





/*  KBAttrNoupdateDlg							*/
/*  KBAttrNoupdateDlg							*/
/*		: Constructor for noupdate dialog			*/
/*  parent	: QWidget *		: Parent widget			*/
/*  attr	: KBAttr *		: Associated attribute		*/
/*  item	: KBAttrItem *		: Associated item		*/
/*  attrDict	: QDict<KBAttrItem> &	: All attributes		*/
/*  (returns)	: KBAttrNoupdateDlg	:				*/

KBAttrNoupdateDlg::KBAttrNoupdateDlg
	(	QWidget			*parent,
		KBAttr			*attr,
		KBAttrItem		*item,
		QDict<KBAttrItem>	&attrDict
	)
	:
	KBAttrDlg	(parent, attr, item, attrDict)
{
	RKVBox	*layout	= new RKVBox (parent) ;
	setTopWidget (layout) ;

	m_noupdate = new RKComboBox  (layout) ;
	layout	 ->addFiller () ;

	m_noupdate->insertItem (TR("Updates database"        )) ;
	m_noupdate->insertItem (TR("Does not update database")) ;
	m_noupdate->insertItem (TR("Value verified only"     )) ;
}

/*  KBAttrNoupdateDlg							*/
/*  init	: Initialise for editing				*/
/*  value	: const QString & : Value				*/
/*  (returns)	: bool		: False, no modal dialog		*/

bool	KBAttrNoupdateDlg::init
	(	const QString	&value
	)
{
	int	c = 0 ;

	if	(value == "No" ) c = 0 ;
	else if (value == "Yes") c = 1 ;
	else if (value == "Ver") c = 2 ;

	m_noupdate->setCurrentItem (c) ;
	return	false	;
}

/*  KBAttrNoupdateDlg							*/
/*  value	: Get value						*/
/*  (returns)	: QString		:				*/

QString	KBAttrNoupdateDlg::value ()
{
	QString	v	= "No" ;

	switch (m_noupdate->currentItem())
	{
		case 1	: v = "Yes" ; break ;
		case 2	: v = "Ver" ; break ;
		default	:	      break ;
	}

	return	v ;
}
