/***************************************************************************
    file	         : kb_attrreadonly.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	"kb_attrreadonly.h"

#if		! __KB_RUNTIME

#include	"kb_attrreadonlydlg.h"


/*  KBAttrReadOnly							*/
/*  getAttrDlg	: Get dialog component for readonly property		*/
/*  parent	: QWidget *		: Parent widget			*/
/*  item	: KBAttrItem *		: Associated item		*/
/*  attrDict	: QDict<KBAttrItem> &	: Attribute dictionary		*/
/*  (returns)	: KBAttrDlg *		: Actually KBAttrReadOnlyDlg	*/

KBAttrDlg
	*KBAttrReadOnly::getAttrDlg
	(	QWidget			*parent,
		KBAttrItem		*item,
		QDict<KBAttrItem>	&attrDict
	)
{
	return	new KBAttrReadOnlyDlg (parent, this, item, attrDict) ;
}

/*  KBAttrReadOnly							*/
/*  displayValue: Get display text for value				*/
/*  value	: const QString & : Actual value			*/
/*  (returns)	: QString	  : Display text for value		*/

QString	KBAttrReadOnly::displayValue
	(	const QString	&value
	)
{
	if (value == "No"  ) return TR("Control can be updated"  ) ;
	if (value == "Yes" ) return TR("User cannot change value") ;
	if (value == "Lock") return TR("Value is locked"	 ) ;
	return	TR(value) ;
}

#endif

uint	KBAttrReadOnly::getFlags ()
{
	QString	v = getValue() ;

	if (v == "No"	) return ARO_NO		;
	if (v == "Yes"	) return ARO_YES	;
	if (v == "Lock"	) return ARO_LOCKED	;
	return	ARO_NO ;
}


int	KBAttrReadOnly::dummy ()
{
	return	0	;
}
