/***************************************************************************
    file	         : kb_attrreadonly.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_ATTRREADONLY_H
#define	__KB_ATTRREADONLY_H

#include	"libkbase_exports.h"
#include	"kb_attr.h"

#if		! __KB_RUNTIME
#include	"kb_attritem.h"
#endif


/*  KBAttrReadOnly							*/
/*  -------------							*/
/*  This class handles the read-only attribute. It maintains backward	*/
/*  compatability with earlier releases. Values	are:			*/
/*	0	- Default	: Normal case				*/
/*	1	- ReadOnly	: User cannot change control		*/
/*	2	- Locked	: No user or script update		*/

class	LIBKBASE_API	KBAttrReadOnly : public KBAttrStr
{
public	:

	KBATTRCTRDEF (KBAttrReadOnly, KBAttrStr)
	KBATTRDLGDEF

	uint			getFlags	() ;

#if	! __KB_RUNTIME
	virtual	QString		displayValue	(const QString &) ;
#endif
}	;

#define	ARO_NO		0x00
#define	ARO_YES		0x01
#define	ARO_LOCKED	0x02

#endif	// __KB_ATTRREADONLY_H
