/***************************************************************************
    file	         : kb_attrreadonlydlg.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/



#include	"rk_vbox.h"
#include	"rk_combobox.h"

#include	"kb_classes.h"
#include	"kb_attr.h"
#include	"kb_attrreadonly.h"
#include	"kb_node.h"


#if		__KB_AUTOMOC
#include 	"kb_attrreadonlydlg.moc"
#else
#include 	"kb_attrreadonlydlg.h"
#endif





/*  KBAttrReadOnlyDlg							*/
/*  KBAttrReadOnlyDlg							*/
/*		: Constructor for readonly dialog			*/
/*  parent	: QWidget *		: Parent widget			*/
/*  attr	: KBAttr *		: Associated attribute		*/
/*  item	: KBAttrItem *		: Associated item		*/
/*  attrDict	: QDict<KBAttrItem> &	: All attributes		*/
/*  (returns)	: KBAttrReadOnlyDlg	:				*/

KBAttrReadOnlyDlg::KBAttrReadOnlyDlg
	(	QWidget			*parent,
		KBAttr			*attr,
		KBAttrItem		*item,
		QDict<KBAttrItem>	&attrDict
	)
	:
	KBAttrDlg	(parent, attr, item, attrDict)
{
	RKVBox	*layout	= new RKVBox (parent) ;
	setTopWidget (layout) ;

	m_readonly = new RKComboBox  (layout) ;
	layout	 ->addFiller () ;

	m_readonly->insertItem ("Control can be updated"  ) ;
	m_readonly->insertItem ("User cannot change value") ;
	m_readonly->insertItem ("Value is locked"	  ) ;
}

/*  KBAttrReadOnlyDlg							*/
/*  init	: Initialise for editing				*/
/*  value	: const QString & : Value				*/
/*  (returns)	: bool		: False, no modal dialog		*/

bool	KBAttrReadOnlyDlg::init
	(	const QString	&value
	)
{
	int	c = 0 ;

	if	(value == "No"  ) c = 0 ;
	else if (value == "Yes" ) c = 1 ;
	else if (value == "Lock") c = 2 ;

	m_readonly->setCurrentItem (c) ;
	return	false	;
}

/*  KBAttrReadOnlyDlg							*/
/*  value	: Get value						*/
/*  (returns)	: QString		:				*/

QString	KBAttrReadOnlyDlg::value ()
{
	QString	v	= "No" ;

	switch (m_readonly->currentItem())
	{
		case 1	: v = "Yes"  ; break ;
		case 2	: v = "Lock" ; break ;
		default	:	       break ;
	}

	return	v ;
}
