/***************************************************************************
    file	         : kb_attrserverdlg.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/



#include	"rk_vbox.h"
#include	"rk_combobox.h"

#include	"kb_classes.h"
#include	"kb_attr.h"
#include	"kb_node.h"
#include	"kb_docroot.h"
#include	"kb_dbinfo.h"

#if		__KB_AUTOMOC
#include 	"kb_attrserverdlg.moc"
#else
#include 	"kb_attrserverdlg.h"
#endif


/*  KBAttrServerDlg							*/
/*  KBAttrServerDlg							*/
/*		: Constructor for alignment dialog			*/
/*  parent	: QWidget *		: Parent widget			*/
/*  attr	: KBAttr *		: Associated attribute		*/
/*  item	: KBAttrItem *		: Associated item		*/
/*  attrDict	: QDict<KBAttrItem> &	: Attribute dictionary		*/	
/*  (returns)	: KBAttrServerDlg:					*/

KBAttrServerDlg::KBAttrServerDlg
	(	QWidget			*parent,
		KBAttr			*attr,
		KBAttrItem		*item,
		QDict<KBAttrItem>	&attrDict
	)
	:
	KBAttrDlg	(parent, attr, item, attrDict)
{
	RKVBox	*layout	= new RKVBox	(parent) ;
	setTopWidget (layout) ;

	m_server	= new RKComboBox(layout) ;
	layout->addFiller () ;


	KBNode	    *node	= m_item->attr()->getOwner() ;


	const KBLocation &locn	 = node->getDocRoot()->getDocLocation() ;
	KBDBInfo	 *dbInfo = node->getDocRoot()->getDBInfo     () ;
	KBServerInfo	 *self	 = dbInfo->findServer (locn.server () ) ;
	KBServerInfo	 *files	 = dbInfo->findServer (KBLocation::m_pFile) ;

	if (!self ->dbType().isEmpty()) m_server->insertItem ("Self") ;
	if (!files->dbType().isEmpty()) m_server->insertItem (KBLocation::m_pFile) ;

	QPtrListIterator<KBServerInfo>
			*svIter = dbInfo->getServerIter() ;
	KBServerInfo	*svInfo	;
	QString		text	;

	while ((svInfo = svIter->current()) != 0)
	{
		m_server->insertItem (svInfo->serverName()) ;
		(*svIter) += 1 ;
	}

	delete	svIter	;
}

/*  KBAttrServerDlg							*/
/*  init	: Initialise for editing				*/
/*  value	: const QString & : Value				*/
/*  (returns)	: bool		  : Always false, no modal dialog	*/

bool	KBAttrServerDlg::init
	(	const QString	&value
	)
{
	for (int idx = 0 ; idx < m_server->count() ; idx += 1)
		if (m_server->text(idx) == value)
		{	m_server->setCurrentItem (idx) ;
			break	;
		}

	return	false	;
}

/*  KBAttrServerDlg							*/
/*  value	: Get value						*/
/*  (returns)	: void		:					*/

QString	KBAttrServerDlg::value ()
{
	return	m_server->currentText() ;
}

