/***************************************************************************
    file	         : kb_attrstretch.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	"kb_attrstretch.h"

#if		! __KB_RUNTIME

#include	"kb_attrstretchdlg.h"


/*  KBAttrStretch							*/
/*  getAttrDlg	: Get dialog component for navigation			*/
/*  parent	: QWidget *		: Parent widget			*/
/*  item	: KBAttrItem *		: Associated item		*/
/*  attrDict	: QDict<KBAttrItem> &	: Attribute dictionary		*/
/*  (returns)	: KBAttrDlg *		: Actually KBAttrStretchDlg	*/

KBAttrDlg
	*KBAttrStretch::getAttrDlg
	(	QWidget			*parent,
		KBAttrItem		*item,
		QDict<KBAttrItem>	&attrDict
	)
{
	return	new KBAttrStretchDlg (parent, this, item, attrDict) ;
}

/*  KBAttrStretch							*/
/*  displayValue: Get display text for value				*/
/*  value	: const QString & : Actual value			*/
/*  (returns)	: QString	  : Display text for value		*/

QString	KBAttrStretch::displayValue
	(	const QString	&value
	)
{
	if (value == "No" ) return TR("Fixed layout: minimum size enforced"  ) ;
	if (value == "Yes") return TR("Stretch layout: minimum size enforced") ;
	if (value == "Any") return TR("Fixed layout: no minimum size"	     ) ;
	return	TR(value) ;
}

#endif

uint	KBAttrStretch::getFlags ()
{
	QString	v = getValue() ;

	if (v == "No"	) return STR_FIXED	;
	if (v == "Yes"	) return STR_STRETCH	;
	if (v == "Any"	) return STR_ANY	;
	if (v == "Grid"	) return STR_GRID	;
	return	0 ;
}


int	KBAttrStretch::dummy ()
{
	return	0	;
}
