/***************************************************************************
    file	         : kb_attrstretch.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_ATTRSTRETCH_H
#define	__KB_ATTRSTRETCH_H

#include	"libkbase_exports.h"
#include	"kb_attr.h"

#if		! __KB_RUNTIME
#include	"kb_attritem.h"
#endif


/*  KBAttrStretch							*/
/*  -------------							*/
/*  This class handles form stretch mode. It maintains backward		*/
/*  compatability with earlier releases. Values	are:			*/
/*	0	- No stretch: form minimum size enforced		*/
/*	1	- Stretch   : form minimum size enforced		*/
/*	2	- No stretch: no minimum form size			*/

class	LIBKBASE_API	KBAttrStretch : public KBAttrStr
{
public	:

	KBATTRCTRDEF (KBAttrStretch, KBAttrStr)
	KBATTRDLGDEF

	uint			getFlags () ;

#if	! __KB_RUNTIME
	virtual	QString		displayValue	(const QString &) ;
#endif
}	;

#define	STR_FIXED	0x00
#define	STR_STRETCH	0x01
#define	STR_ANY		0x02
#define	STR_GRID	0xff

#endif	// __KB_ATTRSTRETCH_H
