/***************************************************************************
    file	         : kb_attrnavdlg.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/



#include	"rk_vbox.h"
#include	"rk_combobox.h"

#include	"kb_classes.h"
#include	"kb_attr.h"
#include	"kb_attrstretch.h"
#include	"kb_node.h"


#if		__KB_AUTOMOC
#include 	"kb_attrstretchdlg.moc"
#else
#include 	"kb_attrstretchdlg.h"
#endif





/*  KBAttrStretchDlg							*/
/*  KBAttrStretchDlg							*/
/*		: Constructor for stretch dialog			*/
/*  parent	: QWidget *		: Parent widget			*/
/*  attr	: KBAttr *		: Associated attribute		*/
/*  item	: KBAttrItem *		: Associated item		*/
/*  attrDict	: QDict<KBAttrItem> &	: All attributes		*/
/*  (returns)	: KBAttrStretchDlg	:				*/

KBAttrStretchDlg::KBAttrStretchDlg
	(	QWidget			*parent,
		KBAttr			*attr,
		KBAttrItem		*item,
		QDict<KBAttrItem>	&attrDict
	)
	:
	KBAttrDlg	(parent, attr, item, attrDict)
{
	RKVBox	*layout	= new RKVBox (parent) ;
	setTopWidget (layout) ;

	m_stretch = new RKComboBox(layout) ;
	layout	 ->addFiller ()		 ;

	m_stretch->insertItem(TR("Fixed layout: minimum size enforced"  )) ;
	m_stretch->insertItem(TR("Stretch layout: minimum size enforced")) ;
	m_stretch->insertItem(TR("Fixed layout: no minimum size"        )) ;
}

/*  KBAttrStretchDlg							*/
/*  init	: Initialise for editing				*/
/*  value	: const QString & : Value				*/
/*  (returns)	: bool		: False, no modal dialog		*/

bool	KBAttrStretchDlg::init
	(	const QString	&value
	)
{
	int	c = 0 ;

	if	(value == "No" ) c = 0 ;
	else if (value == "Yes") c = 1 ;
	else if (value == "Any") c = 2 ;

	m_stretch->setCurrentItem (c) ;
	return	false	;
}

/*  KBAttrStretchDlg							*/
/*  value	: Get value						*/
/*  (returns)	: QString		:					*/

QString	KBAttrStretchDlg::value ()
{
	QString	v	= "No" ;

	switch (m_stretch->currentItem())
	{
		case 1	: v = "Yes" ; break ;
		case 2	: v = "Any" ; break ;
		default	:	      break ;
	}

	return	v ;
}
