/***************************************************************************
    file	         : kb_attrvalidator.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	"kb_attrvalidator.h"
#include	"kb_item.h"


#if		! __KB_RUNTIME

#include	"kb_attrvalidatordlg.h"

/*  KBAttrValidator							*/
/*  getAttrDlg	: Get dialog component for validator selection		*/
/*  parent	: QWidget *		: Parent widget			*/
/*  item	: KBAttrItem *		: Associated item		*/
/*  attrDict	: QDict<KBAttrItem> &	: Attribute dictionary		*/
/*  (returns)	: KBAttrDlg *		: Actually KBAttrValidatorDlg	*/

KBAttrDlg
	*KBAttrValidator::getAttrDlg
	(	QWidget			*parent,
		KBAttrItem		*item,
		QDict<KBAttrItem>	&attrDict
	)
{
	return	new KBAttrValidatorDlg (parent, this, item, attrDict) ;
}

/*  KBAttrStretch							*/
/*  displayValue: Get display text for value				*/
/*  value	: const QString & : Actual value			*/
/*  (returns)	: QString	  : Display text for value		*/

QString	KBAttrValidator::displayValue
	(	const QString	&value
	)
{
	QStringList	bits	= QStringList::split(";", value) ;
	QStringList	display	;

	switch (bits[0].toInt())
	{
		case KBItem::VFNone	:
			display.append (TR("None")) ;
			break	;

		case KBItem::VFShow	:
			display.append (TR("Show always")) ;
			break	;

		case KBItem::VFBlank	:
			display.append (TR("Reserve space")) ;
			break	;

		case KBItem::VFAutoShow	:
			display.append (TR("Show if required")) ;
			break	;

		case KBItem::VFAutoBlank:
			display.append (TR("Show if required else reserve space")) ;
			break	;

		default	:
			return	QString::null	;

	}

	if (bits.count() > 1)
	{
		display.append	(bits[1]) ;
		display.append	(bits[2]) ;
	}

	return	display.join ("; ") ;
}

#endif

int	KBAttrValidator::dummy ()
{
	return	0	;
}

int	KBAttrValidator::validatorMode
	(	QString		&graphicGood,
		QString		&graphicBad
	)
{
	QStringList bits = QStringList::split(";", getValue()) ;

	if (bits.count() >= 3) graphicBad  = bits[2] ;
	if (bits.count() >= 2) graphicGood = bits[1] ;

	return	bits.count() >= 1 ? bits[0].toInt() : 0	;
}
