/***************************************************************************
    file	         : kb_attrvalidatordlg.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/



#include	"rk_vbox.h"
#include	"rk_hbox.h"
#include	"rk_lineedit.h"
#include	"rk_combobox.h"
#include	"rk_pushbutton.h"

#include	"kb_classes.h"
#include	"kb_attr.h"
#include	"kb_node.h"
#include	"kb_docroot.h"
#include	"kb_dbinfo.h"
#include	"kb_dbdociter.h"
#include	"kb_attrvalidator.h"

#if		__KB_AUTOMOC
#include 	"kb_attrvalidatordlg.moc"
#else
#include 	"kb_attrvalidatordlg.h"
#endif


/*  KBAttrValidatorDlg							*/
/*  KBAttrValidatorDlg							*/
/*		: Constructor for validator dialog			*/
/*  parent	: QWidget *		: Parent widget			*/
/*  attr	: KBAttr *		: Associated attribute		*/
/*  item	: KBAttrItem *		: Associated item		*/
/*  attrDict	: QDict<KBAttrItem> &	: Attribute dictionary		*/	
/*  (returns)	: KBAttrValidatorDlg:					*/

KBAttrValidatorDlg::KBAttrValidatorDlg
	(	QWidget			*parent,
		KBAttr			*attr,
		KBAttrItem		*item,
		QDict<KBAttrItem>	&attrDict
	)
	:
	KBAttrImageBaseDlg (parent, attr, item, attrDict)
{
	RKVBox	*layMain = new RKVBox	(parent ) ;
	setTopWidget (layMain) ;

	RKHBox	*layHelp = new RKHBox	    (layMain) ;
	m_validator	 = new RKComboBox   (layHelp) ;

	extern	QStringList *getvalidatorSet() ;
	m_validator->clear		() ;
	m_validator->insertItem		("None"			) ;
	m_validator->insertItem		("Show always"		) ;
	m_validator->insertItem		("Reserve space"	) ;
	m_validator->insertItem		("Show if required"	) ;
	m_validator->insertItem		("Show if required else reserve space"	) ;

	static	const char *legends [] =
	{	"Value OK",
		"Value invalid"
	}	;

	makeSelectors	(layMain, 2, legends) ;

	layMain->addFiller () ;
}

/*  KBAttrValidatorDlg							*/
/*  init	: Initialise for editing				*/
/*  value	: const QString & : Value				*/
/*  (returns)	: bool		  : Always false, no modal dialog	*/

bool	KBAttrValidatorDlg::init
	(	const QString	&value
	)
{
	QStringList bits = QStringList::split (';', value) ;
	while (bits.size() < m_count + 1) bits.append (QString::null) ;

	m_validator->setCurrentItem (bits[0].toInt()) ;

	loadImageList() ;

	for (uint idx1 = 0 ; idx1 < m_count ; idx1 += 1)
	{
		QString	name = bits[idx1 + 1] ;
		m_images.at(idx1)->setText	  (name) ;
		m_lists .at(idx1)->setCurrentText (name) ;
	}

	return	false	;
}

/*  KBAttrValidatorDlg							*/
/*  value	: Get value						*/
/*  (returns)	: void		:					*/

QString	KBAttrValidatorDlg::value ()
{
	QStringList list ;

	list.append (QString::number(m_validator->currentItem())) ;

	for (uint idx = 0 ; idx < m_count ; idx += 1)
		list.append (m_images.at(idx)->text()) ;

	return	list.join (";") ;
}

