/***************************************************************************
    file	         : kb_button.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_BUTTON_H
#define		__KB_BUTTON_H

#include 	"libkbase_exports.h"

#include	"kb_object.h"
#include	"kb_qtbutton.h"
#include	"kb_attrimage.h"

class	KBPopupMenu	;

/*  KBButton								*/
/*  ------------							*/
/*  This class is used for XML parse tree elements corresponding to	*/
/*  simple push-buttons.						*/

class	LIBKBASE_API	KBButton : public KBObject
{
	Q_OBJECT

	KBAttrStr		m_fgcolor	;
	KBAttrStr		m_bgcolor	;
	KBAttrStr		m_font		;
	KBAttrStr		m_text		;
	KBAttrImage		m_image		;
	KBAttrUInt		m_tabOrd 	;
	KBAttrBool		m_toggle	;
	KBEvent			m_onClick	;
	KBEvent			m_onToggle	;
	KBAttrStr		m_toolTip	;

	KBCtrlButton		*m_button	;
	bool			m_disable	;
	KBScriptCode		*m_code		;
	
	QPixmap			loadImage	(const QString &) ;


public slots :

	void			clicked 	()	;
	void			toggled 	(bool)	;
	void			recordVerifyText()	;

public	:

#if	! __KB_RUNTIME
	virtual	bool		propertyDlg	(cchar *) ;
	virtual void		makeRecordPopup	(KBPopupMenu *, uint, bool) ;
#endif
	virtual	void		buildDisplay	(KBDisplay *) ;
	virtual	KBNode		*replicate	(KBNode    *) ;
	virtual	void		showAs		(KB::ShowAs ) ;

	virtual	bool		keyStroke	(QKeyEvent *) ;
	virtual	void		setTabOrder	(int )	;
	virtual	int		getTabOrder	()     	;

	bool			loadPixmaps	()	;
	bool			setPixmaps	(const QString &, const QString &) ;

	bool			isOn		()	;
	void			setOn		(bool)	;

	void			setToolTip	(const QString	&tip ) ;
	void			setText		(const QString	&text) ;
	QString			getText		()	;
	bool			getToggle	()	;

	virtual	void		enumKBProperty	(QStringList	  	&) ;
	virtual	bool		hasKBProperty	(cchar *)		   ;
	virtual	bool		getKBProperty	(cchar *,	KBValue &) ;
	virtual	bool		setKBProperty	(cchar *, const KBValue &) ;

	KBButton				(KBNode  *, const QDict<QString> &, bool * = 0) ;
	KBButton				(KBNode  *, KBButton *) ;
	virtual	~KBButton			()	;
}	;

#endif		// __KB_BUTTON_H
