/***************************************************************************
    file	         : kb_check.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_CHECK_H
#define		__KB_CHECK_H

#include 	"libkbase_exports.h"

#include	<qcheckbox.h>

#include	"kb_classes.h"
#include	"kb_node.h"
#include	"kb_item.h"



/*  KBCheck								*/
/*  -------								*/
/*  This class is used to represent a KBaseCheck element in the XML	*/
/*  form description. Note that it may map onto more than one actual	*/
/*  field.								*/

class	LIBKBASE_API	KBCheck : public KBItem
{
	Q_OBJECT

	KBAttrStr		m_fgcolor	;
	KBAttrStr		m_bgcolor	;
	KBAttrBool		m_nullIsZero	;
	KBEvent			m_onChange	;

protected :

	virtual	KBControl 	*makeCtrl	(uint) ;

public	:

#if	! __KB_RUNTIME
	virtual	bool		propertyDlg	(cchar * ) ;
#endif

	virtual	KBNode		*replicate 	(KBNode *) ;
	bool			isChecked	(uint	 ) ;
	void			setChecked	(uint, bool) ;
	virtual	KBValue		getValue	(uint) ;

	KBCheck					(KBNode  *, const QDict<QString> &, bool * = 0) ;
	KBCheck 				(KBNode  *, KBCheck *) ;
	virtual	~KBCheck			() ;
}	;

#endif		// __KB_CHECK_H
