/***************************************************************************
    file	         : kb_choice.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_CHOICE_H
#define	_KB_CHOICE_H

#include 	"libkbase_exports.h"

#include	<qdict.h>
#include	<qstringlist.h>

#include	"kb_classes.h"
#include	"kb_item.h"
#include	"kb_attrgeom.h"


/*  KBChoice								*/
/*  --------								*/
/*  This class is used to represent a KBaseChoice element in the XML	*/
/*  form description. Note that it may map onto more than one actual	*/
/*  field.								*/

class	LIBKBASE_API	KBChoice : public KBItem
{
	Q_OBJECT

	KBAttrStr		m_values	;
	KBAttrStr		m_nullval	;
	KBAttrBool		m_nullOK	;
	KBAttrBool		m_noblank	;
	KBAttrBool		m_editable	;
	KBAttrStr		m_fgcolor	;
	KBAttrStr		m_bgcolor	;
	KBAttrStr		m_font		;
	KBAttrBool		m_morph		;
	KBEvent			m_onChange	;

	QStringList		m_valset	;

	void			loadValues	() ;

protected slots :

	void			recordVerifyChoices	()	;

protected :

	virtual	KBControl	*makeCtrl	(uint)	  ;

public	:

#if	! __KB_RUNTIME
	virtual	bool		propertyDlg	(cchar *) ;
#endif
	virtual	KBNode		*replicate	(KBNode *     ) ;
	virtual	void		showAs		(KB::ShowAs   ) ;
	virtual	bool		keyStroke	(QKeyEvent   *) ;
	virtual bool		checkValid	(const KBValue &, bool) ;

	void			setValues	(const QStringList   &) ;
	bool			canEdit		() ;
	const	QStringList	&getValues	() ;
	uint			getNumValues	() ;

	void			setCurrentItem	(uint, uint) ;
	uint			currentItem	(uint)	     ;

	virtual	bool		isMorphing	() ;
	virtual	void		doSearch	() ;
	virtual	bool		canBeInvalid	() ;

#if	! __KB_RUNTIME
	virtual void		makeRecordPopup	(KBPopupMenu *, uint, bool) ;
#endif

	KBChoice				(KBNode  *, const QDict<QString> &, bool * = 0) ;
	KBChoice				(KBNode  *, KBChoice *) ;
	virtual	~KBChoice			() ;
}	;


#if	! __KB_RUNTIME
extern LIBKBASE_API	bool	choicePropDlg
			(	KBChoice	*,
				cchar		*,
				QPtrList<KBAttr>	&,
				cchar		* = 0
			)	;
#endif
#endif	// _KB_CHOICE_H
