/***************************************************************************
    file	         : kb_listwidget.h
    copyright            : (C) 1999,2000,2001,2002,2003,2004 by Mike Richardson
			   (C) 2001,2002,2003,2004 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_COMBOWIDGET
#define	__KB_COMBOWIDGET

#include	"libkbase_exports.h"

#include	<qwidget.h>
#include	<qptrlist.h>
#include	<qpixmap.h>

class	RKComboBox	;
class	QWidgetStack	;

/*  KBComboWidget							*/
/*  -------------							*/
/*  This class is like a tab widget, but uses a combo box in place of	*/
/*  the tab bar.							*/

class	LIBKBASE_API	KBComboWidget : public QWidget
{
	Q_OBJECT

	RKComboBox		*m_combo	;
	QWidgetStack		*m_stack	;
	QPtrList<QWidget>	m_pages		;

signals	:

	void		currentChanged	(QWidget *) ;

protected slots :

	void		slotChangePage	(int) ;

public	:

	KBComboWidget		(QWidget *)		;

	void	addPage		(QWidget *, const QString &, const QPixmap &) ;
	void	addTab		(QWidget *, const QString &, const QPixmap & = QPixmap()) ;
	void	setCurrentPage	(const QString &)	;
	QWidget	*visibleWidget	()			;
}	;

#endif	// __KB_COMBOWIDGET
