/***************************************************************************
    file	         : kb_componentdlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_COMPONENTDLG_H
#define	_KB_COMPONENTDLG_H


#include	"libkbase_exports.h"

#include	"kb_propdlg.h"
#include	"kb_script.h"
#include	"kb_import.h"


class	KBParamDlg	;
class	KBComponent	;


/*  KBComponentPropDlg							*/
/*  ----------------							*/
/*  Properties dialog for component objects.				*/

class	LIBKBASE_API	KBComponentPropDlg : public KBPropDlg
{
	Q_OBJECT

	KBParamDlg	*m_paramDlg 	;
	KBComponent	*m_root		;

protected :

	virtual KBAttrItem	*getAttrItem	(KBAttr *) ;
	virtual	bool		hideProperty	(KBAttr *) ;
	virtual	bool		showProperty	(KBAttrItem *) ;
	virtual	bool		saveProperty	(KBAttrItem *) ;
	virtual	void		preExec		() ;

protected slots :

	virtual	void		clickOK		() ;

public	:

	KBComponentPropDlg
	(	KBComponent	*,
		cchar 		*,
		QPtrList<KBAttr  > &,
		QPtrList<KBParam > &,
		cchar		* = 0
	)	;
       ~KBComponentPropDlg () ;
}	;

#endif	// _KB_COMPONENTDLG_H
