/***************************************************************************
    file	         : kb_configdlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_CONFIGDLG_H
#define	_KB_CONFIGDLG_H

#if	! __KB_RUNTIME

#include	"rk_listview.h"

#include	"libkbase_exports.h"

#include	"kb_param.h"
#include	"kb_config.h"
#include	"kb_dialog.h"
#include	"kb_paramsetdlg.h"

#include	"rk_vbox.h"

class		QWidgetStack	;
class		QCheckBox	;

class		RKLineEdit	;
class		RKComboBox	;
class		RKPushButton	;

/*  KBConfigItem							*/
/*  -----------								*/
/*  This is a wrapper round a list view item, used to store the		*/
/*  properties of a configuration item which is being edited.		*/

class	LIBKBASE_API KBConfigItem : public QListViewItem
{
	bool		m_user		;
	bool		m_required	;
	bool		m_hidden	;

	void		showFlags  ()	;

public	:

	KBConfigItem
	(	RKListView 	*,
		KBConfig	*
	)	;

	KBConfigItem
	(	RKListView	*,
		const QString	&,
		const QString	&,
		const QString	&,
		bool		,
		bool		,
		bool
	) ;

        virtual ~KBConfigItem () ;

	KBConfig	*getConfig  (KBNode *, uint) ;

	inline	bool	user     ()
	{
		return	m_user	    ;
	}
	inline	bool	required ()
	{
		return	m_required  ;
	}
	inline	bool	hidden   ()
	{
		return	m_hidden    ;
	}
}	;



/*  KBConfigDlg								*/
/*  ----------								*/
/*  This class is used as a component in property dialogs to handle	*/
/*  editing of configuration objects.					*/

class	LIBKBASE_API KBConfigDlg : public RKVBox
{
	Q_OBJECT

	KBNode		*m_node		;

	QWidgetStack	*m_attrStack	;
	RKLineEdit	*m_eAttrib	;
	RKComboBox	*m_cbAttrib	;
	RKLineEdit	*m_eValue	;
	RKLineEdit	*m_eLegend	;

	QCheckBox	*m_cUser	;
	QCheckBox	*m_cRequired	;
	QCheckBox	*m_cHidden	;

	RKPushButton	*m_bAdd		;
	RKPushButton	*m_bRemove	;
	RKPushButton	*m_bEdit	;

	RKListView	*m_lvConfigs	;

	KBConfigItem	*m_curItem	;
	KBConfigItem	*m_editItem	;
	uint		m_ident		;

protected slots :

	void		clickAdd	() ;
	void		clickRemove	() ;
	void		clickEdit	() ;
	void		userChanged	() ;
	void		selectionChanged(QListViewItem *) ;

public	:

	KBConfigDlg	(QWidget *, KBNode *) ;
	~KBConfigDlg	() ;

	void		fixUp		() ;
	QString		getText		() ;
}	;


#endif
#endif	// _KB_CONFIGDLG_H
