/***************************************************************************
    file	         : kb_cookie.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/



#include	"kb_classes.h"
#include	"kb_cookie.h"


#define		__DEBUG_COOKIE	(0)
#if		__DEBUG_COOKIE
#include	"kb_dprintf.h"
#endif


/*  KBCookieJar								*/
/*  setCookie	: Set a cookie						*/
/*  cookie	: cchar *	: Cookie name				*/
/*  value	: cchar *	: Cookie value				*/
/*  (returns)	: void		:					*/

void	KBCookieJar::setCookie
	(	cchar 		*cookie,
		cchar		*value
	)
{
	DPRINTF
	((	"KBCookieJar::setCookie: [%s]<-[%s]\n",
		cookie,
		value
	))	;
	m_cookies.replace (cookie, new QCString(value)) ;
}

/*  KBCookieJar								*/
/*  getCookie	: Get a cookie						*/
/*  cookie	: cchar *	: Cookie name				*/
/*  (returns)	: cchar *	: Cookie value or null on error		*/

cchar	*KBCookieJar::getCookie
	(	cchar 		*cookie
	)
{
	const QCString *value = m_cookies.find(cookie)	;

	DPRINTF
	((	"KBCookieJar::getCookie: [%s]->[%s]\n",
		cookie,
		value == 0 ? "/NONE/" : value->data()
	))	;

	return	value == 0 ? 0 : value->data() ;
}

void	KBCookieJar::clear ()
{
	m_cookies.clear () ;
}


/*  KBCookieJar								*/
/*  jar		: Return dictionary of all cookies in the jar		*/
/*  (returns)	: const QAsciiDict<QCString> &				*/
/*				: Dictionary				*/

const QAsciiDict<QCString> &KBCookieJar::jar ()
{
	return	m_cookies ;
}

/*  KBCookieJar								*/
/*  self	: Instantiate singleton cookie jar object		*/
/*  (returns)	: KBCookieJar *	: Cookie jar				*/

KBCookieJar
	*KBCookieJar::self  ()
{
	static KBCookieJar *jar = 0 ;
	if (jar == 0) jar = new KBCookieJar ;
	return	jar ;
}


