/***************************************************************************
    file	         : kb_cookie.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef		__KB_COOKIE_H
#define		__KB_COOKIE_H

#include	"libkbase_exports.h"

#include	<qasciidict.h>
#include	<qcstring.h>

#include	"kb_classes.h"


/*  KBCookieJar								*/
/*  -----------								*/
/*  Trivial class used to store cookies, as a simple ASCII->ASCII	*/
/*  string mapping. This is really intended for use with RekallWeb,	*/
/*  when the cookies are copied back and forth between the server and	*/
/*  the client scripts.							*/

class	LIBKBASE_API	KBCookieJar
{
	QAsciiDict<QCString>	m_cookies	;

public	:

	void			setCookie	(cchar *, cchar *)	;
	cchar			*getCookie	(cchar *)		;
	void			clear		()			;

	const QAsciiDict<QCString>	&jar	()			;

	static	KBCookieJar		*self	()			;
}	;

#endif		//__KB_COOKIE_H
