/***************************************************************************
    file	         : kb_dbspecification.h
    copyright            : (C) 1999,2000,2001,2002,2003,2004 by Mike Richardson
			   (C) 2001,2002,2003,2004 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	__KB_DBSPECIFICATION_H
#define	__KB_DBSPECIFICATION_H

#include	<qdom.h>
#include	<qmap.h>
#include	<qstringlist.h>

#include	"libkbase_exports.h"
#include	"kb_classes.h"

/*  KBDBSpecification							*/
/*  -----------------							*/
/*  This class is used to parse and extract information from database	*/
/*  specification files, which are encoded in XML and contain details	*/
/*  of one or more stock databases.					*/

class	LIBKBASE_API	KBDBSpecification
{
	KBError				m_error		;
	QDomDocument			m_specification	;

	QMap<QString,QDomElement>	m_databases	;

	bool		init	()	;

public	:

	KBDBSpecification	()	;

	bool		loadText	(const QString &) ;
	bool		loadFile	(const QString &) ;
	QStringList	databases	()		  ;
	QString		description	(const QString &) ;
	QString		url		(const QString &) ;
	bool		asfiles		(const QString &) ;
	QStringList	validForDBs	(const QString &) ;

	inline	const	KBError	&lastError ()
	{
		return	m_error	;
	}
}	;

#endif	// __KB_DBSPECIFICATION_H
