/***************************************************************************
    file	         : kb_deleter.h
    copyright            : (C) 1999,2000,2001,2002,2003,2004 by Mike Richardson
			   (C) 2001,2002,2003,2004 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_DELETER_H
#define		__KB_DELETER_H

#include	<qobject.h>
#include	<qptrqueue.h>
#include	"libkbase_exports.h"


/*  KBDeleter								*/
/*  ---------								*/
/*  This class provides an asynchronous deleter for use where we want	*/
/*  an object to be able to (safely) delete itself.			*/

class	LIBKBASE_API	KBDeleter : public QObject
{
	Q_OBJECT

	QPtrQueue<QObject>	m_queue	;

	KBDeleter	() ;

private slots :

	void		slotDelete	() ;

private	:

	void		enqueueObject	(QObject *) ;

public	:

	static	void	addObject	(QObject *) ;
}	;

#endif		// __KB_DELETER_H
