/***************************************************************************
    file	         : kb_dialog.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_SUPPORT_H
#define	_KB_SUPPORT_H


#include 	"libkbase_exports.h"
#include	"rk_dialog.h"


class		RKPushButton	;
class		RKBox		;

/*  KBDialog								*/
/*  ---------								*/
/*  This class is a wrapper for RKDialog. It has additional support for	*/
/*  automating the addition of OK and Cancel buttons.			*/

class	LIBKBASE_API	KBDialog : public RKDialog
{
	Q_OBJECT

	QString		m_name		;
	QSize		m_lastSize	;

	void		init 		(const QString &, const char * = 0, const QSize & = QSize()) ;

protected :

	bool		m_showMaxed	;

	virtual	void	resizeEvent	(QResizeEvent *);

public	:

	KBDialog 	(QString, 	const char * = 0, const QSize & = QSize()) ;
	KBDialog 	(QString, bool, const char * = 0, const QSize & = QSize()) ;
       ~KBDialog	() ;

	virtual	void	show		() ;

	/* Static versions for use in dialogs (such as tabbed dialogs)	*/
	/* which are not derived from KBDialog.				*/
	static	void	setupLayout	(QWidget *)	 ;
	static	void	sameSize	(QWidget *, ...) ;

	static	void	addOKCancel
			(	RKBox		*,
				RKPushButton	** = 0,
				RKPushButton	** = 0,
				const char	*  = 0
			)	;

	static	int	marginHint	() ;
	static	int	spacingHint	() ;
}	;

#endif	// _KB_SUPPORT_H
