/***************************************************************************
    file	         : kb_draglist.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_DRAGBOX_H
#define	_KB_DRAGBOX_H

#include 	"libkbase_exports.h"

#include	"rk_listbox.h"

class		RKPushButton	;

/*  KBDragBox								*/
/*  ---------								*/
/*  This is a RKListBox extended so that entries can be reordered by	*/
/*  dragging.								*/

class	LIBKBASE_API	KBDragBox : public RKListBox
{
	Q_OBJECT

	int	  mouseDownAt	;
	int	  mouseUpAt	;

public	:

	KBDragBox (QWidget *, RKPushButton * = 0, RKPushButton * = 0)	;

protected :

	virtual	void	mousePressEvent   (QMouseEvent   *) ;
	virtual	void	mouseReleaseEvent (QMouseEvent   *) ;

protected slots :

	virtual	void	clickMoveUp	  () ;
	virtual	void	clickMoveDown	  () ;

signals :

	void	moved	(int, int) ;
}	;

#endif	// _KB_DRAGBOX_H
