/***************************************************************************
    file	         : kb_emitter.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	"kb_classes.h"
#include	"kb_attr.h"
#include	"kb_event.h"
#include	"kb_object.h"

#if		__KB_AUTOMOC
#include	"kb_emitter.moc"
#else
#include	"kb_emitter.h"
#endif

#define		__DEBUG_EMITTER	(0)
#if		__DEBUG_EMITTER
#include	"kb_dprintf.h"
#endif

/*  KBEmitter								*/
/*  KBEmitter	: Constructor for event signal emitter			*/
/*  parent	: KBObject *	: Parent object				*/
/*  event	: KBEvent  *	: Associated event			*/
/*  (returns)	: KBEmitter	:					*/
 
KBEmitter::KBEmitter
	(	KBObject	*parent,
		KBEvent		*event
	)
	:
	m_parent(parent),
	m_event	(event)
{
}

/*  KBEmitter								*/
/*  doSignal	: Emit an event signal					*/
/*  argc	: uint		  : Number of arguments			*/
/*  argv	: KBValue *	  : Vector of arguments			*/
/*  language	: int		  : 1->L1 2->L2 0->Any			*/
/*  (returns)	: KBScriptError * : Error or null if OK			*/

KBScriptError
	*KBEmitter::doSignal
	(	uint		argc,
		KBValue		*argv,
		int		language
	)
{
	DPRINTF
	((	"KBEmitter::doSignal: [%s/%s] [%d/%p] l=%d\n",
		(cchar *)m_parent->getAttrVal("name"),
		(cchar *)m_event ->getName(),
		argc,
		(void *)argv,
		language
	))	;

	KBScriptError	*rc = 0 ;

	emit	eventSignal
		(	m_parent,
			m_event->getName (),
			argc,
			argv,
			rc,
			language
		)	;

	return	rc	;
}
