/***************************************************************************
    file	         : kb_errordlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_ERRORDLG_H
#define	__KB_ERRORDLG_H


#include	"libkbase_exports.h"
#include	"kb_classes.h"
#include	"kb_dialog.h"

class	RKVBox		;
class	RKPushButton	;
class	QTextView	;
class	QComboBox	;
class	KBScriptError	;



/*  KBErrorDlg								*/
/*  ----------								*/
/*  Dialog class used to display errors. Has an extension, but does it	*/
/*  in house so that we don't get stuck with a fixed geometry when	*/
/*  extended.								*/

class 	LIBKBASE_API	KBErrorDlg : public KBDialog
{
	Q_OBJECT

	const KBError	&m_error	;
	cchar		*m_dFile	;
	uint		m_dLno		;

	QString		m_detailText	;

	RKVBox		*m_layout	;
	RKPushButton	*m_bDetails	;
	QTextView	*m_tDetails	;
	QComboBox	*m_cbWhich	;
	QSize		m_baseSize	;

protected slots :

	void	slotShowError	(int)	;
	void	slotShowDetails	(bool)	;

public	:

	KBErrorDlg
	(	const QString	&,
		const KBError	&,
		cchar		*,
		uint
	)	;

	~KBErrorDlg	()	;

	int	exec	()	;
}	;

class 	LIBKBASE_API	KBErrorBlock : public KBErrorBlockBase
{
	KBErrorBlock	*m_prior	;
	KBScriptError	*m_scriptError	;

public	:

	KBErrorBlock	(EBlock)	;
	~KBErrorBlock	()		;

	static	bool	processError	(KBScriptError *) ;
}	;

#endif	// __KB_ERRORDLG_H
