/***************************************************************************
    file	         : kb_execsql.cpp
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	<qregexp.h>

#include	"kb_classes.h"
#include	"kb_type.h"
#include	"kb_value.h"
#include	"kb_database.h"
#include	"kb_dblink.h"

#include	"libkbase_exports.h"



LIBKBASE_API
	KBSQLQuery	*executeSQLQuery
	(	KBDBLink		&dbLink,
		const QString		&query,
		bool			&ok,
		const KBValue		*argv,
		uint			argc
	)
{
	static	QRegExp *rxSelect ;
	static	QRegExp *rxUpdate ;
	static	QRegExp *rxInsert ;
	static	QRegExp *rxDelete ;

	if (rxSelect == 0)
	{
		rxSelect = new QRegExp  ("^select", 			 false) ;
		rxUpdate = new QRegExp  ("^update\\s+([^\\s]+)", 	 false) ;
		rxInsert = new QRegExp  ("^insert\\s+into\\s+([^\\s]+)", false) ;
		rxDelete = new QRegExp  ("^delete\\s+from\\s+([^\\s]+)", false) ;
	}

	if (rxSelect->search(query) >= 0)
	{
		KBSQLSelect *qrySelect = dbLink.qrySelect (true, query) ;
		ok	= qrySelect->execute (argc, argv) ;
		return	qrySelect ;
	}
	if (rxUpdate->search(query) >= 0)
	{
		KBSQLUpdate *qryUpdate = dbLink.qryUpdate (true, query, rxUpdate->cap(1)) ;
		ok	= qryUpdate->execute (argc, argv) ;
		return	qryUpdate ;
	}
	if (rxInsert->search(query) >= 0)
	{
		KBSQLInsert *qryInsert = dbLink.qryInsert (true, query, rxInsert->cap(1)) ;
		ok	= qryInsert->execute (argc, argv) ;
		return	qryInsert ;
	}
	if (rxDelete->search(query) >= 0)
	{
		KBSQLDelete *qryDelete = dbLink.qryDelete (true, query, rxDelete->cap(1)) ;
		ok	= qryDelete->execute (argc, argv) ;
		return	qryDelete ;
	}

	KBSQLSelect *qrySelect = 0 ;
	ok = dbLink.command (true, query, argc, (KBValue *)argv, &qrySelect) ;
	return	qrySelect ;
}

