/***************************************************************************
    file	         : kb_fixedlabel.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/



#include	<qfont.h>
#include	<qfontmetrics.h>

#include	"kb_classes.h"
#include	"kb_fixedlabel.h"

#define		EXTRA	(15)

#define		__DEBUG_FIXEDLABEL	(0)
#if		__DEBUG_FIXEDLABEL
#include	"kb_dprintf.h"
#endif


KBFixedLabel::KBFixedLabel
	(	uint		width,
		QWidget		*parent
		
	)
	:
	QLabel	(parent)
{
	DPRINTF
	((	"KBFixedLabel::KBFixedLabel: [%d]->[%d]\n",
		width,
		QFontMetrics(QFont()).width("123456789") * width / 10
	))	;
	setFixedWidth (QFontMetrics(QFont()).width("123456789") * width / 10 + EXTRA) ;
}

KBFixedLabel::KBFixedLabel
	(	const QString	&text,
		QWidget		*parent
	)
	:
	QLabel	(text, parent)
{
	DPRINTF
	((	"KBFixedLabel::KBFixedLabel: [%s]->[%d]\n",
		(const char *)text,
		QFontMetrics(QFont()).width(text)
	))	;
	setFixedWidth (QFontMetrics(QFont()).width(text) + EXTRA) ;
}

KBFixedLabel::KBFixedLabel
	(	const QStringList	&text,
		QWidget			*parent
	)
	:
	QLabel	(text[0], parent)
{
	int	maxw	= 0 ;
	for (uint idx = 0 ; idx < text.count() ; idx += 1)
	{	int w = QFontMetrics(QFont()).width(text[idx]) ;
		if (w > maxw) maxw = w ;
	}

	DPRINTF
	((	"KBFixedLabel::KBFixedLabel: [%s]->[%d]\n",
		text.join(":").latin1(),
		maxw
	))	;

	setFixedWidth (maxw + EXTRA) ;
}

