/***************************************************************************
    file	         : kb_formatdlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_FORMAT_H
#define	_KB_FORMAT_H


#include	"libkbase_exports.h"

#include	"kb_classes.h"
#include	"rk_vbox.h"

class	RKLineEdit	;
class	RKListBox	;
class	RKListView	;
class	QListViewItem	;
class	QCheckBox	;

struct	LIBKBASE_API	aFormat
{
	cchar	*descr	;
	cchar	*example;
	cchar	*format	;
}	;

/*  KBFormatDlg								*/
/*  -----------								*/
/*  This class contains the functionality needed to handle format	*/
/*  selection in a dialog box. It is used with, for instance, the Field	*/
/*  and Data control dialogs.						*/

class	LIBKBASE_API	KBFormatDlg : public RKVBox
{
	Q_OBJECT

	RKLineEdit	*m_eBox		;
	RKListBox	*m_types	;
	RKListView	*m_formats	;
	QCheckBox	*m_forced	;

	void		loadFormats 	(aFormat *) ;

private slots :

	void		selectType	(const QString &) ;
	void		selectFormat	(QListViewItem *) ;


public	:

	KBFormatDlg	(QWidget *) ;

	bool		showFormats	(const QString &, KB::IType) ;
	bool		showFormats	(const QString &, const QString &, KBQryBase *, uint) ;

	QString		getValue	() ;
}	;

LIBKBASE_API	struct	aFormat	*getDateFormat		() ;
LIBKBASE_API	struct	aFormat	*getTimeFormat		() ;
LIBKBASE_API	struct	aFormat	*getDateTimeFormat	() ;

#endif	// _KB_FORMAT_H
