/***************************************************************************
    file	         : kb_formdlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_FORMDLG_H
#define	_KB_FORMDLG_H

#if	! __KB_RUNTIME

#include	"libkbase_exports.h"
#include	"kb_propdlg.h"


class	KBScriptDlg	;
class	KBImportDlg	;
class	KBParamDlg	;
class	KBTestSuiteList	;


/*  KBFormPropDlg							*/
/*  -------------							*/
/*  Properties dialog for form top-level object, that is, those parts	*/
/*  of KBForm which are specific to KBForm and not contained in the	*/
/*  KBBlock base class.							*/

class	LIBKBASE_API	KBFormPropDlg : public KBPropDlg
{
	Q_OBJECT

	KBAttrStr		m_mattr		;
	KBAttrStr		m_m2attr	;
	KBAttrStr		m_iattr		;
	KBAttrStr		m_pattr		;
	KBAttrStr		m_tattr		;

	KBScriptDlg		*m_scriptDlg	;
	KBScriptDlg		*m_script2Dlg	;
	KBImportDlg		*m_importDlg	;
	KBParamDlg		*m_paramDlg 	;
	KBTestSuiteList		*m_testSuiteList;

	KBForm			*m_root		;
	QString			m_ibtype	;

	QPtrList<KBModule>	m_scripts	;
	QPtrList<KBModule>	m_scripts2	;
	QPtrList<KBModule>	m_imports	;
	QPtrList<KBParam >	m_params	;
	QPtrList<KBTestSuite>	m_testSuites	;

protected :

	virtual	bool	showProperty (KBAttrItem *) ;
	virtual	bool	saveProperty (KBAttrItem *) ;
	virtual	bool	hideProperty (KBAttr *) ;
	virtual	void	preExec	     () ;

protected slots :

	virtual	void	clickOK	     () ;

public	:

	KBFormPropDlg
	(	KBForm 			*,
		cchar			*,
		QPtrList<KBAttr  >	&,
//		QPtrList<KBModule>	&,
//		QPtrList<KBModule>	&,
//		QPtrList<KBModule>	&,
//		QPtrList<KBParam >	&,
		cchar			* = 0
	)	;
       ~KBFormPropDlg () ;

	static	void	initToplevelCombo (RKComboBox *, const QString &) ;
}	;

#endif
#endif	// _KB_FORMDLG_H
