/***************************************************************************
    file	         : kb_forminitdlg.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	<qtextview.h>
#include	<qlabel.h>

#if	 	__KB_AUTOMOC
#include	"kb_forminitdlg.moc"
#else
#include	"kb_forminitdlg.h"
#endif

#include	"kb_locator.h"



KBFormInitDlg::KBFormInitDlg
	(	bool		&ok
	)
	:
	KBWizard (0, QString::null)
{
	QString	source	= locateFile ("appdata", "wizards/wizFormSetup.wiz") ;

	if (source.isEmpty())
	{
		fprintf
		(	stderr,
			"KBFormInitDlg::KBFormInitDlg: Cannot locate wizFormSetup.wiz\n"
		)	;
		ok	= false	;
		return	;
	}

	ok = init (source) ;
}

KBBlock::BlkType
	KBFormInitDlg::toplevel ()
{
	static	KBBlock::BlkType vals[] = 
	{	KBBlock::BTTable,
		KBBlock::BTQuery,
		KBBlock::BTSQL,
		KBBlock::BTNull
	}	;

	int	idx	= ctrlAttribute ("source", "source", "index").toInt() ;
	return	(idx >= 0) && (idx < 4) ? vals[idx] : KBBlock::BTTable ;
}

KBAttrGeom::MgmtMode
	KBFormInitDlg::management ()
{
	int	idx	= ctrlAttribute ("mgmt", "mgmt", "index").toInt() ;
	return	idx == 1 ? KBAttrGeom::MgmtDynamic : KBAttrGeom::MgmtStatic ;
}

QString	KBFormInitDlg::language ()
{
	return	ctrlValue ("script", "script") ;
}
