/***************************************************************************
    file	         : kb_graphic.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB__GRAPHIC_H
#define	_KB__GRAPHIC_H

#include	"libkbase_exports.h"

#include	"kb_object.h"
#include	"kb_qtgraphic.h"
#include	"kb_attrserver.h"
#include	"kb_attrimage.h"
#include	"kb_attrframe.h"


/*  KBGraphic								*/
/*  -----------								*/
/*  This class is used for XML parse tree elements corresponding to	*/
/*  statis graphic elements.						*/

class	LIBKBASE_API	KBGraphic : public KBObject
{
	Q_OBJECT

	KBAttrImage	m_image		;
	KBAttrFrame	m_frame	 	;	/* Frame style		*/
	KBAttrUInt	m_autosize	;
	KBCtrlGraphic	*m_graphic	;

	KBReport	*m_report	;	/* Embedding report	*/

	bool		loadImage ()	;


public	:

	KBGraphic (KBNode  *, const QDict<QString> &, bool * = 0) ;
	KBGraphic (KBNode  *, KBGraphic *) ;
virtual~KBGraphic () ;

#if	! __KB_RUNTIME
	virtual	bool		propertyDlg	(cchar *) ;
#endif

	virtual	void		buildDisplay	(KBDisplay *) ;
	virtual	KBNode		*replicate	(KBNode    *) ;
	virtual	void		showAs		(KB::ShowAs ) ;

	inline	uint	autoSize ()
	{
		return	m_autosize.getIntValue() ;
	}
}	;

#if	! __KB_RUNTIME
extern	bool LIBKBASE_API graphicPropDlg
			  (	KBGraphic	*,
				cchar		*,
				QPtrList<KBAttr>	&
			  )	;
#endif
#endif	// _KB__GRAPHIC_H
