/***************************************************************************
    file	         : kb_grid.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef		__KB_GRID_H
#define		__KB_GRID_H

#include	"libkbase_exports.h"

#include	"kb_classes.h"
#include	"kb_object.h"
#include	"kb_qtgrid.h"

#include	<qintdict.h>


/*  KBGrid								*/
/*  ------								*/
/*  This class is used for XML parse tree elements corresponding to	*/
/*  headers used in grid blocks.					*/

class	LIBKBASE_API	KBGrid : public KBObject
{
	Q_OBJECT

	KBAttrBool		m_nosort	;

	KBCtrlGrid		*m_grid		;
	QPtrList<KBItem>	m_allItems	;
	QPtrList<KBItem>	m_visItems	;
	int			m_sortCol	;
	bool			m_sortAsc	;
	int			m_rmOffset	;

	QIntDict<KBItem>	m_defTabOrder	;

public slots	:

	void			columnClicked	(int)		;

public	:

	KBGrid	(KBNode  *, const QDict<QString> &, bool * = 0) ;
	KBGrid	(KBNode  *, KBGrid *) ;
virtual~KBGrid	()		 ;

#if	! __KB_RUNTIME
	virtual	bool		propertyDlg	(cchar  *)		;
#endif
	virtual	KBNode		*replicate	(KBNode *) ;

	virtual	KBGrid		*isGrid		() { return this ; }

	virtual	void		buildDisplay	(KBDisplay *)		;
	virtual	void		showAs		(KB::ShowAs )		;

	void			getItems	(QPtrList<KBItem>    &)	;
	void			setOrder	(QPtrList<KBItem>    &)	;
	void			setItemsVisible	(QValueList<bool> &, bool = false) ;
	void			setItemsEnabled	(QValueList<bool> &)	;

	void			setColumnWidth	(KBItem *,  uint)	;

	void			clearItems	(bool = false)		;
	void			appendItem	(KBItem *, bool = false);
	void			resetSort	()			;
	void			orderByExpr	(bool)			;
	void			columnSort	()			;
	void			adjustItems	()			;
	uint			rowMarkOffset	()			;
	bool			noSort		()			;
}	;

#endif		// __KB_GRID_H
