/***************************************************************************
    file	         : kb_hidden.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_HIDDEN_H
#define		__KB_HIDDEN_H

#include	"libkbase_exports.h"

#include	"kb_classes.h"
#include	"kb_node.h"
#include	"kb_item.h"


class	KBHiddenValue	;

/*  KBHidden								*/
/*  --------								*/
/*  This class is used to represent a KBHidden elements in the XML	*/
/*  form description, which provide for "hidden" fields used to get	*/
/*  values from the database server for the benefit of scripts.		*/ 

class	LIBKBASE_API KBHidden : public KBItem
{
	Q_OBJECT

	QMemArray<KBHiddenValue *>
				m_values	;

	void			init			()	;
	KBHiddenValue		*valueAtQRow		(uint)	;

protected slots	:

	void			recordVerifyValue 	()	;

protected :

	virtual	void		setMonitor		(KBNodeMonitor *) ;


public	:

#if	! __KB_RUNTIME
	virtual	bool		propertyDlg		(cchar  *) ;
#endif
	virtual	KBNode		*replicate		(KBNode *) ;
	virtual	void		showAs			(KB::ShowAs) ;

	virtual	KBHidden	*isHidden		()
	{
		return	this	;
	}


	virtual	KBValue		getValue		(uint) ;
	virtual	bool		setValue		(uint, const KBValue &) ;
	virtual	bool		isEmpty			(uint) ;
	virtual	void		clearValue		(uint, bool) ;
	virtual	bool		isValid			(uint, bool) ;
	virtual	bool		changed			(uint) ;

	virtual	uint		calcNumRows 		(int,  int,  uint    ) ;
	virtual	uint		calcNumRows 		(uint, uint, int, int) ;
	virtual void		setupControls		() ;

	virtual	void		hideBelow		(uint)
	{
	}

	virtual	bool	ctrlGeometry
		(	uint	,
			QRect &
		)
	{
		return	false	;
	}
	inline	void	setNameAndExpr
		(	const QString	&name,
			const QString	&expr
		)
	{
		m_name.setValue (name) ;
		m_expr.setValue (expr) ;
	}

	friend	class	KBHiddenDlg	;

	KBHidden 			(KBNode   *, const QDict<QString> &, bool * = 0) ;
	KBHidden 			(KBObject *, bool     &) ;
	KBHidden 			(KBNode   *, KBHidden *) ;
	virtual~KBHidden		() ;
}	;

#endif		// __KB_HIDDEN_H
