/***************************************************************************
    file	         : kb_label.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB__LABEL_H
#define	_KB__LABEL_H


#include	"libkbase_exports.h"

#include	"kb_object.h"
#include	"kb_qtlabel.h"
#include	"kb_attralign.h"
#include	"kb_attrframe.h"


class	KBPopupMenu	;

/*  KBLabel								*/
/*  -----------								*/
/*  This class is used for XML parse tree elements corresponding to	*/
/*  simple labeks.							*/

class	LIBKBASE_API	KBLabel : public KBObject
{
	Q_OBJECT

	KBAttrStr		m_text		;
	KBAttrStr		m_fgcolor	;
	KBAttrStr		m_bgcolor	;
	KBAttrFrame		m_frame		;
	KBAttrStr		m_font		;
	KBAttrAlign		m_align		;
	KBCtrlLabel		*m_label	;
	KBAttrStr		m_buddy		;
	KBEvent			m_onClick	;
	KBReport		*m_report	;

protected slots :

	void			recordVerifyText()	;

public	:

#if	! __KB_RUNTIME
	virtual	bool		propertyDlg	(cchar     *) ;
	virtual void		makeRecordPopup	(KBPopupMenu *, uint, bool) ;
#endif

	virtual	void		buildDisplay	(KBDisplay *) ;
	virtual	KBNode		*replicate	(KBNode	   *) ;
	virtual	void		showAs		(KB::ShowAs ) ;
	virtual void		setPalette	() ;

	void			setText		(const QString	&text) ;
	QString			getText 	() ;
	int			getAlign  	() ;


	virtual	void		enumKBProperty	(QStringList	  	&) ;
	virtual	bool		hasKBProperty	(cchar *)		   ;
	virtual	bool		getKBProperty	(cchar *,	KBValue &) ;
	virtual	bool		setKBProperty	(cchar *, const KBValue &) ;

	void			clicked		()	;

	KBLabel					(KBNode  *, const QDict<QString> &, bool * = 0) ;
	KBLabel 				(KBNode  *, KBLabel *) ;
	virtual	~KBLabel			()	;
}	;

#if	! __KB_RUNTIME
extern	LIBKBASE_API	bool labelPropDlg
			(	KBLabel			*,
				cchar			*,
				QPtrList<KBAttr>	&,
				cchar			* = 0
			)	;
#endif
#endif	// _KB__LABEL_H
