/***************************************************************************
    file	         : kb_link.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_LINK_H
#define		__KB_LINK_H

#include	"libkbase_exports.h"

#include	<qdict.h>
#include	<qstringlist.h>

#include	"kb_classes.h"
#include	"kb_linktree.h"
#include	"kb_qtlink.h"

/*  KBLink								*/
/*  ----------								*/
/*  This class is used to represent a link element in the XML form	*/
/*  description. Note that it may map onto more than one actual field.	*/

class	LIBKBASE_API	KBLink : public KBLinkTree
{
	Q_OBJECT

	KBAttrUInt		m_showCols	;
	KBAttrBool		m_morph		;

protected slots :

	void			recordVerifyChoices	()	;

protected :

	virtual	KBControl	*makeCtrl    	(uint)	;
	virtual	void		loadControl	(uint, const QStringList &, const KBLTValueSet &) ;

public	:

#if	! __KB_RUNTIME
	virtual	bool		propertyDlg  	(cchar  *)	;
#endif
	virtual	KBNode		*replicate	(KBNode *)	;

	virtual void		setUserFilter	(uint, const QString	&) ;
	virtual void		setUserSorting	(uint, const QString	&) ;
	virtual	void		reload		(uint) ;
	virtual	KBValue		getExtra	(uint, bool, uint) ;
	virtual QStringList	getDisplayList	(uint) 	;
	virtual	uint		getNumValues	(uint)	;
	virtual	bool		isMorphing	()	;

	bool			setCurrentDisplay
						(uint, const QString	&) ;

	void			setCurrentItem	(uint, uint) ;
	uint			currentItem	(uint)	     ;

	static	KBPopupMenu	*makeLinkPopup
				(	QWidget		*,
					QObject		*,
					Qt::ButtonState	*,
					NodeSpec	**
				)	;

#if	! __KB_RUNTIME
	virtual void		makeRecordPopup	(KBPopupMenu *, uint, bool) ;
#endif

	KBLink					(KBNode  *, const QDict<QString> &, bool * = 0) ;
	KBLink					(KBNode  *, KBLink *) ;
	virtual	~KBLink				() ;
}	;

#if	! __KB_RUNTIME
extern	LIBKBASE_API	bool	linkPropDlg
			(	KBLink 			*,
				cchar			*,
				QPtrList<KBAttr>	&,
				cchar			* = 0
			)	;
#endif
#endif		// __KB_LINK_H
