/***************************************************************************
    file	         : kb_linktreedlg.h
    copyright            : (C) 1999,2000,2001,2002,2003,2004 by Mike Richardson
			   (C) 2001,2002,2003,2004 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_LINKTREEDLG_H
#define	_KB_LINKTREEDLG_H

#if	! __KB_RUNTIME


#include	"libkbase_exports.h"


#include	"kb_classes.h"
#include	"kb_linktree.h"
#include	"kb_itemdlg.h"

class	RKPushButton	;


/*  KBLinkTreePropDlg							*/
/*  -------------							*/
/*  Wrapper class for link/tree properties dialog. Handles special-case	*/
/*  properties.								*/

class	LIBKBASE_API	KBLinkTreePropDlg : public KBItemPropDlg
{
	Q_OBJECT

	RKPushButton		*m_bQuery	;
	KBLinkTree		*m_linkTree	;

private slots :

	void			clickQuery	() ;

protected :

	virtual KBAttrItem	*getAttrItem	(KBAttr *) ;
	virtual	void		dropProperty	() ;
	virtual	bool		showProperty	(KBAttrItem *) ;
	virtual	bool		saveProperty	(KBAttrItem *) ;

public	:

	KBLinkTreePropDlg (KBLinkTree *, cchar *, QPtrList<KBAttr> &, cchar *) ;
       ~KBLinkTreePropDlg () ;
}	;

#endif
#endif	// _KB_LINKTREEDLG_H
