/***************************************************************************
    file	         : kb_listbox.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_LISTBOX_H
#define		__KB_LISTBOX_H

#include 	"libkbase_exports.h"

#include	<qdict.h>
#include	<qstringlist.h>

#include	"kb_classes.h"
#include	"kb_item.h"
#include	"kb_attrgeom.h"


/*  KBListBox								*/
/*  ----------								*/
/*  This class is used to represent a KBListBox element in the XML	*/
/*  form description. Note that it may map onto more than one actual	*/
/*  field.								*/

class	LIBKBASE_API	KBListBox : public KBItem
{
	Q_OBJECT

	KBAttrStr		m_values	;
	KBAttrStr		m_nullval	;
	KBAttrBool		m_nullOK	;
	KBAttrBool		m_noblank	;
	KBAttrStr		m_fgcolor	;
	KBAttrStr		m_bgcolor	;
	KBAttrStr		m_font		;
	KBEvent			m_onChange	;

	QStringList		m_valset	;

	void			loadValues	() ;

protected :

	virtual	KBControl	*makeCtrl	(uint)	  ;

public	:

#if	! __KB_RUNTIME
	virtual	bool		propertyDlg	(cchar *) ;
#endif
	virtual	KBNode		*replicate	(KBNode *     ) ;
	virtual	void		showAs		(KB::ShowAs   ) ;
	virtual	bool		keyStroke	(QKeyEvent   *) ;

	virtual	bool		canBeInvalid	() ;
	virtual bool		checkValid	(const KBValue &, bool) ;
	void			setValues	(const QStringList   &) ;
	const	QStringList	&getValues	() ;
	uint			getNumValues	() ;

	void			setCurrentItem	(uint, uint) ;
	uint			currentItem	(uint)	     ;

	virtual	void		doSearch	() ;

	KBListBox				(KBNode  *, const QDict<QString> &, bool * = 0) ;
	KBListBox				(KBNode  *, KBListBox *) ;
	virtual	~KBListBox			()		 ;
}	;


#if	! __KB_RUNTIME
extern LIBKBASE_API	bool	listBoxPropDlg
			(	KBListBox		*,
				cchar			*,
				QPtrList<KBAttr>	&,
				cchar			* = 0
			)	;
#endif
#endif	// __KB_LISTBOX_H
