/***************************************************************************
    file	         : kb_listbocdlg.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<stdio.h>

#include	<qframe.h>
#include	<qmessagebox.h>

#include	"kb_classes.h"
#include	"kb_type.h"
#include	"kb_value.h"

#include	"kb_attr.h"
#include	"kb_dbinfo.h"
#include	"kb_qrybase.h"
#include	"kb_block.h"
#include	"kb_listbox.h"

#if		__KB_AUTOMOC
#include	"kb_listboxdlg.moc"
#else
#include	"kb_listboxdlg.h"
#endif


/*  KBListBoxPropDlg							*/
/*  KBListBoxPropDlg							*/
/*		: Constructor for list box properties dialog		*/
/*  choice	: KBChoice *	   : Parent choice			*/
/*  caption	: const char *     : Dialog box caption			*/
/*  attribs	: QPtrList<KBAttr>&: List of attributes			*/
/*  iniAttr	: cchar *	   : Initial attribute			*/
/*  (returns)	: KBListBoxPropDlg :					*/

KBListBoxPropDlg::KBListBoxPropDlg
	(	KBListBox		*listbox,
		cchar			*caption,
		QPtrList<KBAttr>	&attribs,
		cchar		*iniAttr
	)
	:
	KBItemPropDlg	(listbox, caption, attribs, iniAttr),
	m_listbox	(listbox)
{
}

/*  KBListBoxPropDlg							*/
/*  ~KBListBoxPropDlg							*/
/*		: Destructor for listbox properties dialog		*/
/*  (returns)	: void		:					*/

KBListBoxPropDlg::~KBListBoxPropDlg ()
{
}


/*  KBListBoxPropDlg							*/
/*  showProperty: Show property						*/
/*  item	: KBAttrItem *	: Associated item			*/
/*  (returns)	: bool		: Property on show			*/

bool	KBListBoxPropDlg::showProperty
	(	KBAttrItem	*item
	)
{
	return	KBItemPropDlg::showProperty (item) ;
}

/*  KBListBoxPropDlg							*/
/*  saveProperty: Check and save attribute				*/
/*  item	: KBAttrItem *	: Associated item			*/
/*  (returns)	: bool		: Attribute OK				*/

bool	KBListBoxPropDlg::saveProperty
	(	KBAttrItem	*item
	)
{
	return	KBItemPropDlg::saveProperty (item) ;
}

/*  listBoxPropDlg: Run the listbox properties dialog			*/
/*  choice	  : KBChoice *	     : Parent choice			*/
/*  caption	  : const char *     : Dialog box caption		*/
/*  attribs	  : QPtrList<KBAttr>&: List of attributes		*/
/*  iniAttr	  : cchar *	     : Initial attribute		*/
/*  (returns)	  : bool	     : Success				*/

bool 	LIBKBASE_API	listBoxPropDlg
	(	KBListBox		*listbox,
		cchar			*caption,
		QPtrList<KBAttr>	&attribs,
		cchar			*iniAttr
	)
{
	KBListBoxPropDlg fDlg (listbox, caption, attribs, iniAttr) ;
	return	fDlg.exec () ;
}
