/***************************************************************************
    file	         : kb_listwidget.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_LISTWIDGET
#define	__KB_LISTWIDGET

#include	"libkbase_exports.h"

#include	<qlistview.h>
#include	<qwidgetstack.h>
#include	<qheader.h>


/*  KBListWidget							*/
/*  ------------							*/
/*  This class is like a tab widget, but uses a list in place of the	*/
/*  tab bar.								*/

class	LIBKBASE_API	KBListWidget : public QWidget
{
	Q_OBJECT

	QListView	*m_list		;
	QWidgetStack	*m_stack	;
	int		m_section	;
	QListViewItem	*m_last		;

signals	:

	void		currentChanged	(QWidget *) ;

protected :

	virtual	void	resizeEvent	(QResizeEvent  *) ;

protected slots :

	void		slotChangePage	(QListViewItem *) ;

public	:

	KBListWidget		(QWidget *)	;

	void	addPage		(QWidget *, const QString &, const QPixmap &) ;
	void	addTab		(QWidget *, const QString &, const QPixmap & = QPixmap()) ;
}	;

#endif	// __KB_LISTWIDGET
