/******************************************************************************
    file		: kb_manual.h
    copyright           : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			  (C)	2001,2002,2003,2004,2005
				by John Dean
    email		: john@totalrekall.co.uk
			: mike@quaking.demon.co.uk
******************************************************************************/

#ifndef	__KB_HELP_H
#define	__KB_HELP_H

#include	<qobject.h>
#include	<qpushbutton.h>

#include	"libkbase_exports.h"

class	QProcess	;
class	QSocketDevice	;
class	QSocketNotifier	;
class	QSocket		;

/*  KBManual								*/
/*  ------								*/
/*  Class used to interface to the help program. Used to create the	*/
/*  process as needed, and to pass help requests to it.			*/

class	LIBKBASE_API KBManual : public QObject
{
	Q_OBJECT

	QProcess	*m_helpProcess	;
	QSocketDevice	*m_listener	;
	QSocketNotifier	*m_notify	;
	uint		m_port		;
	QSocket		*m_comms	;

	void		startHelpProcess	(const char *) ;

	KBManual		()	;
	~KBManual		()	;

private slots	:

	void		slotCommsCalled		() ;
	void		slotProcessExited	() ;

public	slots	:

	void		slotHelp 		(const char *) ;
	void		slotHelp 		() ;
	void		showContents		() ;
	void		showIndex		() ;

public	:

	static	KBManual	*self()	;
}	;


/*  KBManualPushButton							*/
/*  ----------------							*/
/*  Simple wrapper round QPushButton which automates the connection of	*/
/*  the button to the help system.					*/

class	LIBKBASE_API KBManualPushButton : public QPushButton
{
	Q_OBJECT

	const char	*m_name	;

public	:

	KBManualPushButton (QWidget *, const char *, const char * = 0) ;
	~KBManualPushButton() ;
}	;

/*  KBHELPKEY								*/
/*  ---------								*/
/*  Macro to wrap help keys, used so we can script a scan to check that	*/
/*  all help keys are valid.						*/

#define	KBHELPKEY(x)	(x)

#endif	// __KB_HELP_H
