/***************************************************************************
    file	         : kb_mask.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_MASK_H
#define	_KB_MASK_H

#include	"libkbase_exports.h"

#define	MCHAR_ANY		'_'
#define	MCHAR_DIGIT		'0'
#define	MCHAR_ALPHA		'a'
#define	MCHAR_UPPER		'A'
#define	MCHAR_DIGIT_OPT		'9'
#define	MCHAR_ALPHA_OPT		'z'
#define	MCHAR_UPPER_OPT		'Z'

#include	"rk_lineedit.h"


class LIBKBASE_API	KBMaskedInput : public QObject
{
	Q_OBJECT

	RKLineEdit	*m_lineEdit	;
	QString		m_mask		;
	QString		m_text		;
	bool		m_enabled	;

public	:

	KBMaskedInput	     (RKLineEdit *)	;

	void	setInputMask (const QString &)	;
	void	setEnabled   (bool)	;

signals :

	void	textChangedTo(const QString &)	;

public	slots :

	void	textChanged  (const QString &)	;
}	;

#endif	// _KB_MASK_H
