/***************************************************************************
    file	         : kb_memo.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef		__KB_MEMO_H
#define		__KB_MEMO_H

#include	"libkbase_exports.h"


#include	"kb_classes.h"
#include	"kb_item.h"
#include	"kb_field.h"
#include	"kb_attrframe.h"



/*  KBMemo								*/
/*  ------								*/
/*  This class is used to represent a memo field in forms and reports	*/
/*  (ie., a multiple line edit box).					*/

class	LIBKBASE_API	KBMemo : public KBItem
{
	Q_OBJECT

	KBAttrStr	m_fgcolor   ;	/* Foreground (text) colour	*/
	KBAttrStr	m_bgcolor   ;	/* Background colour		*/
	KBAttrFrame	m_frame	    ;	/* Frame style			*/
	KBAttrStr	m_font	    ; 	/* Report font			*/
	KBAttrBool	m_nullOK    ;	/* Is empty field OK		*/
	KBAttrStr	m_hilite    ;	/* Text highlight scheme	*/
	KBAttrBool	m_wrap	    ;	/* Text wrapping		*/
	KBAttrBool	m_emptyNull ;	/* Treat empty fields as null	*/
	KBAttrUInt	m_mapCase   ;	/* Case mapping on save		*/
	KBAttrUInt	m_focusCaret;	/* Caret option on focus	*/
	KBEvent		m_onChange  ;

	KBReport	*m_report   ;

	bool			doCheckValid	(const QString &, bool) ;

protected :

	virtual	KBControl	*makeCtrl	(uint)	  ;

public	:

	KBMemo	(KBNode  *, const QDict<QString> &, bool * = 0) ;
	KBMemo	(KBNode  *, KBMemo *) ;
virtual~KBMemo	() ;

#if	! __KB_RUNTIME
	virtual	bool		propertyDlg	(cchar *)  ;
#endif
	virtual	KBNode		*replicate	(KBNode *) ;
	virtual	KBValue		getValue	(uint)	   ;

	virtual	bool		canBeInvalid	()	   ;
	virtual	bool		doLeave		(uint)	   ;
	virtual bool		checkValid	(const KBValue &, bool) ;

	bool			isWrapping	()	;
	KBField::MapCase	getMapCase	()	;
	KBField::FocusCaret	getFocusCaret	()	;
}	;



#if	! __KB_RUNTIME
extern LIBKBASE_API	bool	memoPropDlg
			(	KBMemo			*,
				cchar			*,
				QPtrList<KBAttr>	&,
				cchar			* = 0
			)	;
#endif
#endif		// __KB_MEMO_H
