/***************************************************************************
    file	         : kb_methdict.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	__KB_METHDICT_H
#define	__KB_METHDICT_H


#include	<qmap.h>
#include	<qdict.h>
#include	<qdom.h>

#include	"libkbase_exports.h"

/*  KBMethDictArg							*/
/*  -------------							*/
/*  Class used to store details of an argument.				*/

class	LIBKBASE_API	KBMethDictArg
{
public	:

	QString		m_name		;
	QString		m_type		;
	QString		m_comment	;
	bool		m_opt		;

	inline	KBMethDictArg	()
	{
		m_opt	= false	;
	}

	KBMethDictArg	(const QDomElement &)	;
}	;

/*  KBMethDictEntry							*/
/*  ---------------							*/
/*  Structure used to handle dictionary entries. Only a class so that	*/
/*  we have automatic initialisation.					*/

class	LIBKBASE_API	KBMethDictEntry
{
	QString				asText		(bool)	;

	QString				m_class		;
	QString				m_name		;
	QString				m_comment	;
	QString				m_description	;
	QString				m_return	;
	QValueList<KBMethDictArg>	m_args		;

public	:


	QString				description	()	;
	QString				prototype	()	;
	QString				substitute	()	;
	const QString			&name		()	;
	const QString			&klass		()	;

	int				compare		(const KBMethDictEntry *) ;

	KBMethDictEntry			(const QString &, const QDomElement &) ;
}	;

/*  KBMethDict								*/
/*  ----------								*/

class	LIBKBASE_API	KBMethDict
{
	void		loadFile	(const QString &) ;
	QDict<KBMethDictEntry>		m_entries	  ;

protected :

	QMap <QString,QDomElement>	m_classes	  ;

public	:

	KBMethDict			(const QString &, const QString &) ;

	QPtrList<KBMethDictEntry>	getMethods
					(	const QString	&,
						const QString	&,
						bool		,
						const QString	&
					) 	;
}	;

#endif	// __KB_METHDICT_H
