/***************************************************************************
    file	         : kb_metrics.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/



#include	<stdio.h>
#include	"kb_classes.h"
#include	"kb_metrics.h"

#define		__DEBUG_METRICS	(0)
#if		__DEBUG_METRICS
#include	"kb_dprintf.h"
#endif


uint	KBMetrics::menuBarHeight	;
uint	KBMetrics::toolBarHeight	;
uint	KBMetrics::statusBarHeight	;

void	KBMetrics::noteMenuBarHeight
	(	uint	height
	)
{
	DPRINTF
	((	"KBMetrics::noteMenuBarHeight: Set menu bar height %u\n",
		height
	))	;
	menuBarHeight	= height ;
}

void	KBMetrics::noteToolBarHeight
	(	uint	height
	)
{
	DPRINTF
	((	"KBMetrics::noteToolBarHeight: Set tool bar height %u\n",
		height
	))	;
	toolBarHeight	= height ;
}

void	KBMetrics::noteStatusBarHeight
	(	uint	height
	)
{
	DPRINTF
	((	"KBMetrics::noteStatusBarHeight: Set status bar height %u\n",
		height
	))	;
	statusBarHeight	= height ;
}

uint	KBMetrics::getMenuBarHeight ()
{
	return	menuBarHeight	;
}

uint	KBMetrics::getToolBarHeight ()
{
	return	toolBarHeight	;
}

uint	KBMetrics::getStatusBarHeight ()
{
	return	statusBarHeight	;
}
