/***************************************************************************
    file	         : kb_moduleitem.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_MODULEITEM_H
#define	__KB_MODULEITEM_H

#include	<qptrlist.h>

#include	"libkbase_exports.h"

#include	"kb_classes.h"
#include	"rk_hbox.h"
#include	"rk_listbox.h"


class	RKLineEdit	;
class	RKPushButton	;
class	RKComboBox	;

/*  KBModuleItem							*/
/*  ------------							*/
/*  This is a wrapper round a list view item, used to store a pointer	*/
/*  at an associated KBModule object.					*/

class	LIBKBASE_API	KBModuleItem : public QListBoxText
{
	KBModule	*module	;

protected :

	virtual	KBModule *makeModule (KBNode *, const QString &) = 0 ;

public	:

	KBModuleItem (RKListBox *, KBModule 	*) ;
	KBModuleItem (RKListBox *, const QString &) ;
        virtual ~KBModuleItem () ;

	inline	KBModule *getModule  () { return module ; }
	void	fixUp	 (KBNode *) ;
}	;

/*  KBModuleDlg								*/
/*  -----------								*/
/*  This dialog is used to edit lists of modules (scripts or imports).	*/
/*  It is extended in each case to implement the pure vurtual function	*/
/*  "makeModule" which creates the appropriate module type.		*/

class	LIBKBASE_API	KBModuleDlg : public RKHBox
{
	Q_OBJECT

	KBNode			*m_node		;
	QString			m_language	;

	RKListBox		*m_vModules	;
	RKComboBox		*m_cbModule	;
	RKPushButton		*m_bAdd	 	;
	RKPushButton		*m_bRemove	;

	QPtrList<KBModule>	m_dropped	;

protected :

	void			setModules	(QPtrList<KBModule> &) ;

	virtual KBModuleItem	*makeModuleItem (RKListBox *, KBModule 	    *) = 0 ;
	virtual KBModuleItem	*makeModuleItem (RKListBox *, const QString &) = 0 ;

protected slots :

	void	clickAdd	()	;
	void	clickRemove	()	;
	void	highlighted	(int)	;

public	:

	KBModuleDlg 		(QWidget *, KBNode *, bool, const QString &) ;
	virtual ~KBModuleDlg	() ;

	void	fixUp		() ;
	QString	getText		() ;
}	;

#endif	// __KB_MODULEITEM_H
