/***************************************************************************
    file	         : kb_overridedlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_OVERRIDEDLG_H
#define	_KB_OVERRIDEDLG_H

#if	! __KB_RUNTIME



#include	"kb_param.h"
#include	"kb_override.h"
#include	"kb_dialog.h"
#include	"kb_attrdlg.h"

#include	"libkbase_exports.h"

#include	"rk_hbox.h"

class	QWidgetStack	;
class	RKListView	;

class	KBTextEdit	;
class	RKPushButton	;
class	KBOverrideItem	;


/*  KBOverrideDlg							*/
/*  -------------							*/
/*  This class is used as a component in property dialogs to handle	*/
/*  editing of override objects.					*/

class	LIBKBASE_API KBOverrideDlg : public RKHBox
{
	Q_OBJECT

	enum	DlgRC
	{
		SyncOK,
		SyncFail,
		Dialog,
		None
	}	;

	KBObject	*m_object	;
	QWidgetStack	*m_stack	;

	RKPushButton	*m_bEdit	;
	RKPushButton	*m_bSave	;
	RKPushButton	*m_bCancel	;
	RKPushButton	*m_bToggle	;

	RKListView	*m_lvOverride	;
	KBTextEdit	*m_textEdit	;

	KBAttrDlg	*m_attrDlg	;

	KBOverrideItem	*m_curItem	;
	KBOverrideItem	*m_editItem	;
	bool		m_adding	;
	uint		m_ident		;

	DlgRC		getAttrDlg	(KBOverrideItem *) ;
	void		saveCurrent	() ;

protected slots :

	void		clickEdit	() ;
	void		clickSave	() ;
	void		clickCancel	() ;
	void		clickToggle	() ;
	void		selectionChanged(QListViewItem *) ;

public	:

	KBOverrideDlg	(QWidget *, KBObject *) ;
	~KBOverrideDlg	() ;

	void		startUp		() ;
	void		fixUp		() ;
	QString		getText		() ;
}	;


#endif
#endif	// _KB_OVERRIDEDLG_H
