/***************************************************************************
    file	         : kb_paramdlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_PARAMDLG_H
#define	_KB_PARAMDLG_H

#if	! __KB_RUNTIME


#include	<qptrlist.h>

#include	"kb_param.h"
#include	"kb_dialog.h"
#include	"kb_paramsetdlg.h"
#include	"libkbase_exports.h"

#include	"rk_vbox.h"

class	RKPushButton	;
class	QCheckBox	;
class	RKListView	;
class	KBParamItem	;

class	RKLineEdit	;

/*  KBParamDlg								*/
/*  ----------								*/
/*  This class is used as a component in the form and report properties	*/
/*  dialogs to handle editing of parameters.				*/

class	LIBKBASE_API	KBParamDlg : public RKVBox
{
	Q_OBJECT

	KBNode		*m_node		;
	RKLineEdit	*m_eName	;
	RKLineEdit	*m_eDefval	;
	RKLineEdit	*m_eLegend	;
	RKLineEdit	*m_eFormat	;
	RKPushButton	*m_bFormat	;
	QCheckBox	*m_ePrompt	;
	RKPushButton	*m_bAdd		;
	RKPushButton	*m_bRemove	;
	RKPushButton	*m_bEdit	;
	RKListView	*m_lvParams	;

	QPtrList<KBParam>	m_dropped	;
	KBParamItem	*m_curItem	;

	void		init		() ;

protected slots :

	void		clickAdd	() ;
	void		clickRemove	() ;
	void		clickEdit	() ;
	void		clickFormat	() ;
	void		selectionChanged(QListViewItem *) ;

public	:

	KBParamDlg	(QWidget *, KBNode *, QPtrList<KBParam> &) ;
	KBParamDlg	(QWidget *, const QDict<KBParamSet>  &) ;

	void		getValues	(QDict<KBParamSet>   &) ;
	void		fixUp		() ;
	QString		getText		() ;
}	;


/*  KBParamDesignDlg							*/
/*  ---------------							*/
/*  Wrapper around KBParamDlg to provide a stand-alone parameter setup	*/
/*  dialog.								*/

class	LIBKBASE_API	KBParamDesignDlg : public KBDialog
{
	Q_OBJECT

	KBParamDlg	*m_paramDlg	;

public	:

	KBParamDesignDlg  (const QDict<KBParamSet> &) ;

	inline	void	getValues
		(	QDict<KBParamSet>	&values
		)
	{
		m_paramDlg->getValues (values) ;
	}	
}	;


#endif
#endif	// _KB_PARAMDLG_H
