/***************************************************************************
    file	         : kb_passdlg.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	<qtextbrowser.h>

#include	"rk_vbox.h"
#include	"rk_hbox.h"
#include	"rk_gridbox.h"

#include	"kb_classes.h"
#include	"kb_sidepanel.h"

#if		__KB_AUTOMOC
#include	"kb_passdlg.moc"
#else
#include	"kb_passdlg.h"
#endif

#include	"rk_lineedit.h"

/*  KBPassDlg								*/
/*  KBPassDlg	: Constructor for username/password dialog		*/
/*  caption	: const QString & : Dialog caption			*/
/*  legend	: const QString & : Dialog legend			*/
/*  userName	: const QString & : Default user name			*/
/*  password	: const QString & : Default password			*/
/*  (returns)	: KBPassDlg	  :					*/

KBPassDlg::KBPassDlg
	(	const QString	&caption,
		const QString	&legend,
		const QString	&userName,
		const QString	&password
	)
	:
	KBDialog	(caption, true)
{
	RKVBox	*layTop		= new RKVBox (this) ;
	layTop->setTracking () ;

	RKHBox	*layMain	= new RKHBox (layTop ) ;
	new KBSidePanel (layMain, caption) ;

	RKVBox	*layData	= new RKVBox (layMain) ;
	QTextBrowser *tb	= new QTextBrowser (layData) ;
	tb->setText (legend)	;

	layData->addFiller ()	;

	RKGridBox *layGrid	= new RKGridBox (2, layData) ;

	new QLabel (TR("Username" ), layGrid) ;
	m_userName = new RKLineEdit (layGrid) ;

	new QLabel (TR("Password "), layGrid) ;
	m_password = new RKLineEdit (layGrid) ;

	new QLabel (layGrid) ;
	m_showPwd  = new QCheckBox  (TR("Show password"), layGrid) ;

	addOKCancel(layTop) ;

	m_userName->setMinimumWidth (220) ;
	m_password->setMinimumWidth (220) ;
	m_userName->setText	(userName) ;
	m_password->setText	(password) ;
	m_password->setEchoMode (RKLineEdit::Password) ;

	connect	(m_showPwd, SIGNAL(toggled(bool)), SLOT(showChanged())) ;
}

KBPassDlg::~KBPassDlg ()
{
}

void	KBPassDlg::showChanged ()
{
	m_password->setEchoMode
	(	m_showPwd->isChecked() ?
			RKLineEdit::Normal : RKLineEdit::Password
	)	;
}
