/***************************************************************************
    file	         : kb_pluginaction.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_PLUGINACTION_H
#define		__KB_PLUGINACTION_H

#include	"libkbase_exports.h"
#include	"tk_action.h"

#include	"kb_location.h"

class	QObject			;
class	QString			;
class	QDomElement		;

class	KBForm			;
class	KBReport		;
class	KBComponent		;


/*  KBPluginAction							*/
/*  --------------							*/
/*  Action class used to handle menu/toolbar plugins.			*/

class	LIBKBASE_API	KBPluginAction : public TKAction
{
	Q_OBJECT

	QString			m_name			;

signals	:

	void			sigPluginAction	(const QString &, bool &) ;

protected :

	virtual	void		slotActivated	()	;

public	:

	KBPluginAction
	(	const QString		&text,
		const QString		&iconName,
		int			accel,
		const QObject		*receiver,
		const QDomElement	&element,
		QObject			*parent,
		const char 		*name	= 0
	)	;
}	;


class	KBPluginActionInfo
{
public	:

	KBLocation		m_location	;
	KBForm			*m_form		;
	KBReport		*m_report	;
	KBComponent		*m_component	;

	inline	KBPluginActionInfo ()
	{
		m_form		= 0	;
		m_report	= 0	;
		m_component	= 0	;
	}
}	;

/*  KBPluginActionBase							*/
/*  ------------------							*/
/*  Abstract base class providing the interface to the plugin action	*/
/*  functionality. Implementations should override the "execute"	*/
/*  method to do whatever they need to do.				*/

class	LIBKBASE_API	KBPluginActionBase : public QObject
{
public	:

	virtual	bool	execute	(KBPluginActionInfo &) = 0	;
}	;


#endif	// __KB_PLUGINACTION_H
