/***************************************************************************
    file	         : kb_popupmenu.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_POPUPMENU_H
#define	__KB_POPUPMENU_H

#include	<qptrlist.h>
#include	<qpopupmenu.h>

#include	"libkbase_exports.h"

class	KBObject	;

/*  KBPopupMenu								*/
/*  -----------								*/
/*  This class extends QPopupMenu such that :				*/
/*  (a)	Key state present when the mouse button is released is noted	*/
/*  (b) Insert methods have a disabled option				*/
/*  (c) Inserted submenus are destroyed when the menu itself is		*/

class	LIBKBASE_API	KBPopupMenu : public QPopupMenu
{
	Qt::ButtonState		*m_lvState	;
	QPtrList<KBPopupMenu>	m_subMenus	;
	QString			m_title		;

protected :

	virtual	void	mouseReleaseEvent (QMouseEvent *) ;

public	:

	void		insertEntry	(bool, const QString &, KBPopupMenu *) ;	
	void		insertEntry	(bool, const QString &, const QObject *, const char *) ;
	void		insertEntry	(bool, const QPixmap &, const QString &, KBPopupMenu *) ;	
	void		insertEntry	(bool, const QPixmap &, const QString &, const QObject *, const char *) ;

	void		setTitle	(const QString &)	;
	void		setTitle	(KBObject      *)	;
	const QString	&title		() ;

	KBPopupMenu 			(QWidget     *, Qt::ButtonState *) ;
	KBPopupMenu 			(KBPopupMenu *) ;
       ~KBPopupMenu 			() ;
}	;

#endif	// __KB_POPUPMENU_H
