/***************************************************************************
    file	         : kb_popupprompt.h
    copyright            : (C) 1999,2000,
			       2001,2002,2003,2004,2005 by Mike Richardson
			   (C) 2001,2002,2003,2004,2005 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_POPUPPROMPT_H
#define	_KB_POPPUPROMPT_H


#include	"libkbase_exports.h"
#include	<qwidget.h>


class	RKLineEdit	;
class	RKComboBox	;
class	RKBox		;
class	RKVBox		;
class	RKHBox		;
class	KBDBInfo	;
class	KBSlot		;
class	KBObject	;


/*  KBPopupBase								*/
/*  -----------								*/
/*  Base class for pseudo-modal prompt popups. These implement a	*/
/*  mechanism which can be similarly implemented in RekallWeb (needed	*/
/*  as browsers do not generally provide modal dialogs). When the user	*/
/*  clicks the "OK" button, this is passed back via a slot invocation.	*/

class	LIBKBASE_API	KBPopupBase : public QWidget
{
	Q_OBJECT

	KBObject		*m_target	;
	KBSlot			*m_slot		;
	bool			m_modal		;

protected slots	:

	virtual	void		reject		()	;

protected :

	void			addOKCancel	(RKBox *) ;
	void			unmodal		()	  ;
	void			reply		(cchar *, const QString &) ;

public	:

	KBPopupBase	(KBObject *, const QString &, const QString &)	;
	~KBPopupBase	() ;

	bool	ok	() ;
}	;


/*  ------------------------------------------------------------------	*/

/*  KBPopupPrompt							*/
/*  -------------							*/
/*  Simple textual response popup.					*/

class	LIBKBASE_API	KBPopupPrompt : public KBPopupBase
{
	Q_OBJECT

	RKLineEdit		*m_tValue	;

protected slots :

	virtual	void		accept	()	;

public	:

	KBPopupPrompt
	(	const QString		&,
		const QString		&,
		const QString		&,
		KBObject		*,
		const QString		&
	)	;

       ~KBPopupPrompt	() ;
}	;

/*  ------------------------------------------------------------------	*/

/*  KBPopupChoice							*/
/*  -------------							*/
/*  Simple choice response popup.					*/

class	LIBKBASE_API	KBPopupChoice : public KBPopupBase
{
	Q_OBJECT

	RKComboBox		*m_tChoice	;

protected slots :

	virtual	void		accept	()	;

public	:

	KBPopupChoice
	(	const QString		&,
		const QString		&,
		const QStringList	&,
		KBObject		*,
		const QString		&
	)	;

       ~KBPopupChoice	() ;
}	;

#endif	// _KB_POPPUPROMPT_H
