/***************************************************************************
    file	         : kb_propdict.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_PROPDICT_H
#define	__KB_PROPDICT_H

#include	"libkbase_exports.h"

#include	<qptrlist.h>
#include	<qdict.h>

/*  KBPropDictEntry								*/
/*  -----------								*/
/*  Structure used to handle dictionary entries. Only a class so that	*/
/*  we can initialise the m_extra pointer.				*/

class	LIBKBASE_API	KBPropDictEntry
{
public	:

	QString		m_tag		;	/* PE element		*/
	QString		m_legend	;	/* PE legend		*/
	QString		m_descrip	;	/* PE descriptive text	*/
	QString		m_nullchk	;	/* PE null check error	*/
	QDict<QString>	*m_extra	;	/* Additional values	*/

	inline	KBPropDictEntry ()
	{
		m_extra	= 0	;
	}

}	;

/*  KBPropDict								*/
/*  ------------							*/
/*  Rekall uses a dictionary to hold information, mainly for use in	*/
/*  the property editor, but also for some other places. This is loaded	*/
/*  from dictionary files. It is done this way since it separates out	*/
/*  the (large volume) of text from the source code.			*/

class	LIBKBASE_API	KBPropDict
{
	QDict<KBPropDictEntry>	m_dict	;

	void		loadFile		(const QString &) ;

public	:

	KBPropDict	(const QString &) ;

	KBPropDictEntry	*getEntry		(const QString &, const QString &) ;
}	;

#endif	// __KB_PROPDICT_H
