/***************************************************************************
    file	         : kb_qryquery.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	 	_KB_QRYQUERY_H
#define	 	_KB_QRYQUERY_H

#include 	"kb_qrydata.h"
#include	"kb_docroot.h"

#include	"libkbase_exports.h"


#include	<qvaluelist.h>
class		KBWhatsThisPair	;

/*  KBQryQuery								*/
/*  -----------								*/
/*  Class used for data queries which retrieve data via a KBase-level	*/
/*  query.								*/

class	LIBKBASE_API	KBQryQuery : public KBQryData
{
	Q_OBJECT

	KBAttrStr		m_qryName	;
	KBAttrStr		m_qryWhere	;
	KBAttrStr		m_qryOrder	;
	KBAttrStr		m_qryGroup	;
	KBAttrStr		m_qryHaving	;
	KBAttrBool		m_qryDistinct	;
	KBAttrStr		m_topTable	;

	KBQuery			*m_qryRoot	;

	QPtrList<KBTable>	m_tabList	;
	QPtrList<KBQryExpr>	m_exprList 	;

	bool			loadQueryDef	() ;

protected :

	virtual	bool		loadQuery	() ;

public	:

	KBQryQuery	(KBNode *, const QDict<QString> &, bool * = 0) ;
	KBQryQuery	(KBNode *, KBQryQuery *) ;
	KBQryQuery	(KBNode *) ;

virtual~KBQryQuery	() ;

	virtual	KBQryQuery 	*isQryQuery	() { return this ; }

#if	! __KB_RUNTIME
	virtual	bool		propertyDlg	(cchar  *) ;
#endif
	virtual	KBNode		*replicate	(KBNode *) ;
	virtual	void		showAs   	(KB::ShowAs) ;

	bool			loadQueryDef	(KBLocation &) ;
	bool			getLinkage	(uint, QString &, QString &) ;

	inline	QString		getQryName	()
	{
		return	m_qryName.getValue () ;
	}
	inline	QString		getTopTable	()
	{
		return	m_topTable.getValue () ;
	}

	virtual	bool		getFieldList	(uint, QPtrList<KBFieldSpec> &, int &) ;
	virtual	QString		getComment	(uint)	;

#if	! __KB_RUNTIME
	virtual	void		whatsThisExtra	(QValueList<KBWhatsThisPair> &) ;
#endif
}	;


/*  KBDummyRoot								*/
/*  -----------								*/
/*  This is used as a root node for a KBQryQuery when we need to run	*/
/*  the query outside a form or report. Nasty hack really!		*/

class	LIBKBASE_API KBDummyRoot : public KBNode
{
	KBDocRoot	m_docRoot	;

public	:

	inline	KBDummyRoot
		(	KBLocation	&location
		)
		:
		KBNode		(0, "KBDummyRoot"),
		m_docRoot	(this, m_children, location)
	{
	}

	virtual	KBDocRoot	*isDocRoot  () { return &m_docRoot ; }
}	;


#endif		// _KB_QRYQUERY_H
