/***************************************************************************
    file	         : kb_qryquerydlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_QRYQUERYDLG_H
#define	_KB_QRYQUERYDLG_H

#if	! __KB_RUNTIME

#include	"kb_classes.h"
#include	"kb_node.h"
#include	"kb_propdlg.h"

#include	"libkbase_exports.h"

class		RKComboBox	;
class		QLabel		;

/*  KBQryQueryPropDlg							*/
/*  -----------------							*/
/*  Wrapper class for query-query properties dialog. Handles special-	*/
/*  case properties.							*/

class LIBKBASE_API	KBQryQueryPropDlg : public KBPropDlg
{
	Q_OBJECT

	KBQryQuery		*m_query		;
	QPtrList<QString>		m_idmap			;
	KBResizeWidget		*m_topTableWidget	;
	RKComboBox		*m_topTableCombo	;

	KBQuery			*m_qryRoot		;
	QPtrList<KBTable>		m_qryList		;
	QPtrList<QLabel>		m_blockUp		;

	void		setBlockSizes	()	;
	bool		loadQueryList	(const QString &, const QString &, KBError &) ;

private slots :

	void		topTableResize	(KBResizeWidget *, QSize) ;
	void		showBlockUp	(int)	;

protected :

	virtual KBAttrItem
			*getAttrItem	(KBAttr     *) ;
	virtual	bool	showProperty	(KBAttrItem *) ;
	virtual	bool	saveProperty	(KBAttrItem *) ;

public	:

	KBQryQueryPropDlg (KBQryQuery *, cchar *, QPtrList<KBAttr> &) ;
       ~KBQryQueryPropDlg () ;

	QString		nameForIdent	(const QString &) ;
}	;

extern	LIBKBASE_API	bool	qryQueryPropDlg
			(	KBQryQuery	*,
				cchar		*,
				QPtrList<KBAttr>	&
			)	;

#endif
#endif	// _KB_QRYQUERYDLG_H
