/***************************************************************************
    file	         : kb_qrysqldlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_QRYSQLDLG_H
#define		__KB_QRYSQLDLG_H

#if		! __KB_RUNTIME


#include	"kb_classes.h"
#include	"kb_node.h"
#include	"kb_propdlg.h"

#include	"libkbase_exports.h"

/*  KBQrySQLPropDlg							*/
/*  -----------------							*/
/*  Wrapper class for SQL-query properties dialog. Handles special-	*/
/*  case properties.							*/

class LIBKBASE_API	KBQrySQLPropDlg : public KBPropDlg
{
	Q_OBJECT

	KBPrimaryDlg		*m_primaryDlg		;
	KBQrySQL		*m_query		;

	KBTableSpec		m_tabSpec		;
	KBAttrPrimaryItem	*m_primaryItem		;
	KBAttr			*m_ptypeAttr		;
	KBAttr			*m_pexprAttr		;

	bool			getTableSpec	()	;
	void			findPrimary	()	;

protected :

	virtual	bool		hideProperty	(KBAttr     *)	;
	virtual	bool		showProperty	(KBAttrItem *)	;
	virtual	bool		saveProperty	(KBAttrItem *)	;
	virtual KBAttrItem	*getAttrItem	(KBAttr *)	;

	virtual	void		preExec		() ;

protected slots :

	virtual	void		clickVerify	()	;

public	:

	KBQrySQLPropDlg (KBQrySQL *, cchar *, QPtrList<KBAttr> &) ;
       ~KBQrySQLPropDlg () ;

	QString		nameForIdent	(const QString &) ;
}	;

#endif
#endif	// __KB_QRYSQLDLG_H
