/***************************************************************************
    file	         : kb_qtbutton.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef		__KB_QTBUTTON_H
#define		__KB_QTBUTTON_H


#include	"kb_classes.h"
#include	"kb_ctrl.h"

#include	"rk_pushbutton.h"

#include	"libkbase_exports.h"


/*  KBCtrlButton							*/
/*  ------------							*/
/*  Wrapper class for push button controls				*/

class	LIBKBASE_API	KBCtrlButton : public KBControl
{
	Q_OBJECT

	KBButton		*m_button	;
	RKPushButton		*m_qtButton	;

	QPixmap			m_pm1		;
	QPixmap			m_pm2		;
	QString			m_currentText	;

	bool			m_rolled	;

	bool			updateButton	()	;

protected :

	virtual	bool		eventFilter	(QObject *, QEvent *)	;

public	:

	virtual	void		showAs		(KB::ShowAs) ;
	virtual	void		setupProperties	()	;

	void			setToolTip	(const QString &) ;
	virtual	void		setValue 	(const KBValue &) ;
	virtual	KBValue		getValue	()			;
	virtual	bool		write	 	(KBWriter *, QRect, const KBValue &, bool, int &) ;

	void			setPixmaps	(const QPixmap &, const QPixmap &) ;
	void			animateClick	()			;

	void			setOn		(bool)	;
	bool			isOn		()	;

	KBCtrlButton				(KBDisplay *, KBButton *) ;
	virtual	~KBCtrlButton			() ;
}	;

#endif		// __KB_QTBUTTON_H
