/***************************************************************************
    file	         : kb_qtcheck.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_QTCHECK_H
#define	_KB_QTCHECK_H


#include	"kb_ctrl.h"
#include	"rk_checkbox.h"

#include	"libkbase_exports.h"


/*  KBCtrlCheck								*/
/*  -----------								*/
/*  Wrapper class for checkbox control					*/

class	LIBKBASE_API KBCtrlCheck : public KBControl
{
	Q_OBJECT

	KBCheck			*m_check	;
	RKCheckBox		*m_checkBox	;
	bool			m_inSetValue	;

public	:

	virtual	bool		isNavigationKey	(QKeyEvent *)	  ;

	virtual	void		showAs		(KB::ShowAs) ;
	virtual	void		setupProperties	()	;
	virtual	void		setValue	(const KBValue &) ;
	virtual	KBValue		getValue	()	;
	virtual	void		clearValue	(bool)	;
	virtual	bool		isEmpty		()	;
	virtual	bool		write		(KBWriter *, QRect, const KBValue &, bool, int &) ;
	virtual	void		setReadOnly	(bool, const QColor &, const QColor &)	;
	virtual	bool		isReadOnly	()	;

	bool			isChecked	()	;
	void			setChecked	(bool)	;

	KBCtrlCheck				(KBDisplay *, KBCheck *, uint) ;
	virtual	~KBCtrlCheck 			()	;
}	;

#endif	// _KB_QTCHECK_H
