/***************************************************************************
    file	         : kb_qtchoice.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_QTCHOICE_H
#define		__KB_QTCHOICE_H


#include	<qstringlist.h>

#include	"kb_classes.h"
#include	"kb_ctrl.h"
#include	"rk_combobox.h"

#include	"libkbase_exports.h"


/*  KBCtrlChoice							*/
/*  ------------							*/
/*  Wrapper class for choice combo box control				*/

class	LIBKBASE_API	KBCtrlChoice : public KBControl
{
	Q_OBJECT

	KBChoice		*m_choice	;
	RKComboBox		*m_comboBox	;
	QListBox		*m_listBox	;

	void			setupDataProperties	() ;
	void			setupWidget		() ;

protected slots :

	virtual void		clearWidget		() ;

protected :

	virtual bool		eventFilter	(QObject *, QEvent *) ;

public	:

	virtual	bool		isNavigationKey	(QKeyEvent *)	;

	virtual	void		setupProperties	() ;
	virtual	void		showAs		(KB::ShowAs) ;
	virtual	void		setValue   	(const KBValue &) ;
	virtual	KBValue		getValue   	()	;
	virtual	void		clearValue	(bool)	;
	virtual	void		setFocus	()	;
	virtual	void		setReadOnly	(bool, const QColor &, const QColor &)	;
	virtual	bool		isReadOnly	()	;

	virtual	QString		morphText	(int &)	;

	void			setValues	(const QStringList &) ;
	void			setCurrentItem	(uint)	;
	uint			currentItem	()	;

	KBCtrlChoice 				(KBDisplay *, KBChoice *, uint) ;
	virtual	~KBCtrlChoice 			() ;
}	;

#endif		// __KB_QTCHOICE_H
