/***************************************************************************
    file	         : kb_qtfield.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef		__KB_QTFIELD_H
#define		__KB_QTFIELD_H

#include	<qguardedptr.h>
#include	<qpixmap.h>

#include	"kb_ctrl.h"
#include	"kb_mask.h"

#include	"libkbase_exports.h"


class	RKPushButton	;
class	RKLineEdit	;


/*  KBCtrlField								*/
/*  -----------								*/
/*  Wrapper class for line edit control					*/


class	LIBKBASE_API	KBCtrlField : public KBControl
{
	Q_OBJECT

	KBField			*m_field	;
	RKLineEdit		*m_lEdit	;
	RKPushButton		*m_bHelp	;
	KBMaskedInput		*m_inputMask	;

	QString			m_helper	;
	QPixmap			m_normal	;
	QPixmap			m_rollover	;

	int			m_selStart	;
	int			m_selLength	;

	QPixmap			loadImage		(const QString &) ;
	void			setupDataProperties	() ;
	void			setupWidget		() ;

protected slots :

	void			helpClicked 	() ;
	void			returnPressed	() ;
	void			slotSetSelection() ;
	virtual void		clearWidget	() ;

protected :

	virtual bool		eventFilter	(QObject *, QEvent *) ;

public	:

	virtual	void		showAs		(KB::ShowAs) ;
	virtual	void		setupProperties	()	;
	virtual	void		setValue	(const KBValue &) ;
	virtual	KBValue		getValue	()	;
	virtual	void		clearValue	(bool)	;
	virtual	bool		changed		()	;
	virtual	bool		write		(KBWriter *, QRect, const KBValue &, bool, int &) ;
	virtual	void		setFocus	()	;
	virtual	void		setReadOnly	(bool, const QColor &, const QColor &)	;
	virtual	bool		isReadOnly	()	;

	void			setSelection	(int, int)	;

	virtual	QString		morphText	(int &)	;

	virtual	QSize		sizeHint	() const	;
	virtual	QSizePolicy	sizePolicy	() const	;

	KBCtrlField 				(KBDisplay *, KBField *, uint) ;
	virtual	~KBCtrlField 			() ;
}	;


#endif		// __KB_QTFIELD_H
