/***************************************************************************
    file	         : kb_qtgrid.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB__QTGRID_H
#define		__KB__QTGRID_H

#include	<qheader.h>

#include	"kb_classes.h"
#include	"kb_ctrl.h"

#include	"libkbase_exports.h"

/*  KBCtrlGrid								*/
/*  -----------								*/
/*  Wrapper class for grid header controls				*/

class	LIBKBASE_API	KBCtrlGrid : public KBControl
{
	Q_OBJECT

	KBGrid			*m_grid		;
	QHeader			*m_header	;
	QPtrList<KBItem>	&m_visItems	;

protected :

	virtual bool		eventFilter	(QObject *, QEvent *) ;

public slots :

	void			sizeChange	(int, int, int)	;
	void			indexChange	(int, int, int)	;

public	:

	virtual	void		showAs		(KB::ShowAs) ;
	virtual	bool		write		(KBWriter *, QRect, const KBValue &, bool, int &) ;

	void			adjustItems	(int)	;
	void			clearLabels	()	;
	void			appendLabel	(const QString &, int, bool) ;
	void			setColumnWidth	(int, uint) ;
	void			setSortIndicator(int, bool) ;

	QSize			size		()	;

	KBCtrlGrid 		(KBDisplay *, KBGrid *, QPtrList<KBItem> &) ;
       ~KBCtrlGrid 		() ;
}	;

#endif		// __KB__QTGRID_H
