/***************************************************************************
    file	         : kb_qtlink.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_QTLINK_H
#define		__KB_QTLINK_H


#include	<qstringlist.h>

#include	"kb_classes.h"
#include	"kb_type.h"
#include	"kb_value.h"
#include	"kb_ctrl.h"
#include	"rk_combobox.h"

#include	"libkbase_exports.h"


class		KBCtrlLinkComboBox	;
class		KBMultiListBox		;


/*  KBCtrlLink								*/
/*  ----------								*/
/*  Wrapper class for combo box control					*/

class	LIBKBASE_API	KBCtrlLink : public KBControl
{
	Q_OBJECT

	KBLink			*m_link		;
	KBCtrlLinkComboBox	*m_comboBox	;
	KBMultiListBox		*m_listBox	;

	QString			m_userFilter	;
	QString			m_userSorting	;
	QStringList		*m_keyset	;
	KBLTValueSet		*m_valset	;

	QFocusEvent		*m_deferFocus	;
	QMouseEvent		*m_deferMouse	;

	bool			m_inSetValue	;

	void			setupDataProperties	() ;
	void			setupWidget		() ;

	void			loadDataValues		(const QValueList<const QStringList> &) ;

private slots :

	virtual void		clearWidget		() ;
	void			passFocus		() ;

protected :

	virtual bool		eventFilter	(QObject *, QEvent *) ;

public	:

	virtual	bool		isNavigationKey	(QKeyEvent *)	  ;
	virtual	void		setupProperties	()		  ;
	virtual	void		loadControl	(const QStringList &, const KBLTValueSet &) ;
	virtual	void		showAs		(KB::ShowAs)	  ;
	virtual	void		setValue   	(const KBValue &) ;
	virtual	KBValue		getValue   	()	;
	virtual	void		setFocus	()	;
	virtual	void		clearValue	(bool)	;
	virtual	bool		isEmpty		()	;
	virtual	bool		write		(KBWriter *, QRect, const KBValue &, bool, int &) ;
	virtual	void		setReadOnly	(bool, const QColor &, const QColor &)	;
	virtual	bool		isReadOnly	()	;

	virtual	QString		morphText	(int &)	;

	void			setUserFilter	(const QString &) ;
	void			setUserSorting	(const QString &) ;
	void			reload		() ;
	KBValue			getExtra	(bool, uint) ;
	bool			getDisplayList	(QStringList   &) ;
	bool			getNumValues	(uint &) ;
	bool			setCurrentDisplay
						(const QString &) ;

	void			setCurrentItem	(uint)	;
	uint			currentItem	()	;

	KBCtrlLink 				(KBDisplay *, KBLink *, uint) ;
	virtual	~KBCtrlLink 			() ;
}	;

#endif		// __KB_QTLINK_H
