/***************************************************************************
    file	         : kb_qtchoice.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	__KB_QTLISTBOX_H
#define	__KB_QTLISTBOX_H


#include	<qstringlist.h>

#include	"kb_classes.h"
#include	"kb_ctrl.h"

#include	"libkbase_exports.h"

class	KBListBox	;
class	RKListBox	;


/*  KBCtrlListBox							*/
/*  ------------							*/
/*  Wrapper class for choice combo box control				*/

class	LIBKBASE_API	KBCtrlListBox : public KBControl
{
	Q_OBJECT

	KBListBox		*m_listbox	;
	RKListBox		*m_qtListBox	;
	bool			m_inSetValue	;

public	:

	virtual	void		setupProperties	() ;
	virtual	void		setValues	(const QStringList &) ;
	virtual	void		showAs		(KB::ShowAs) ;
	virtual	void		setValue   	(const KBValue &) ;
	virtual	KBValue		getValue   	()	;
	virtual	void		clearValue	(bool)	;
	virtual	void		setReadOnly	(bool, const QColor &, const QColor &)	;
	virtual	bool		isReadOnly	()	;

	void			setCurrentItem	(uint)	;
	uint			currentItem	()	;

	KBCtrlListBox				(KBDisplay *, KBListBox *, uint) ;
	virtual	~KBCtrlListBox			() ;
}	;

#endif	// __KB_QTLISTBOX_H
