/***************************************************************************
    file	         : kb_qtmemo.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef		__KB_QTMEMO_H
#define		__KB_QTMEMO_H


#include	"kb_ctrl.h"
#include	"kb_textedit.h"
#include	"kb_field.h"


#include	"libkbase_exports.h"

class		KBMemo			;
class		KBSyntaxHighlighter	;
class		KBCtrlLinkTextEdit	;


/*  ------------------------------------------------------------------  */

/*  KBCtrlMemo								*/
/*  ----------								*/
/*  Wrapper class for memi edit control					*/

class	LIBKBASE_API	KBCtrlMemo : public KBControl
{
	Q_OBJECT

	KBMemo			*m_memo		;
	KBCtrlLinkTextEdit	*m_textEdit	;
	KBValue			m_iniVal	;
	KBSyntaxHighlighter	*m_highlighter	;

	bool			m_inSetValue	;
	QString			m_curHilite	;
	KBField::FocusCaret	m_pendingCaret	;

	void			setSelection	(KBField::FocusCaret) ;

protected slots :

	void			loadFromFile	()	;
	void			saveToFile	()	;
	void			slotSetSelection()	;

public	:

	virtual	void		setupProperties	()	;
	virtual	void		setPalette	(const QPalette *)	;
	virtual	void		setFont		(const QFont    *)	;
	virtual	void		showAs		(KB::ShowAs) ;
	virtual	void		setValue	(const KBValue &) ;
	virtual	KBValue		getValue	()	;
	virtual	void		clearValue	(bool)	;
	virtual	void		setReadOnly	(bool, const QColor &, const QColor &)	;
	virtual	bool		isReadOnly	()	;
	virtual	bool		write		(KBWriter *, QRect, const KBValue &, bool, int &) ;
	virtual bool		eventFilter	(QObject *, QEvent *)	;

	virtual	bool		viewSetFocusOK	()	;

	void			extendPopupMenu	(QPopupMenu *) ;

	KBCtrlMemo				(KBDisplay *, KBMemo *, uint) ;
	virtual	~KBCtrlMemo			()	;
}	;


#endif		// __KB_QTMEMO_H
