/***************************************************************************
    file	         : kb_qtpixmap.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_QTPIXMAP_H
#define		__KB_QTPIXMAP_H

#include	<qlabel.h>

#include	"kb_classes.h"
#include	"kb_ctrl.h"

#include	"libkbase_exports.h"

/*  KBCtrlPixmap							*/
/*  -----------								*/
/*  Wrapper class for image control					*/

class LIBKBASE_API	KBCtrlPixmap : public KBControl
{
	KBPixmap		*m_pmap		;
	QLabel			*m_label	;

protected :

	virtual	bool		eventFilter	(QObject *, QEvent *)	;
	virtual	void		setMonitor	(const KBValue &)	;

	virtual	void		dropEvent	(QDropEvent      *) ;
	virtual	void		dragEnterEvent	(QDragEnterEvent *) ;

public	:


	virtual	void		showAs		(KB::ShowAs) ;
	virtual	void		setupProperties	() ;
	virtual	void		setValue	(const KBValue &) ;
	virtual	void		clearValue	(bool) ;
	virtual	bool		isValid		(bool) ;
	virtual	bool		write		(KBWriter *, QRect, const KBValue &, bool, int &) ;

	void			saveImage	(const QString &, const char *) ;
	void			loadImage	(const QString &) ;

	KBCtrlPixmap 				(KBDisplay *, KBPixmap *, uint) ;
	virtual	~KBCtrlPixmap			 () ;
}	;


#endif	// _KB_QTPIXMAP_H
