/***************************************************************************
    file	         : kb_qtreplink.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_QTREPLINK_H
#define		__KB_QTREPLINK_H


#include	<qstrlist.h>

#include	"libkbase_exports.h"

#include	"kb_classes.h"
#include	"kb_ctrl.h"
#include	"rk_lineedit.h"


/*  KBCtrlRepLink							*/
/*  -------------							*/
/*  This class is used for link controls in reports, where what we	*/
/*  actually want is a line edit.					*/

class	LIBKBASE_API	KBCtrlRepLink : public KBControl
{
	KBLink				*m_link		;
	RKLineEdit			*m_lineEdit	;
	const KBLTValueSet		*m_valset	;

public	:

	virtual	void	setupProperties	()		  ;
//	virtual	void	setData		(void *)	  ;
	virtual	void	showAs		(KB::ShowAs)	  ;
	virtual	void	setValue   	(const KBValue &) ;
	virtual	KBValue	getValue   	()		  ;
	virtual	void	clearValue	(bool  )	  ;
	virtual	bool	write		(KBWriter *, QRect, const KBValue &, bool, int &) ;

	KBCtrlRepLink 			(KBDisplay *, KBLink *, uint) ;
	virtual	~KBCtrlRepLink 		() ;
}	;

#endif		// __KB_QTREPLINK_H
