/***************************************************************************
    file	         : kb_qtrichtext.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_QTRICHTEXT_H
#define	_KB_QTRICHTEXT_H


#include	"kb_classes.h"
#include	"kb_ctrl.h"
#include	"libkbase_exports.h"

#include	"rk_vbox.h"
#include	"rk_hbox.h"
#include	"rk_textbrowser.h"


class	KBRichText		;
class	KBCtrlRichText		;
class	KBCtrlRichTextWrapper	;
class	KBCtrlRichTextContainer	;

class	LIBKBASE_API	KBCtrlRichTextWrapper : public RKTextBrowser
{
	Q_OBJECT

	KBCtrlRichText	*m_richText ;

public slots :

	void			slotToggleBold		()	;
	void			slotToggleItalic	()	;
	void			slotToggleUnderline	()	;
	void			slotFontSizeUp		()	;
	void			slotFontSizeDown	()	;
	void			slotFont		()	;
	void			slotColor		()	;
	void			slotTextLeft		()	;
	void			slotTextRight		()	;
	void			slotTextCenter		()	;

public	:

	KBCtrlRichTextWrapper	(QWidget *, KBCtrlRichText *)	;

	virtual	void	emitLinkClicked	(const QString	&)	;
}	;


class	LIBKBASE_API	KBCtrlRichTextContainer : public RKVBox
{
	Q_OBJECT

	KBCtrlRichText		*m_richText	;
	RKHBox			*m_toolBar	;
	KBCtrlRichTextWrapper	*m_wrapper	;
	bool			m_toolBarInited	;

public	:

	KBCtrlRichTextContainer	(QWidget *, KBCtrlRichText *)	;
	KBCtrlRichTextWrapper	*wrapper	()		;

	void			setupToolBar	(bool, const QString &) ;
	virtual	void		setPalette	(const QPalette &)	;
	virtual	void		setFont		(const QFont    &)	;
}	;

/*  KBCtrlRichtext							*/
/*  --------------							*/
/*  Wrapper class for rich text control					*/

class	LIBKBASE_API	KBCtrlRichText : public KBControl
{
	Q_OBJECT

	KBRichText		*m_richText	;
	KBCtrlRichTextContainer	*m_container	;
	KBCtrlRichTextWrapper	*m_wrapper	;

public	:


	virtual	void		showAs		(KB::ShowAs) ;
	virtual	void		setupProperties	()	;
	virtual	void		setValue	(const KBValue &) ;
	virtual	KBValue		getValue	()	;
	virtual	void		clearValue	(bool)	;
	virtual	bool		write		(KBWriter *, QRect, const KBValue &, bool, int &) ;
	virtual bool		eventFilter	(QObject *, QEvent *)	;

	void			emitLinkClicked	(const QString &) ;

	KBCtrlRichText 				(KBDisplay *, KBRichText *, uint) ;
	virtual	~KBCtrlRichText 		() ;
}	;


#endif	// _KB_QTRICHTEXT_H
