/***************************************************************************
    file	         : kb_qtrowmark.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_QTROWMARK_H
#define	_KB_QTROWMARK_H

#include	<qlabel.h>

#include	"kb_classes.h"
#include	"kb_ctrl.h"

#include	"libkbase_exports.h"

/*  KBCtrlRowMark							*/
/*  -------------							*/
/*  Wrapper class for row mark widgets					*/

class LIBKBASE_API	KBCtrlRowMark : public KBControl
{
	KBRowMark	*m_rowmark	;
	QLabel		*m_label	;
	bool		m_current	;
	bool		m_inBlock	;
	KB::RState	m_state		;
	bool		m_showRow	;
	uint		m_rowNo		;

	void		showIcon	() ;

protected :

	virtual	bool	eventFilter	(QObject *, QEvent *)	;

public	:

	void			setState	(KB::RState)		;
	void			setCurrent  	(bool)			;
	void			setInBlock	(bool)			;
	void			setRowNumber	(uint)			;

	virtual	void		setupProperties	()	 ;
	virtual	void		clearValue	(bool  ) ;
	virtual	void		showAs		(KB::ShowAs) ;
	virtual	bool		write		(KBWriter *, QRect, const KBValue &, bool, int &) ;

	KBCtrlRowMark			(KBDisplay *, KBRowMark *, uint) ;
	virtual	~KBCtrlRowMark		() ;
}	;

#endif	// _KB_QTROWMARK_H
