/***************************************************************************
    file	         : kb_qtspinbox.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_QTSPINBOX_H
#define	_KB_QTSPINBOX_H

#include	<qspinbox.h>

#include	"kb_ctrl.h"
#include	"kb_mask.h"

#include	"libkbase_exports.h"

class	KBSpinBox		;
class	KBCtrlSpinBoxWrapper	;

/*  KBCtrlSpinBox							*/
/*  -------------							*/
/*  Wrapper class for spin box control					*/

class	LIBKBASE_API	KBCtrlSpinBox : public KBControl
{
	Q_OBJECT

	KBSpinBox		*m_spinbox	;
	KBCtrlSpinBoxWrapper	*m_qtSpinBox	;
	QWidget			*m_mainWidget	;

	bool			m_isNull	;

	QLineEdit		*m_editor	;
	QWidget			*m_spinner	;

protected slots :

	virtual bool		userChange	()	;

protected :

	virtual	QString		mapValueToText	(int)	;

public	:

	virtual	void		showAs		(KB::ShowAs) ;
	virtual	void		setValue	(const KBValue &) ;
	virtual	KBValue		getValue	()	;
	virtual	void		clearValue	(bool)	;
	virtual	bool		isEmpty		()	;
	virtual	bool		isValid		(bool)	;
	virtual	bool		write		(KBWriter *, QRect, const KBValue &, bool, int &) ;
	virtual	void		setupProperties	()	;

	virtual	QString		morphText	(int &) ;

	KBCtrlSpinBox 				(KBDisplay *, KBSpinBox *, uint) ;
	virtual	~KBCtrlSpinBox			() ;
}	;


#endif	// _KB_QTSPINBOX_H
