/***************************************************************************
    file	         : kb_qttabber.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_QTTABBER_H
#define		__KB_QTTABBER_H

#include	<qtabbar.h>

#include	"kb_classes.h"
#include	"kb_ctrl.h"

#include	"libkbase_exports.h"

class	KBTabberBar	;
class	KBDisplay	;

class	KBCtrlTabBar	;

/*  KBCtrlTabBar							*/
/*  ------------							*/
/*  Wrapper class for tabber tab control				*/

class	LIBKBASE_API	KBCtrlTabberBar : public KBControl
{
	KBTabberBar	*m_tabberBar	;
	KBCtrlTabBar	*m_qtTabBar	;

public	:

	KBCtrlTabberBar (KBDisplay *, KBTabberBar *) ;
virtual~KBCtrlTabberBar () ;

	int		addTab		(const QString &) ;
	void		setTabText	(int, const QString &) ;
	QRect		getTabRect	(int)	;
	void		removeTab	(int)	;

	int		getNumTabs	()	;
	int		getCurrentTab	()	;
	void		setCurrentTab	(int)	;
	void		setTabEnabled	(int, bool) ;

	virtual	bool	write		(KBWriter *, QRect, const KBValue &, bool, int &) ;
}	;

#endif		// __KB_QTTABBER_H

