/***************************************************************************
    file	         : kb_quicktext.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_QUICKTEXT_H
#define		__KB_QUICKTEXT_H


#if		! __KB_RUNTIME

#include	"libkbase_exports.h"
#include	"rk_lineedit.h"


/*  KBQuickText								*/
/*  -----------								*/
/*  This class provides a quick text edit widget, used to provide quick	*/
/*  editing of things like button and label text. Once started, it	*/
/*  allows updates until focus would leave the control, or enter is	*/
/*  pressed, at which point it posts an event.				*/

class	LIBKBASE_API	KBQuickText : public RKLineEdit
{
	Q_OBJECT

	QObject		*m_notify	;
	QEvent::Type	m_code		;
	bool		m_done		;

protected slots :

	void		slotReturn	() ;

protected :

	virtual	void	focusOutEvent	(QFocusEvent *)	;

public	:

	KBQuickText
	(	QWidget		*parent,
		QRect		geometry,
		const QString	&text,
		QObject		*notify,
		QEvent::Type	code
	)	;

	bool	eventFilter	(QObject *, QEvent *)	;
}	;

#endif		// ! __KB_RUNTIME
#endif		// __KB_QUICKTEXT_H
