/***************************************************************************
    file	         : kb_recentdb.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	<qstring.h>
#include	<qstringlist.h>
#include	<qdir.h>

#include	"tk_config.h"

#include	"libkbase_exports.h"

#include	"kb_dbinfo.h"
#include	"kb_errordlg.h"


void	LIBKBASE_API recentDatabases
	(	QStringList	&fileList,
		QStringList	&infoList
	)
{
	TKConfig *config = TKConfig::getConfig() ;
	config->setGroup ("RecentFiles") ;

	QStringList list ;

	KBErrorBlock eb (KBErrorBlock::None) ;

	for (int idx = 1 ; idx <= 10 ; idx += 1)
	{
		QString	file	= config->readEntry (QString("File%1").arg(idx)) ;
		if (file.isEmpty ()) continue ;

		file.replace	("$HOME", QDir::home().path(), false) ;
		fileList.append (file ) ;

		KBDBInfo dbInfo (file ) ;
		dbInfo.init	(false) ;

		QPtrListIterator<KBServerInfo>	*iter = dbInfo.getServerIter() ;
		KBServerInfo	*svInfo	;
		QStringList	info	;

		while ((svInfo = iter->current()) != 0)
		{
			const QString	&name	= svInfo->serverName () ;
			const QString	&comment= svInfo->comment    () ;

			if (!comment.isEmpty())
				info.append
				(	"<b>"	+
					name	+
					"</b><blockquote>" +
					comment	+
					"</blockquote>"
				)	;

			++(*iter) ;
		}

		delete	iter	;

		if (info.count() > 0)
			infoList.append	("<p>" + info.join("</p><p>") + "</p>") ;
		else	infoList.append	(QString::null) ;
	}
}
