/***************************************************************************
    file	         : kb_recorder.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_RECORDER_H
#define		__KB_RECORDER_H


#include	"libkbase_exports.h"

class	KBNode		;
class	KBValue		;
class	KBMacroExec	;
class	KBDocRoot	;
class	KBDBInfo	;
class	QString		;
class	QKeyEvent	;
class	KBTabber	;

class	LIBKBASE_API	KBRecorder
{
public	:

	enum	PopupType
	{
		PopupMessage	= 1,
		PopupQuery	= 2,
		PopupPrompt	= 3,
		PopupChoice	= 4
	}	;

private	:

	KBDocRoot		*m_docRoot	;
	KBMacroExec		*m_macro	;

	KBRecorder		()		;

public	:

	bool			start		(KBDocRoot *, KBDBInfo *, const QString &) ;
	bool			isRecording	(KBDocRoot *) ;
	KBMacroExec		*recording	() ;

	void			verifyValue
				(	KBItem		*item,
					uint		drow,
					const KBValue	&value
				)	;
	void			verifyRegexp
				(	KBItem		*item,
					uint		drow,
					const QString	&regexp
				)	;
	void			verifyText
				(	KBObject	*object,
					uint		drow,
					const QString	&text
				)	;
	void			verifyChoices
				(	KBItem		*item,
					uint		drow,
					const QString	&value
				)	;
	void			verifyState
				(	KBObject	*object,
					uint		drow,
					bool		,
					bool
				)	;
	void			verifyStack
				(	KBObject	*object,
					const QString	&page
				)	;
	void			updateValue
				(	KBItem		*item,
					uint		drow,
					const KBValue	&value
				)	;
	void			keyNavigation
				(	KBItem		*item,
					uint		drow,
					QKeyEvent	*key
				)	;
	void			mouseNavigation
				(	KBItem		*item,
					uint		drow
				)	;
	void			mouseClick
				(	KBObject	*object,
					uint		drow,
					const QString	&link
				)	;
	void			popupResult
				(	PopupType	type,
					bool		rc,
					const QString	&value
				)	;
	void			raisePage
				(	KBTabber	*tabber,
					const QString	&page
				)	;
					
	static KBRecorder	*self		() ;
}	;
#endif		// __KB_RECORDER_H
