/***************************************************************************
    file	         : kb_recordnav.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_RECORDNAV_H
#define		__KB_RECORDNAV_H


#include	<qframe.h>

#include	"kb_classes.h"
#include	"rk_hbox.h"
#include 	"libkbase_exports.h"

class	QLabel		;
class	RKPushButton	;
class	RKLineEdit	;

/*  KBRecordNav								*/
/*  -----------								*/
/*  This class provides a record navigation and record number tool for	*/
/*  use in blocks and elsewhere.					*/

class	LIBKBASE_API KBRecordNav : public RKHBox
{
	Q_OBJECT

	RKPushButton	*m_bFirst	;
	RKPushButton	*m_bPrevious	;
	QLabel		*m_lRecord	;
	RKLineEdit	*m_eRecordNo	;
	QLabel		*m_lRecordOf	;
	RKPushButton	*m_bNext	;
	RKPushButton	*m_bLast	;
	RKPushButton	*m_bAdd		;

signals :

	void		operation		(KB::Action, uint) ;

protected slots :

	void		slotClickFirst		() ;
	void		slotClickPrevious	() ;
	void		slotClickNext		() ;
	void		slotClickLast		() ;
	void		slotClickAdd		() ;
	void		slotReturnPressed	() ;

public	:

	KBRecordNav	(QWidget *, uint)	;

	void		setRecord	(uint, uint) ;

	static	uint	getHeight	()	;
}	;

#endif	// __KB_RECORDNAV_H
