/***************************************************************************
    file	         : kb_reportblock.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_REPORTBLOCK_H
#define		__KB_REPORTBLOCK_H

#include	"kb_block.h"

#include	"libkbase_exports.h"

class	LIBKBASE_API	KBYObject
{
public	:

	KBObject	*object	;
	uint		needs	;
	uint		y	;

	KBYObject	(KBObject *) ;
}	;

class	KBYSort : public QPtrList<KBYObject>
{
protected :

	int	compareItems (QCollection::Item, QCollection::Item) ;
}	;

/*  KBReportBlock							*/
/*  ------------							*/
/*  This class implements the block object when embedded in a report.	*/

class	LIBKBASE_API	KBReportBlock : public KBBlock
{
	Q_OBJECT

	KBAttrInt		pThrow	;
	KBYSort			ySort	;

	void			ySortObjects	()	;
	virtual	KBPopupMenu	*makeNewPopup	(KBPopupMenu *, QRect) ;

protected :

	void			addFramers	()	;
	void			startPage	()	;
	void			finishPage	(bool)	;

public	:

	virtual	KBNode		*replicate	(KBNode *) ;

	virtual	KBReportBlock	*isReportBlock	() { return this ; }

	virtual	void		setGeometry	(const QRect &) ;
	bool			showData	() ;
	virtual	KBValue		getValue	(uint) ;
	virtual	bool		setValue	(uint, const KBValue &) ;
	virtual	uint		rowsInBlock	() ;

public	slots :

	virtual void		docPropDlg	() ;

	virtual KBNode		*newNode	(int) ;
	virtual void		newTableBlock	() ;
	virtual void		newSQLBlock	() ;
	virtual void		newQueryBlock	() ;
	virtual void		addHeader	() ;
	virtual void		addFooter	() ;

public	:

	KBReportBlock 				(KBNode   *, const QDict<QString> &, cchar * = "KBReportBlock", bool * = 0) ;
	KBReportBlock 				(KBObject *, const QRect &, BlkType, bool  &, cchar * = "KBReportBlock") ;
	KBReportBlock 				(KBNode   *, KBReportBlock *) ;
	virtual	~KBReportBlock 			() ;
}	;

#endif		// __KB_REPORTBLOCK_H
