/***************************************************************************
    file	         : kb_richtext.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_RICHTEXT_H
#define	_KB_RICHTEXT_H

#include	"kb_classes.h"
#include	"kb_item.h"
#include	"kb_attrframe.h"
#include	"kb_attroptlist.h"

#include	"libkbase_exports.h"


/*  KBRichText								*/
/*  -----------								*/
/*  This class is used to represent a rich text element in the XML	*/
/*  form description. Note that it may map onto more than one actual	*/
/*  control.								*/

class	LIBKBASE_API	KBRichText : public KBItem
{
	Q_OBJECT

	KBAttrStr	m_fgcolor ;	/* Foreground (text) colour	*/
	KBAttrStr	m_bgcolor ;	/* Background colour		*/
	KBAttrStr	m_font	  ;	/* Report font			*/
	KBAttrFrame	m_frame	  ;	/* Frame style			*/
	KBAttrBool	m_supress ;	/* Supress repeats		*/
	KBAttrOptlist	m_toolbar ;
	KBEvent		m_onLink  ;	/* Link clicked			*/

	KBReport	*m_report ;	/* Embedding report		*/
	KBValue		m_lastVal ;	/* Last row value		*/

protected :

	virtual	KBControl	*makeCtrl	(uint)	;

public	:

	KBRichText	(KBNode  *, const QDict<QString> &, bool * = 0) ;
	KBRichText 	(KBNode  *, KBRichText *) ;
virtual~KBRichText	() ;

#if	! __KB_RUNTIME
	virtual	bool		propertyDlg	(cchar  *) ;
#endif
	virtual	KBNode		*replicate	(KBNode *) ;
	virtual	KBValue		getReportValue	(bool, bool = false) ;

	void			linkClicked	(uint, const QString &) ;
}	;

#endif	// _KB_RICHTEXT_H
