/***************************************************************************
    file	         : kb_rowcoldialog.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<qvaluelist.h>


#include	"kb_dialog.h"
#include	"kb_attrgeom.h"

class	KBAttrGeom	;
class	KBGridSetup	;
class	RKComboBox	;
class	QSpinBox	;
class	QFrame		;
class	QGridLayout	;
class	KBObject	;
class	KBDisplay	;
class	KBRowColPicker	;

/*  KBRowColDialog							*/
/*  --------------							*/
/*  Class to handle setup of row and column spacing and stretch values	*/
/*  for dynamic geometry management.					*/

class	KBRowColDialog : public KBDialog
{
	Q_OBJECT

	KBAttrGeom		&m_geom		;
	KBObject		*m_object	;
	KBDisplay		*m_display	;
	KBGridSetupList		m_rowSetup	;
	KBGridSetupList		m_colSetup	;

	RKComboBox		*m_rowSelect	;
	RKComboBox		*m_colSelect	;
	QSpinBox		*m_rowSpacing	;
	QSpinBox		*m_colSpacing	;
	QSpinBox		*m_rowStretch	;
	QSpinBox		*m_colStretch	;
	KBRowColPicker		*m_picker	;

	int			m_row		;
	int			m_col		;
	bool			m_lock		;

protected slots	:

	void		rowChanged	(int)	;
	void		colChanged	(int)	;
	void		settingChanged	()	;
	virtual void	accept		()	;

public	:

	KBRowColDialog	(KBAttrGeom &, KBObject *, uint = 0, uint = 0) ;
	~KBRowColDialog	()			;

	void		showRowCol	(uint, uint) ;
}	;

