/***************************************************************************
    file	         : kb_rowmark.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_ROWMARK_H
#define		__KB_ROWMARK_H


#include	"kb_classes.h"
#include	"kb_item.h"
#include	"kb_attrframe.h"

#include	"libkbase_exports.h"

/*  KBRowMarkData							*/
/*  -------------							*/
/*  A whole bunch of settings are passed to the rowmark control via the	*/
/*  KBRowMarkData structure.						*/

//struct	LIBKBASE_API	KBRowMarkData
//{
//	enum	Type
//	{	State,
//		Current,
//		InBlock,
//		RowNo,
//		Marked
//	}	;
//
//	Type	type	;
//
//	union
//	{	KB::RState	state	;
//		bool		current	;
//		bool		inBlock	;
//		uint		rowNo	;
//	}	;
//}	;

/*  KBRowMark								*/
/*  ---------								*/
/*  This class is used to represent a KBaseRowMark element in the XML	*/
/*  form description. Note that it may map onto more than one actual	*/
/*  field.								*/

class	LIBKBASE_API	KBRowMark : public KBItem
{
	Q_OBJECT

	KBAttrStr		m_bgcolor	;
	KBAttrFrame		m_frame		;
	KBAttrBool		m_showRow	;
	KBEvent			m_dblClick	;
	KBEvent			m_onClick	;
	uint			m_rcRow		;

protected :

	virtual	KBControl	*makeCtrl    (uint)	;

public	:

	virtual	bool		contextMenu	(QMouseEvent *, uint) ;

#if	! __KB_RUNTIME
	virtual	bool		propertyDlg	(cchar    *) ;
#endif
	virtual	KBNode		*replicate	(KBNode   *) ;

	void			setState	(uint, KB::RState)	;
	void			setCurrent  	(uint)			;
	void			setInBlock	(bool)			;
	void			setRowNumber	(uint)			;

	void			setTabOrder	(int)	;
	int			getTabOrder	()	;


	void			setRowMarked	(uint, KB::MarkOp) ;
	void			doSingleClick	(uint)	;

public	slots :

	void			insertRow	() ;
	void			deleteRow	() ;
	void			markSetAll	() ;
	void			markClearAll	() ;

public	:

	inline	bool	getShowRow	()
	{
		return	m_showRow.getBoolValue() ;
	}
	virtual	KBRowMark *isRowMark	()
	{
		return	this	;
	}

	KBRowMark				(KBNode  *, const QDict<QString> &, bool * = 0) ;
	KBRowMark				(KBNode  *, KBRowMark *) ;
	virtual	~KBRowMark			() ;
}	;


#if	! __KB_RUNTIME
extern LIBKBASE_API	bool	rowMarkPropDlg
			(	KBRowMark	*,
				cchar		*,
				QPtrList<KBAttr>	&
			)	;
#endif
#endif	// _KB_ROWMARK_H
