/***************************************************************************
    file	         : kb_skin.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_SKIN_H
#define		__KB_SKIN_H

#include	"libkbase_exports.h"

#include	<qstring.h>
#include	<qdict.h>

class	QDomElement	;


/*  KBSkinElement							*/
/*  -------------							*/
/*  Element in a skin; contains the element name and the set of values	*/
/*  associated with the name.						*/

class	LIBKBASE_API KBSkinElement
{
	QString		m_name		;
	QString		m_fgColor	;
	QString		m_bgColor	;
	QString		m_font		;

public	:

	KBSkinElement	(const QString &, const QString &, const QString &, const QString &) ;
	KBSkinElement	(const QDomElement &)	;

	const	QString		&name	()	const ;
	const	QString		&fgColor()	const ;
	const	QString		&bgColor()	const ;
	const	QString		&font	()	const ;

	void			save	(QDomElement &)	const ;
}	;


/*  KBSkin								*/
/*  ------								*/
/*  Class holding information for a skin, aka a style sheet, comprises	*/
/*  a name and a set of skin elements.					*/

class	LIBKBASE_API KBSkin
{
	QString			m_name		;
	QDict<KBSkinElement>	m_elements	;

public	:

	KBSkin	()			;
	KBSkin	(const QDomElement &)	;

	const	QString		&fgColor(const QString &) const ;
	const	QString		&bgColor(const QString &) const ;
	const	QString		&font	(const QString &) const ;

	void			save	(QDomElement   &) const ;

	void			setName	(const QString &)	;
	void			add	(const QString &, const QString &, const QString &, const QString &) ;

	const QDict<KBSkinElement>	&elements ()	  const ;
}	;

#endif		// __KB_SKIN_H
