/***************************************************************************
    file	         : kb_skindlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_SKINDLG_H
#define		__KB_SKINDLG_H


#include	"kb_dialog.h"
#include	"kb_location.h"

#include	"libkbase_exports.h"


class	KBSkinTable	;


/*  KBSkinDlg								*/
/*  ---------								*/
/*  Dialog used to edit skin (aka style sheet) definitions.		*/

class	LIBKBASE_API KBSkinDlg : public KBDialog
{
	Q_OBJECT

	KBLocation	m_location	;
	KBSkinTable	*m_table	;
	int		m_row		;
	int		m_col		;

	void		loadFromLocation	()	;
	void		saveToLocation		()	;
	bool		validate		()	;

protected slots :

	void		fixupRows		()	;
	void		edit			()	;
	void		clear			()	;
	void		insert			()	;
	void		remove			()	;
	void		contextMenu		(int, int)	;

	void		save			()	;
	void		saveAs			()	;

public	:

	KBSkinDlg
	(	QWidget			*,
		const KBLocation 	&,
		bool			= true,
		bool			= true
	)	;

	int		exec			()	;
	void		load			(const KBSkin	&) ;
	void		save			(KBSkin		&) ;

	const KBLocation&location		()	;
}	;

#endif		// __KB_SKINDLG_H
