/***************************************************************************
    file	         : kb_slotnotifier.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_SLOTNOTIFIER_H
#define	__KB_SLOTNOTIFIER_H

#include	<qobject.h>
#include	<qobject.h>
#include	<qvaluelist.h>

#include	"libkbase_exports.h"
#include	"kb_classes.h"

class	KBObject	;
class	KBSlot		;
class	KBValue		;
class	KBScriptError	;

/*  KBSlotNotifierEntry							*/
/*  -------------------							*/
/*  Slot notifier entry, records the slot along with its parent object	*/
/*  and the name of the event to which it should be attached.		*/
class	KBSlotNotifierEntry
{
public	:

	KBNode		*m_node		;
	KBSlot		*m_slot		;
	QString		m_name		;

	KBSlotNotifierEntry	()	;
	KBSlotNotifierEntry	(KBNode *, KBSlot *, const QString &) ;
}	;

/*  ------------------------------------------------------------------	*/

/*  KBSlotNotifier							*/
/*  --------------							*/
/*  Singleton class used to handle slot notifications. Maintains a list	*/
/*  of all connected slots, and handles firing of such slots.		*/

class	LIBKBASE_API	KBSlotNotifier : public QObject 
{
	Q_OBJECT

	QValueList<KBSlotNotifierEntry>	m_entries	;

protected slots	:

	void	slotDestroyed	(QObject *)	;

public	:

	static	KBSlotNotifier	*self	()	;

	void	add		(KBNode  *, KBSlot *, const QString &)	;
	void	remove		(KBSlot	  *)	;

	void	fire		(KBObject *, const QString &, uint, KBValue *, KBScriptError *&) ;
}	;

#endif	// __KB_SLOTNOTIFIER_H
