/***************************************************************************
    file	         : kb_spinbox.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef		__KB_SPINBOX_H
#define		__KB_SPINBOX_H

#include	"libkbase_exports.h"

#include	"kb_classes.h"
#include	"kb_item.h"
#include	"kb_qtspinbox.h"


/*  KBSpinBox								*/
/*  -----------								*/
/*  This class is used to represent a KBaseField element in the XML	*/
/*  form description. Note that it may map onto more than one actual	*/
/*  field.								*/

class	KBSpinBox : public KBItem
{
	Q_OBJECT

	KBAttrStr		m_fgcolor	;
	KBAttrStr		m_bgcolor	;
	KBAttrBool		m_nullOK	;
	KBAttrBool		m_morph		;
	KBEvent			m_onChange  	;

protected :

	virtual	KBControl	*makeCtrl	(uint)	  ;

public	:

#if	! __KB_RUNTIME
	virtual	bool		propertyDlg	(cchar  *) ;
#endif
	virtual	KBNode		*replicate	(KBNode *) ;
	virtual	bool		canBeInvalid	()	   ;
	virtual	bool		isMorphing	()	   ;

	inline	bool	allowNull ()
	{
		return	m_nullOK.getBoolValue() ;
	}

	KBSpinBox 				(KBNode  *, const QDict<QString> &, bool * = 0) ;
	KBSpinBox 				(KBNode  *, KBSpinBox *) ;
	virtual	~KBSpinBox 			() ;
}	;

#endif		// __KB_SPINBOX_H
