/***************************************************************************
    file	         : kb_tabpagedlg.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#if		__KB_AUTOMOC
#include	"kb_tabpagedlg.moc"
#else
#include	"kb_tabpagedlg.h"
#endif

#include	"kb_draglist.h"
#include	"kb_sidepanel.h"

#include	"rk_hbox.h"
#include	"rk_vbox.h"
#include	"rk_gridbox.h"
#include	"rk_pushbutton.h"
#include	"rk_listbox.h"



KBTabPageDlg::KBTabPageDlg
	(	QPtrList<KBTabberPage>	&pageList
	)
	:
	KBDialog	(TR("Set page order"), true),
	m_pageList	(pageList)
{
	RKVBox		*layTop  = new RKVBox	 (this) ;
	layTop->setTracking () ;

	RKHBox		*layMain = new RKHBox	 (layTop) ;
	new KBSidePanel (layMain, TR("Set page order")) ;

	RKVBox		*layButt = new RKVBox	 (layMain) ;

	m_bMoveUp	= new RKPushButton (TR("Move Up"),   layButt) ;
	layButt->addFiller () ;
	m_bMoveDown	= new RKPushButton (TR("Move Down"), layButt) ;

	m_pageListBox	= new KBDragBox	(layMain, m_bMoveUp, m_bMoveDown) ;

	for (KBTabberPage *page  = m_pageList.first() ;
			   page != 0 ;
			   page  = m_pageList.next ())
		new KBPageListBoxItem (m_pageListBox, page) ;

	addOKCancel	(layTop) ;

	m_pageListBox->setMinimumHeight (150) ;
}

void	KBTabPageDlg::accept ()
{
	m_pageList.clear () ;

	for (uint idx = 0 ; idx < m_pageListBox->count() ; idx += 1)
		m_pageList.append (((KBPageListBoxItem *)m_pageListBox->item(idx))->getPage()) ;

	done	(1) ;
}

/*  KBTabPageDlg							*/
/*  clickMoveUp	 : Handle click of the move-up button			*/
/*  (returns)	 : void		:					*/

void	KBTabPageDlg::clickMoveUp ()
{
	int		idx	;
	QListBoxItem	*cur	;

	if ((idx = m_pageListBox->currentItem()) <= 0) return ;
	if ((cur = m_pageListBox->item    (idx)) == 0) return ;

	m_pageListBox->takeItem       (cur) ;
	m_pageListBox->insertItem     (cur, idx - 1) ;
	m_pageListBox->setCurrentItem (cur) ;
}

/*  KBTabPageDlg							*/
/*  clickMoveDown: Handle click of the move-down button			*/
/*  (returns)	 : void		:					*/

void	KBTabPageDlg::clickMoveDown ()
{
	int		idx	;
	QListBoxItem	*cur	;

	if ((idx = m_pageListBox->currentItem())  < 0) return ;
	if ((cur = m_pageListBox->item    (idx)) == 0) return ;
	if (idx >= (int)m_pageListBox->count  ()  - 1) return ;

	m_pageListBox->takeItem       (cur) ;
	m_pageListBox->insertItem     (cur, idx + 1) ;
	m_pageListBox->setCurrentItem (cur) ;
}

