/***************************************************************************
    file	         : kb_tabpagedlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_TABPAGEDLG
#define	__KB_TABPAGEDLG

#if	! __KB_RUNTIME

#include	"libkbase_exports.h"

#include	"kb_tabber.h"
#include	"kb_dialog.h"

#include	"rk_listbox.h"

class		RKPushButton	;
class		RKListBox	;
class		KBDragBox	;

/*  KBPageListBoxItem							*/
/*  ----------------							*/
/*  This class is a wrapper round QListBoxText. It retains a a pointer	*/
/*  to the tab page with which it is associated.			*/


class	LIBKBASE_API	KBPageListBoxItem : public QListBoxText
{
	KBTabberPage	*m_page	;

public	:

	inline	KBPageListBoxItem
		(	RKListBox	*listBox,
			KBTabberPage	*page
		)
		:
		QListBoxText	(listBox, page->getAttrVal("tabtext")),
		m_page		(page)
	{
	}

	inline	KBTabberPage	*getPage ()
	{
		return	m_page	;
	}
}	;

class	LIBKBASE_API	KBTabPageDlg : public KBDialog
{
	Q_OBJECT	
	RKPushButton		*m_bMoveUp	;
	RKPushButton		*m_bMoveDown	;
	KBDragBox		*m_pageListBox	;
	QPtrList<KBTabberPage>	&m_pageList	;

protected slots :

	virtual	void		accept	      ();
	void			clickMoveUp   ();
	void			clickMoveDown ();

public	:

	KBTabPageDlg (QPtrList<KBTabberPage> &)	;
}	;

#endif
#endif	// __KB_TABPAGEDLG
