/***************************************************************************
    file	         : kb_testdlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_TESTDLG_H
#define	__KB_TESTDLG_H


#include	"rk_hbox.h"

#include	"kb_classes.h"
#include	"kb_dialog.h"
#include	"kb_options.h"


class	KBAttrItem	;
class	KBAttrEventItem	;
class	RKPushButton	;
class	RKListBox	;
class	RKLineEdit	;
class	RKTextEdit	;
class	KBEventBaseDlg	;


/*  KBTestListDlg							*/
/*  -------------							*/
/*  This dialog (which is actually derived from an RKHBox and is	*/
/*  intended to be embedded in a real dialog) is used to select amongst	*/
/*  a list of tests.							*/

class	LIBKBASE_API	KBTestListDlg : public RKHBox
{
	Q_OBJECT

	const QPtrList<KBTest> 		&m_testList	;
	KBNode				*m_node		;

	RKListBox			*m_lbTestList	;
	RKPushButton			*m_bAddTest	;
	RKPushButton			*m_bEditTest	;
	RKPushButton			*m_bDropTest	;

	QString				m_openTest	;

protected slots :

	void			clickAddTest	()	;
	void			clickEditTest	()	;
	void			clickDropTest	()	;
	void			highlighted	()	;
	void			slotOpenTest	()	;

public	:

	KBTestListDlg		(QWidget *, const QPtrList<KBTest> &, KBNode *) ;

	void			openTest	(const QString	  &)	;
	void			save		(QPtrList<KBTest> &)	;
}	;


/*  KBTestDlg								*/
/*  ---------								*/
/*  Dialog for editing tests. Most of the functionality is in the	*/
/*  KBEventBaseDlg class.						*/

class	LIBKBASE_API KBTestDlg	: public KBDialog
{
	Q_OBJECT

	const QPtrList<KBTest> 		&m_testList	;
	KBTest				*m_test		;
	KBNode				*m_parent	;
	KBEventBaseDlg			*m_eventDlg	;
	RKLineEdit			*m_name		;
	RKTextEdit			*m_comment	;
	RKPushButton			*m_bOK		;
	KBOptions::ScriptType		m_showing	;

protected slots :

	void			nameChanged	() ;
	void			clickVerify	() ;
	virtual void		accept		() ;

public	:

	KBTestDlg	(KBTest *, const QPtrList<KBTest> &, KBNode *) ;
}	;

#endif	// __KB_TESTDLG_H
