/***************************************************************************
    file	         : kb_testsuite.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		_KB_TESTSUITE
#define		_KB_TESTSUITE

#include	"kb_node.h"
#include	"kb_test.h"

#include	"libkbase_exports.h"

class	KBTestSuiteResultsDlg	;
class	KBDocRoot		;

class	LIBKBASE_API	KBTestSuite : public KBNode
{
	KBAttrBool	m_transaction	;
	KBAttrUInt	m_maxErrors	;
	KBAttrStr	m_initialise	;
	KBAttrStr	m_setup		;
	KBAttrStr	m_teardown	;
	KBAttrStr	m_reset		;
	KBAttrStr	m_testList	;

	KBTest		 *findTest	(const QString  &) ;
	KBTest::ErrorOpt executeTest	(KBTest::ErrorOpt, KBTest *) ;

public	:

	virtual	KBNode		*replicate 	(KBNode *) ;

	virtual	KBTestSuite	*isTestSuite 	() { return this ; }

	KBTestSuite		(KBNode *, const QDict<QString> &, bool * = 0) ;
	KBTestSuite		(KBNode *, KBTestSuite *) ;
       ~KBTestSuite		() ;

#if	! __KB_RUNTIME
	bool			transaction	()	;
	uint			maxErrors	()	;
	QString			initialise	()	;
	QString			setup		()	;
	QString			teardown	()	;
	QString			reset		()	;
	QString			testList	()	;

	void			setTransaction	(bool)	;
	void			setMaxErrors	(uint)	;
	void			setInitialise	(const QString &) ;
	void			setSetup	(const QString &) ;
	void			setTeardown	(const QString &) ;
	void			setReset	(const QString &) ;
	void			setTestList	(const QString &) ;

	KBTest::ErrorOpt	executeTests	(KBTest::ErrorOpt, bool = false) ;
	void			execute		(KBTest::ErrorOpt, bool = false) ;

	static void		executeStart	(KBDocRoot *)	;
	static void		executeFinish	(KBDocRoot *)	;
	static bool		executeResults	(KBDocRoot *, KBTestSuiteResultsDlg &) ;
#endif
}	;



#endif	// _KB_TESTSUITE
