/***************************************************************************
    file	         : kb_testsuitedlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	_KB_TESTSUITEDLG_H
#define	_KB_TESTSUITEDLG_H

#if	! __KB_RUNTIME


#include	<qptrlist.h>

#include	"kb_param.h"
#include	"kb_dialog.h"
#include	"kb_paramsetdlg.h"
#include	"libkbase_exports.h"

#include	"rk_vbox.h"
#include	"rk_hbox.h"

class	RKPushButton	;
class	RKListBox	;
class	RKLineEdit	;
class	RKComboBox	;
class	QCheckBox	;
class	QSpinBox	;

class	LIBKBASE_API	KBTestSuiteList : public RKHBox
{
	Q_OBJECT

	KBForm		*m_root			;
	RKListBox	*m_testSuiteList	;
	RKPushButton	*m_bAdd			;
	RKPushButton	*m_bEdit		;
	RKPushButton	*m_bRemove		;

protected slots :

	void		clickAdd	() ;
	void		clickEdit	() ;
	void		clickRemove	() ;

public	:

	KBTestSuiteList	(QWidget *, KBForm *, QPtrList<KBTestSuite> &) ;

	void		fixUp		(QPtrList<KBTestSuite> &) ;
	QString		getText		() ;
}	;

/*  ------------------------------------------------------------------	*/

/*  KBTestSuiteDlg							*/
/*  --------------							*/
/*  This class is used as a component in the form and report properties	*/
/*  dialogs to handle setup of test suites.				*/

class	LIBKBASE_API	KBTestSuiteDlg : public KBDialog
{
	Q_OBJECT

	KBForm		*m_root		;
	RKLineEdit	*m_name		;
	RKComboBox	*m_initialise	;
	RKComboBox	*m_setup	;
	RKComboBox	*m_teardown	;
	RKComboBox	*m_reset	;
	RKListBox	*m_tests	;
	QCheckBox	*m_transaction	;
	QSpinBox	*m_maxErrors	;

	RKListView	*m_allTests	;
	RKPushButton	*m_bAdd		;
	RKPushButton	*m_bRemove	;
	RKPushButton	*m_bUp		;
	RKPushButton	*m_bDown	;
	RKPushButton	*m_bOK		;


	void		expandAll	(QListViewItem *) ;
	void		findAllTests	(KBNode *, QListViewItem *) ;

protected slots :

	void		clickAdd	()	;
	void		clickRemove	()	;
	void		clickUp		()	;
	void		clickDown	()	;
	void		clickExpand	()	;
	void		setButtons	()	;
	void		selectionChanged(QListViewItem *) ;

public	:

	KBTestSuiteDlg
		(	KBForm		*,
			const QString	&,
			bool		,
			uint		,
			const QString	&,
			const QString	&,
			const QString	&,
			const QString	&,
			const QString	&
		)	;

	QString		name		()	;
	bool		transaction	()	;
	uint		maxErrors	()	;
	QString		initialise	()	;
	QString		setup		()	;
	QString		teardown	()	;
	QString		reset		()	;
	QString		testList	()	;
}	;


#endif
#endif	// _KB_TESTSUITEDLG_H
