/***************************************************************************
    file	         : kb_urlrequest.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_URLREQUEST_H
#define	__KB_URLREQUEST_H


#include	"libkbase_exports.h"

#include	<qstring.h>
#include	<qurl.h>
#include	<qhttp.h>

#include	"kb_databuffer.h"

class	KBError			;
class	KBObject		;
class	QObject			;
class	QHttpResponseHeader	;

/*  KBURLRequest							*/
/*  -------------							*/

class	LIBKBASE_API	KBURLRequest : public QHttp
{
public	:

	enum	State
	{
		Error		= 0,
		ProgressMessage	= 1,
		Progress	= 2,
		Finished	= 3
	}	;

private	:

	Q_OBJECT

	QUrl		m_url			;
	QString		m_what			;
	KBObject	*m_notify		;
	QString		m_slotName		;
	KBSlot		*m_slot			;
	KBDataBuffer	m_data			;

	int		m_URLSetHostID		;
	int		m_URLGetID		;
	bool		m_active		;

	bool		m_inSlot		;
	bool		m_immolate		;

	void		notifySlot	(State, const QString &) ;

	void		setURLError	()	;
	void		setProgress	(const QString &) ;
	void		setProgress	(int, int	) ;

protected slots	:

	void		slotURLStarted	(int)		  ;
	void		slotURLFinished	(int, bool)	  ;
	void		slotURLProgress	(int, int )	  ;
	void		slotURLReady	(const QHttpResponseHeader &) ;
	void		slotShowingAs	(KB::ShowAs)	  ;

public	:

	KBURLRequest			(KBObject *, const QString &) ;
	virtual	~KBURLRequest		() ;

	void		exec		(const QString &, const QString &) ;
	void		halt		() ;
	bool		active		() ;
}	;

#endif	// __KB_URLREQUEST_H
