/***************************************************************************
    file	         : kb_stockdb.h
    copyright            : (C) 1999,2000,2001,2002,2003,2004 by Mike Richardson
			   (C) 2001,2002,2003,2004 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef		__KB_STOCKDB_H
#define		__KB_STOCKDB_H

#include	"kb_classes.h"
#include	"kb_wizard.h"
#include	"kb_dbspecification.h"
#include	"kb_downloader.h"

#include	"libwizard_exports.h"



class	RKComboBox	;
class	RKPushButton	;
class	QTextBrowser	;
class	QWidgetStack	;
class	QProgressBar	;
class	RKVBox		;

/*  KBWizardCtrlStockDB							*/
/*  -------------------							*/
/*  Wizard control for accessing stock database definitions.		*/

class	LIBWIZARD_API	KBWizardCtrlStockDB : public KBWizardCtrl, public KBDownloader
{
	Q_OBJECT

	RKComboBox		*m_location	;
	RKPushButton		*m_bFetch	;

	QWidgetStack		*m_progress	;
	RKLineEdit		*m_progressText	;
	QProgressBar		*m_progressBar	;

	QTextBrowser		*m_details	;
	RKComboBox		*m_databases	;

	RKPushButton		*m_bFinish	;

	QString			m_specification	;
	KBDBSpecification	m_dbSpec	;

protected slots :

	void		slotFetch 		()	;
	void		slotDatabase		()	;

protected	:

	virtual	void	setError	(const KBError &) ;
	virtual	void	setError	(const QString &, const QString & = QString::null) ;

	virtual	void	setProgress	(const QString &) ;
	virtual	void	setProgress	(int, int )	  ;

	virtual	void	downloadData	(const QByteArray &)	;
	virtual	void	downloadComplete()		  	;

public	:

	KBWizardCtrlStockDB
	(	KBWizardPage		*,
		const QDomElement	&
	)	;

	virtual	~KBWizardCtrlStockDB	()	;

	virtual	bool	ok		()	;
	virtual	void	setValue	(const QString &) ;
	virtual	QString	value		()	;		

	virtual	QVariant
			attribute	(const QString &) ;
}	;

#endif	// __KB_STOCKDB_H
