/***************************************************************************
    file	         : kb_wizcolor.cpp
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	"kb_classes.h"

#if		__KB_AUTOMOC
#include	"kb_wizcolor.moc"
#else
#include	"kb_wizcolor.h"
#endif

#include	"tk_config.h"
#include	"tk_colordialog.h"

#include	"rk_hbox.h"
#include	"rk_vbox.h"
#include	"rk_lineedit.h"
#include	"rk_pushbutton.h"


/*  KBWizardCtrlColor							*/
/*  KBWizardCtrlColor							*/
/*		: Constructor for color wizard control			*/
/*  page	: KBWizardPage *	: Parent wizard page		*/
/*  elem	: QDomElement &		: Definition element		*/

KBWizardCtrlColor::KBWizardCtrlColor
	(	KBWizardPage		*page,
		const QDomElement	&elem
	)
	:
	KBWizardCtrl	(page, elem.attribute("name")),
	m_type		(elem.attribute ("type"))
{
	RKVBox		*cntr	= new RKVBox	   (page) ;

	m_wizColor 		= new RKLineEdit   (cntr) ;
	m_wizColor->setReadOnly (true)  ;

	RKHBox		*btns	= new RKHBox	   (cntr) ;
	RKPushButton	*set	= new RKPushButton (TR("Set"  ), btns) ;
	RKPushButton	*clear	= new RKPushButton (TR("Clear"), btns) ;

	KBDialog::setupLayout	(cntr)	 ;

	setWidget (cntr) ;

	connect
	(	set,
		SIGNAL(clicked	     ()),
		SLOT  (slotSetColor  ())
	)	;
	connect
	(	clear,
		SIGNAL(clicked	     ()),
		SLOT  (slotClearColor())
	)	;

	TKConfig *config = TKConfig::getConfig() ;
	config->setGroup ("Wizard Color")	 ;
	m_wizColor->setText(config->readEntry(m_type)) ;
}

KBWizardCtrlColor::~KBWizardCtrlColor ()
{
}

void	KBWizardCtrlColor::slotSetColor ()
{
	TKColorDialog  cDialog (0, TR("Color"), true) ;
	cDialog.setColor (m_wizColor->text()) ;

	if (cDialog.exec())
	{
		QString	res ;
		res.sprintf ("0x%06x", cDialog.color().rgb() & 0x00ffffff) ;
		m_wizColor->setText (res) ;
		ctrlChanged() ;
	}
}

void	KBWizardCtrlColor::slotClearColor ()
{
	m_wizColor->setText (QString::null) ;
}

void	KBWizardCtrlColor::setValue
	(	const QString	&value
	)
{
	m_wizColor->setText (value) ;
}

/*  KBWizardCtrlColor							*/
/*  value	: Get value						*/
/*  (returns)	: QString	: Value					*/

QString	KBWizardCtrlColor::value ()
{
	return	m_wizColor->text () ;
}

void	KBWizardCtrlColor::save
	(	int
	)
{
	TKConfig *config = TKConfig::getConfig() ;
	config->setGroup   ("Wizard Color")       ;
	config->writeEntry (m_type, m_wizColor->text()) ;
}

WIZARDCTRLREG(Color)
