#include	"kb_dbinfo.h"
#include	"kb_serverinfo.h"
#include	"kb_location.h"
#include	"kb_wizcontrol.h"

#include	"kb_locator.h"


/*  KBWizardKBControl							*/
/*  KBWizardKBControl							*/
/*		: Constructor for button wizard				*/
/*  location	: KBLocation &	   : Dummy location			*/
/*  server	: const QString &  : Server name			*/
/*  wizName	: const QString &  : Wizard name			*/
/*  (returns)	: KBWizardKBControl:					*/

KBWizardKBControl::KBWizardKBControl
	(	KBLocation	&location,
		const QString	&server,
		const QString	&wizName
	)
	:
	KBWizard   (location.dbInfo(), server),
	m_location (location),
	m_wizName  (wizName)
{
}

/*  KBWizardKBControl							*/
/*  exec	: Execute wizard					*/
/*  (returns)	: int		: DIalog exit code			*/

int	KBWizardKBControl::exec ()
{
	/* Locate the wizard definition and initialise the wizard,	*/
	/* checking for errors, not that there should be any thus far.	*/
	QString	wizXML	= locateFile ("appdata", "wizards/wiz" + m_wizName + ".wiz") ;
	if (wizXML.isNull())
	{
		KBError::EError
		(	QString(TR("Cannot locate wizard specification")),
			m_wizName,
			__ERRLOCN
		)	;
		return	0 ;
	}

	if (!init (wizXML))
	{	lastError().DISPLAY() ;
		return	0 ;
	}

	return	KBWizard::execute () ;
}

int	KBWizardKBControl::execute ()
{
	return	KBWizardKBControl::exec () ;
}
