/***************************************************************************
    file	         : kb_wizdbtype.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_WIZDBTYPE_H
#define	__KB_WIZDBTYPE_H

#include	"kb_wizard.h"
#include	"kb_database.h"

#include	"libwizard_exports.h"

class		RKComboBox	;
class		QTextBrowser	;


/*  KBWizardCtrlDBType							*/
/*  ------------------							*/
/*  Class used to present selection of database drivers to the user.	*/
/*  The control shows the driver comment but returns the driver tag.	*/

class	LIBWIZARD_API KBWizardCtrlDBType : public KBWizardCtrl
{
	Q_OBJECT

	RKComboBox		*m_dbType	;
	QTextBrowser		*m_info		;
	KBDriverDetailsList	m_drvList	;
	QStringList		m_accept	;

	void		loadTypes	()	;

protected slots :

	void		slotTypeChanged	(int)	;

public	:

	KBWizardCtrlDBType
	(	KBWizardPage		*,
		const QDomElement	&
	)	;

	virtual	~KBWizardCtrlDBType	()	;

	virtual	QVariant
			attribute	(const QString &) 	;

	virtual	void	setValueList	(const QStringList &)   ;
	virtual	void	setValue	(const QString &) 	;
	virtual	QString	value		()	;		
}	;

#endif	// __KB_WIZDBTYPE_H
