/***************************************************************************
    file	         : kb_wizedit.cpp
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	"kb_classes.h"
#include	"kb_dbdociter.h"

#if		__KB_AUTOMOC
#include	"kb_wizedit.moc"
#else
#include	"kb_wizedit.h"
#endif

KBWizardCtrlEdit::KBWizardCtrlEdit
	(	KBWizardPage		*page,
		const QDomElement	&elem
	)
	:
	KBWizardCtrl	(page, elem.attribute("name"))
{
	setWidget	(m_textedit = new QTextEdit (page)) ;
	setWide		(true) ;

	m_textedit->setTextFormat ((Qt::TextFormat)elem.attribute("mode", QString::number(Qt::PlainText)).toInt()) ;

	connect
	(	m_textedit,
		SIGNAL(textChanged()),
		SLOT  (ctrlChanged())
	)	;
}

KBWizardCtrlEdit::~KBWizardCtrlEdit ()
{
}

void	KBWizardCtrlEdit::setValue
	(	const QString	&value
	)
{
	m_textedit->setText (value) ;
}

/*  KBWizardCtrlEdit							*/
/*  value	: Get value						*/
/*  (returns)	: QString	: Value					*/

QString	KBWizardCtrlEdit::value ()
{
	return	m_textedit->text() ;
}

WIZARDCTRLREG(Edit)
