/***************************************************************************
    file	         : kb_wizobjlist.cpp
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	"rk_combobox.h"

#include	"kb_classes.h"
#include	"kb_dbdociter.h"

#if		__KB_AUTOMOC
#include	"kb_wizobjlist.moc"
#else
#include	"kb_wizobjlist.h"
#endif

KBWizardCtrlObjList::KBWizardCtrlObjList
	(	KBWizardPage		*page,
		const QDomElement	&elem
	)
	:
	KBWizardCtrl	(page, elem.attribute("name"))
{
	setWidget	(m_objlist = new RKComboBox (page)) ;
	loadObjects	(elem.attribute("type"), elem.attribute("extn")) ;

	connect
	(	m_objlist,
		SIGNAL(activated      (int)),
		SLOT  (ctrlChanged    ())
	)	;
	connect
	(	m_objlist,
		SIGNAL(activated      (int)),
		SLOT  (slotTypeChanged(int))
	)	;
}

KBWizardCtrlObjList::~KBWizardCtrlObjList ()
{
}

void	KBWizardCtrlObjList::setValue
	(	const QString	&value
	)
{
	for (int idx = 0 ; idx < m_objlist->count() ; idx += 1)
		if (m_objlist->text(idx) == value)
		{	m_objlist->setCurrentItem (idx) ;
			break	;
		}
}

/*  KBWizardCtrlObjList							*/
/*  value	: Get value						*/
/*  (returns)	: QString	: Value					*/

QString	KBWizardCtrlObjList::value ()
{
	return	m_objlist->currentText() ;
}

void	KBWizardCtrlObjList::loadObjects
	(	const QString	&type,
		const QString	&extn
	)
{
	KBDBDocIter	docIter ;
	KBError		error	;

	fprintf
	(	stderr,
		"KBWizardCtrlObjList::loadObjects@ server=[%s] type=[%s] extn=[%s]\n",
		(cchar *)page()->wizard()->server(),
		(cchar *)type,
		(cchar *)extn
	)	;

	if (!docIter.init
		(	page()->wizard()->dbInfo(),
			page()->wizard()->server(),
			type,
			extn,
			error
	   ))
	{	error.DISPLAY() ;
		return		;
	}

	QString	name	;
	QString	stamp	;

	while (docIter.getNextDoc (name, stamp))
	{
		m_objlist->insertItem (name) ;
	}
}

WIZARDCTRLREG(ObjList)
