/***************************************************************************
    file	         : kb_wizorder.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_WIZORDER_H
#define	__KB_WIZORDER_H


#include	"kb_classes.h"
#include	"kb_database.h"
#include	"kb_wizard.h"
#include	"kb_listboxpair.h"

#include	"libwizard_exports.h"


class	RKListBox	;

class	LIBWIZARD_API KBWizOrderSpecList : public KBListBoxPair
{
public	:

	KBWizOrderSpecList
	(	RKListBox    	*, RKListBox   	*,
		RKPushButton	*, RKPushButton *,
		RKPushButton	*, RKPushButton *,
		RKPushButton	*,
		bool = false
	)	;

	virtual	QListBoxItem	*replicate (QListBoxItem *) ;

}	;


/*  KBWizardCtrlOrder							*/
/*  -----------------							*/
/*  Wizard control used to allow selection of field order (for instance	*/
/*  for sorting. Uses the KBListBoxPair class to handle addition and	*/
/*  removal, and ordering.						*/

class	LIBWIZARD_API KBWizardCtrlOrder : public KBWizardCtrl
{
	Q_OBJECT

	QString			m_sourceName	;

	QWidget			*m_widget	;
	RKListBox		*m_source	;
	RKListBox		*m_dest		;
	RKPushButton		*m_bAdd		;
	RKPushButton		*m_bAddAll	;
	RKPushButton		*m_bRemove	;
	RKPushButton		*m_bMoveUp	;
	RKPushButton		*m_bMoveDown	;
	KBWizOrderSpecList	*m_lbPair	;


public	:

	KBWizardCtrlOrder
	(	KBWizardPage		*,
		const QDomElement	&
	)	;

	virtual	~KBWizardCtrlOrder	()	;

	virtual	void	pageShown	(bool)	;

	virtual	QVariant
			attribute	(const QString &) ;
	virtual	void	setValue	(const QString &) ;
	virtual	QString	value		()	;		

	virtual	bool	ok		()	;
}	;

#endif	// __KB_WIZORDER_H
