/***************************************************************************
    file	         : kb_wizrecentdb.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	<qdir.h>
#include	<qtextbrowser.h>
#include	<qlistbox.h>

#include	"rk_combobox.h"
#include	"tk_config.h"

#include	"kb_classes.h"

#if		__KB_AUTOMOC
#include	"kb_wizrecentdb.moc"
#else
#include	"kb_wizrecentdb.h"
#endif


/*  KBWizardCtrlRecentDB						*/
/*  KBWizardCtrlRecentDB						*/
/*		: Constructor for script language wizard control	*/
/*  page	: KBWizardPage *      : Parent page			*/
/*  elem	: const QDomElement & : Definition			*/
/*  (returns)	: KBWizardCtrlRecentDB  :				*/

KBWizardCtrlRecentDB::KBWizardCtrlRecentDB
	(	KBWizardPage		*page,
		const QDomElement	&elem
	)
	:
	KBWizardCtrl	 (page, elem.attribute("name"))
{
	setWidget	 (m_db   = new RKComboBox   (false, page)) ;
	page->setInfoCtrl(m_info = new QTextBrowser (page)) ;

	void recentDatabases (QStringList &, QStringList &) ;
	recentDatabases	 (m_fileList, m_infoList) ;

	m_db->insertStringList	(m_fileList) ;
	slotDBChanged		()	     ;

	connect
	(	m_db,
		SIGNAL(activated	(int)),
		SLOT  (slotDBChanged	())
	)	;
}

/*  KBWizardCtrlRecentDB						*/
/*  ~KBWizardCtrlRecentDB						*/
/*		: Destructor for script language wizard control		*/
/*  (returns)	:		:					*/

KBWizardCtrlRecentDB::~KBWizardCtrlRecentDB ()
{
}

/*  KBWizardCtrlRecentDB						*/
/*  slotDBChanged: Used changes database selection			*/
/*  (returns)	 : void		:					*/

void	KBWizardCtrlRecentDB::slotDBChanged ()
{
	int	idx	= m_db->currentItem() ;
	if (idx >= 0)
		m_info->setText (m_infoList[idx]) ;
	else	m_info->setText (QString::null  ) ;
}

/*  KBWizardCtrlRecentDB						*/
/*  setValue	: Set current value					*/
/*  value	: const QString & : Required value			*/
/*  (returns)	: void		  :					*/

void	KBWizardCtrlRecentDB::setValue
	(	const QString	&
	)
{
	/* Never used ...						*/
}

/*  KBWizardCtrlRecentDB						*/
/*  value	: Get value						*/
/*  (returns)	: QString	: Value					*/

QString	KBWizardCtrlRecentDB::value ()
{
	return	m_db->currentText () ;
}

WIZARDCTRLREG(RecentDB)
