/***************************************************************************
    file	         : kb_wizscript.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_WIZSCRIPT_H
#define	__KB_WIZSCRIPT_H

#include	"kb_wizard.h"
#include	"kb_database.h"

#include	"libwizard_exports.h"

class		RKComboBox	;
class		QTextBrowser	;


/*  KBWizardCtrlScript							*/
/*  ------------------							*/
/*  Class used to present selection of database drivers to the user.	*/
/*  The control shows the driver comment but returns the driver tag.	*/

class	LIBWIZARD_API KBWizardCtrlScript : public KBWizardCtrl
{
	Q_OBJECT

	RKComboBox		*m_script	;
	QTextBrowser		*m_info		;

	void		loadLanguages	()	;

protected slots :

	void		slotLangChanged	(int)	;

public	:

	KBWizardCtrlScript
	(	KBWizardPage		*,
		const QDomElement	&
	)	;

	virtual	~KBWizardCtrlScript	()	;

	virtual	void	setValue	(const QString &) 	;
	virtual	QString	value		()	;		

	inline	RKComboBox *comboBox	()
	{
		return	m_script	;
	}
}	;

#endif	// __KB_WIZSCRIPT_H
