/***************************************************************************
    file	         : kb_wizsubform.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__KB_WIZSUBFORM_H
#define		__KB_WIZSUBFORM_H

#include	<qpushbutton.h>

#include	"kb_classes.h"
#include	"kb_dialog.h"
#include	"kb_wizard.h"
#include	"kb_wizsource.h"
#include	"kb_wizfields.h"


/*  KBWizardSubForm							*/
/*  ------------							*/
/*  Wizard class for creation of forms.					*/

class	KBWizardSubForm : public KBWizard
{
	KBLocation	&m_location	;

public	:

	KBWizardSubForm	(KBLocation &, const QString &) ;

	int		exec	() ;
	void		create	() ;

	inline	KBWizardCtrlDataSource::Type sourceType	()
	{
		return	(KBWizardCtrlDataSource::Type)ctrlAttribute	("source", "object", "type"  ).toInt	   () ;
	}

	inline	QString		sourceName	() { return ctrlValue		("source", "object"  ) ; }
	inline	QStringList	fields		() { return ctrlAttribute 	("fields", "fields", "fields").toStringList() ; }
	inline	int		layout		() { return ctrlAttribute 	("layout", "layout", "index" ).toInt	   () ; }
	inline	bool		stretch		() { return ctrlValue		("layout", "stretch"	     ).toInt	   () ; }
	inline	bool		move		() { return ctrlValue		("navi",   "move"	     ).toInt	   () ; }
	inline	bool		update		() { return ctrlValue		("navi",   "update"	     ).toInt	   () ; }
	inline	int		scroll		() { return ctrlAttribute	("navi",   "scroll", "index" ).toInt	   () ; }
	inline	int		mode		() { return ctrlAttribute	("final",  "mode",   "index" ).toInt	   () ; }
	inline	QString		caption		() { return ctrlValue		("names",  "caption" ) ; }
	inline	QString		name		() { return ctrlValue		("names",  "name"    ) ; }

	inline	void	fieldList
		(	QPtrList<KBFieldSpec>	&fieldList
		)
	{
		((KBWizardCtrlFields *)findCtrl("fields", "fields"))->fields (fieldList) ;
	}

	virtual	int		execute		() ;
}	;


#endif		// __KB_WIZSUBFORM_H
