/***************************************************************************
    file	         : kb_wizwizfile.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	"kb_classes.h"
#include	"kb_database.h"
#include	"kb_serverinfo.h"

#if		__KB_AUTOMOC
#include	"kb_wizwizfile.moc"
#else
#include	"kb_wizwizfile.h"
#endif

#include	"rk_hbox.h"
#include	"rk_lineedit.h"
#include	"rk_pushbutton.h"

/*  KBWizardCtrlWizFile							*/
/*  KBWizardCtrlWizFile							*/
/*		: Constructor for file locator wizard control		*/
/*  page	: KBWizardPage *	: Parent wizard page		*/
/*  elem	: QDomElement &		: Definition element		*/

KBWizardCtrlWizFile::KBWizardCtrlWizFile
	(	KBWizardPage		*page,
		const QDomElement	&elem
	)
	:
	KBWizardCtrl	(page, elem.attribute("name"))
{
	RKHBox		*cntr	= new RKHBox (page) ;
	m_wizFile 		= new RKLineEdit   (cntr) ;
	RKPushButton	*btn	= new RKPushButton (cntr) ;

	m_mode			= (KBFileDialog::KBMode)elem.attribute("mode").toInt() ;
	m_caption		= elem.attribute("caption") ;

	btn   ->setText	      ("...") ;
	btn   ->setFixedWidth ((btn->sizeHint().width() * 2) / 3) ;

	setWidget (cntr) ;

	connect
	(	m_wizFile,
		SIGNAL(textChanged(const QString &)),
		SLOT  (ctrlChanged())
	)	;
	connect
	(	btn,
		SIGNAL(clicked()),
		SLOT  (slotClickFile())
	)	;
}

KBWizardCtrlWizFile::~KBWizardCtrlWizFile ()
{
}

void	KBWizardCtrlWizFile::slotClickFile ()
{
	QString	name	;

	switch (m_mode)
	{
		case KBFileDialog::Directory	:
			name  = KBFileDialog::getExistingDirectory
				(	"",
					m_caption
				)	;
			break	;

		case KBFileDialog::ExistingFile	:
			name  = KBFileDialog::getOpenFileName
				(	"",
					"*.rkl|Rekall files",
					0,
					m_caption
				) ;
			break	;

		default	:
			name  = KBFileDialog::getSaveFileName
				(	"",
					"*.rkl|Rekall files",
					0,
					m_caption
				) ;
			break;
	}

	if (name.isEmpty()) return ;

	m_wizFile->setText (name) ;
}


void	KBWizardCtrlWizFile::setValue
	(	const QString	&value
	)
{
	m_wizFile->setText (value) ;
}

/*  KBWizardCtrlDBType							*/
/*  value	: Get value						*/
/*  (returns)	: QString	: Value					*/

QString	KBWizardCtrlWizFile::value ()
{
	return	m_wizFile->text () ;
}

WIZARDCTRLREG(WizFile)
