/***************************************************************************
    file	         : kb_componentlist.cpp
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	"kb_classes.h"
#include	"kb_location.h"
#include	"kb_dbinfo.h"
#include	"kb_listitem.h"
#include	"kb_viewer.h"
#include	"kb_callback.h"
#include	"kb_appptr.h"
#include	"kb_popupmenu.h"

#if		__KB_AUTOMOC
#include	"kb_componentlist.moc"
#else
#include 	"kb_componentlist.h"
#endif

#include	"tk_icons.h"

#include	<qcursor.h>


/*  KBComponentList							*/
/*  KBComponentList							*/
/*		: Constructor for component list widget			*/
/*  parent	: QWidget *	  : Parent widget			*/
/*  dbInfo	: KBDBInfo *	  : Database information object		*/
/*  (returns)	: KBComponentList	  :					*/

KBComponentList::KBComponentList
	(	QWidget		*parent,
		KBDBInfo	*dbInfo
	)
	:
	KBFileList
	(	parent,
		dbInfo,
		"Create new component",
		"component",
		"component",
		"Component name"
	)
{
}

/*  KBComponentList							*/
/*  ~KBComponentList							*/
/*		: Destructor for component list widget			*/
/*  (returns)	:		:					*/

KBComponentList::~KBComponentList ()
{
}

/*  KBComponentList							*/
/*  showServerMenu : Show popup menu for server entries			*/
/*  (returns)	   : void	:					*/

void	KBComponentList::showServerMenu
	(	int
	)
{
	KBPopupMenu pop (0) ;

	if ((m_curItem != 0) && (m_curItem->type() == KBListItem::Server))
		pop.setTitle   (QString(TR("Components: %1")).arg(m_curItem->text(0))) ;
	else	pop.setTitle   (TR("Component")) ;

	pop.insertItem
	(	getSmallIcon("reload"),
		TR("&Reload component list"),
		this,
		SLOT(reloadServer())
	)	;
	pop.insertItem
	(	getSmallIcon("editcopy"),
		TR("&Copy to server ..."),
		this,
		SLOT(copyToServer())
	)	;
	pop.exec (QCursor::pos()) ;
}

/*  KBComponentList							*/
/*  showObjectMenu : Show popup menu for server entries			*/
/*  (returns)	   : void	:					*/

void	KBComponentList::showObjectMenu
	(	int
	)
{
	KBPopupMenu pop (0) ;

	if ((m_curItem != 0) && (m_curItem->type() == KBListItem::Object))
		pop.setTitle   (QString(TR("Components: %1")).arg(m_curItem->text(0))) ;
	else	pop.setTitle   (TR("Component")) ;

	pop.insertItem
	(	getSmallIcon("designview"),
		TR("&Edit component"),
		this,
		SLOT(showAsData	   ())
	)	;
	pop.insertItem
	(	TR("&Rename component"),
		this,
		SLOT(renameComponent())
	)	;
	pop.insertItem
	(	getSmallIcon("editdelete"),
		TR("De&lete component"),
		this,
		SLOT(deleteComponent())
	)	;
	pop.insertItem
	(	getSmallIcon("filesave"),
		TR("&Save to file"),
		this,
		SLOT(saveObjToFile())
	)	;
	pop.exec (QCursor::pos()) ;
}

/*  KBComponentList							*/
/*  renameComponent							*/
/*		: Rename a component					*/
/*  (returns)	: void		:					*/

void	KBComponentList::renameComponent ()
{
	rename	(m_curItem) ;
}

/*  KBComponentList							*/
/*  deleteComponment							*/
/*		: Delete a component					*/
/*  (returns)	: void		:					*/

void	KBComponentList::deleteComponent ()
{
	delobj	(m_curItem) ;
}
