/***************************************************************************
    file	         : kb_filewidget.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_FILEWIDGET_H
#define	__KB_FILEWIDGET_H


#include	"kb_editlistview.h"
#include	"kb_copybase.h"
#include	"kb_copyfile.h"

#include	"rk_vbox.h"

class	QWidgetStack	;
class	QGroupBox	;
class	QCheckBox	;
class	QSpinBox	;

class	RKComboBox	;
class	RKLineEdit	;
class	RKPushButton	;


/*  KBFileWidget							*/
/*  -------------							*/
/*  This is the copier widget which provides the user GUI interface to	*/
/*  the file copier object.						*/

class	KBFileWidget : public RKVBox, public KBCopyFile
{
	Q_OBJECT

	QObject		*m_part		;

	bool		m_srce		;
	KBLocation	m_location	;

	RKComboBox	*m_cbFixedDelim	;
	QCheckBox	*m_cbHeader	;
	QSpinBox	*m_spHeader	;

	QWidgetStack	*m_typeStack	;

	QGroupBox	*m_gbDelim	;
	QGroupBox	*m_gbFixed	;
	QGroupBox	*m_gbFile	;

	RKComboBox	*m_cbDelim	;
	RKComboBox	*m_cbQualif	;
	RKLineEdit	*m_leCopyList	;

	KBEditListView	*m_fixedCols	;
	RKPushButton	*m_bTable	;
	RKPushButton	*m_bSample	;

	RKLineEdit	*m_eFile	;
	RKPushButton	*m_bBrowse	;
	RKComboBox	*m_cbErrOpt	;

	void		saveall		() ;

signals	:

	void		changed		() ;

protected slots	:

	void		fixedSelected	(int) ;
	void		clickBrowse	() ;
	void		clickTable	() ;
	void		clickSample	() ;

public	:

	KBFileWidget	(QWidget *parent, QObject *, bool, KBLocation &) ;

	bool		valid		(KBError     &) ;
	void		def		(QDomElement &) ;
	bool		set		(QDomElement &, KBError &) ;
	bool		init		(KBError     &) ;
}	;

#endif	// __KB_FILEWIDGET_H
