/***************************************************************************
    file	         : kb_querywidget.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_QUERYWIDGET_H
#define	__KB_QUERYWIDGET_H


#include	"kb_copybase.h"
#include	"kb_copyquery.h"

#include	"rk_vbox.h"

class		RKComboBox	;
class		RKLineEdit	;
class		RKPushButton	;
class		KBFieldChooser	;
class		RKListBox	;


/*  KBQueryWidget							*/
/*  -------------							*/
/*  This is the copied widget which provides the user GUI interface to	*/
/*  the query copier object.						*/

class	KBQueryWidget : public RKVBox, public KBCopyQuery
{
	Q_OBJECT

	QObject		*m_part		;

	bool		m_srce		;
	KBLocation	m_location	;

	RKComboBox	*m_cbServer	;
	RKComboBox	*m_cbQuery	;

	RKListBox	*m_lbFields	;
	RKListBox	*m_lbSelect	;
	RKPushButton	*m_bAdd		;
	RKPushButton	*m_bAddAll	;
	RKPushButton	*m_bRemove	;
	RKPushButton	*m_bUp		;
	RKPushButton	*m_bDown	;

	RKLineEdit	*m_eExpr	;
	RKLineEdit	*m_eWhere	;
	RKLineEdit	*m_eOrder	;

	KBFieldChooser	*m_fldChooser	;

	void		saveall		() ;

signals	:

	void		changed		() ;

protected slots	:

	void		clickExpr	()	;

public	:

	KBQueryWidget	(QWidget *parent, QObject *, bool, KBLocation &) ;
	~KBQueryWidget	() ;

	bool		valid		(KBError     &) ;
	void		def		(QDomElement &) ;
	bool		set		(QDomElement &, KBError &) ;
	bool		init		(KBError     &) ;
}	;
#endif	// __KB_QUERYWIDGET_H
