/***************************************************************************
    file	         : kb_tablewidget.h
    copyright            : (c)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_TABLEWIDGET_H
#define	__KB_TABLEWIDGET_H


#include	"kb_copybase.h"
#include	"kb_copytable.h"

#include	"rk_vbox.h"

class		RKComboBox	;
class		RKLineEdit	;
class		RKPushButton	;
class		KBFieldChooser	;
class		RKListBox	;


/*  KBTableWidget							*/
/*  -------------							*/
/*  This is the copied widget which provides the user GUI interface to	*/
/*  the table copied object.						*/

class	KBTableWidget : public RKVBox, public KBCopyTable
{
	Q_OBJECT

	QObject		*m_part		;

	bool		m_srce		;
	KBLocation	m_location	;

	RKComboBox	*m_cbServer	;
	RKComboBox	*m_cbTable	;

	RKListBox	*m_lbFields	;
	RKListBox	*m_lbSelect	;
	RKPushButton	*m_bAdd		;
	RKPushButton	*m_bAddAll	;
	RKPushButton	*m_bAddAuto	;
	RKPushButton	*m_bRemove	;
	RKPushButton	*m_bUp		;
	RKPushButton	*m_bDown	;

	RKLineEdit	*m_eExpr	;
	RKLineEdit	*m_eWhere	;
	RKLineEdit	*m_eOrder	;

	RKComboBox	*m_cbOption	;
	RKComboBox	*m_cbOptField	;

	KBFieldChooser	*m_fldChooser	;

	void		saveall		() ;

signals	:

	void		changed		() ;

protected slots	:

	void		clickExpr	()	;
	void		optSelected	(int)	;
	void		selectChanged	(bool)	;
	void		slotAddAuto	()	;

public	:

	KBTableWidget	(QWidget *parent, QObject *, bool, KBLocation &) ;
	~KBTableWidget	() ;

	bool		valid		(KBError     &) ;
	void		def		(QDomElement &) ;
	bool		set		(QDomElement &, KBError &) ;
	bool		init		(KBError     &) ;
}	;
#endif	// __KB_TABLEWIDGET_H
