/***************************************************************************
    file	         : kb_xmlwidget.h
    copyright            : (c)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_XMLWIDGET_H
#define	__KB_XMLWIDGET_H


#include	"kb_editlistview.h"
#include	"kb_copybase.h"
#include	"kb_copyxml.h"

#include	"rk_vbox.h"

class	QLabel		;

class	RKLineEdit	;
class	RKComboBox	;
class	RKPushButton	;


/*  KBXMLWidget								*/
/*  -----------								*/
/*  This is the copied widget which provides the user GUI interface to	*/
/*  the XML copier object.						*/

class	KBXMLWidget : public RKVBox, public KBCopyXML
{
	Q_OBJECT

	QObject		*m_part		;

	bool		m_srce		;
	KBLocation	m_location	;

	RKLineEdit	*m_eMainTag	;
	RKLineEdit	*m_eRowTag	;


	KBEditListView	*m_fieldList	;
	RKPushButton	*m_bTable	;
	RKPushButton	*m_bSample	;

	RKLineEdit	*m_eFile	;
	RKPushButton	*m_bBrowse	;
	RKComboBox	*m_cbErrOpt	;


	void		saveall		() ;

signals	:

	void		changed		() ;

protected slots	:

	void		clickBrowse	() ;
	void		clickTable	() ;
	void		clickSample	() ;

public	:

	KBXMLWidget	(QWidget *parent, QObject *, bool, KBLocation &) ;

	bool		valid		(KBError     &) ;
	void		def		(QDomElement &) ;
	bool		set		(QDomElement &, KBError &) ;
	bool		init		(KBError     &) ;
}	;
#endif	// __KB_XMLWIDGET_H
