/***************************************************************************
    file	         : kb_editor.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef  _KB_EDITOR_H
#define  _KB_EDITOR_H

#include	<qmultilineedit.h>
#include	<qpushbutton.h>
#include	<qregexp.h>



#include	"kb_locator.h"
#include	"kb_viewer.h"

#include	"tk_config.h"



class	RKListBox	;
class	QSplitter	;
class	KBTextEdit	;
class	QTextBrowser	;


/*  KBEditor								*/
/*  --------								*/
/*  Basic script editor class						*/

class	KBEditor : public KBViewer
{
	Q_OBJECT

	QSplitter		*m_splitter	;
	KBTextEdit		*m_editWin	;
	QTextBrowser		*m_errorWin	;
	KBaseGUI		*m_gui		;

	QRegExp			m_errExp	;
	QSize			m_size		;
	int			m_ewind		;

	KBScriptIF		*m_scrIface	;

	void		gotoLine	(uint)	;
	void		loadFiles	(const QString &, uint) ;

public	:

		 KBEditor (KBObjBase *, QWidget *) ;
	virtual	~KBEditor () ;

	virtual	KBEditor	*isEditor	() { return this ; }
	virtual	cchar		*getChanged	(bool)	;
	virtual	bool		queryClose	()	;

	virtual	void		reloadScript	(const QString &, uint) ;
	bool			startup		(const QString &, uint, bool) ;

	QString					def() ;

private	slots	:

	void			modified	()     ;

public	slots	:

	virtual	void		showAs		(KB::ShowAs) ;

	void			saveDocument	()     ;
	void			saveDocumentAs	()     ;
	void			doCompile	()     ;
}	;

#endif // _KB_EDITOR_H
