/***************************************************************************
    file	         : kb_formbase.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_FORMBASE_H
#define	__KB_FORMBASE_H


#include	<qguardedptr.h>

#include	"kb_libloader.h"
#include	"kb_objbase.h"
#include	"kb_formviewer.h"
#include	"kb_form.h"


class	KBFormBase : public KBObjBase
{
	Q_OBJECT

	KBForm			*m_docRoot	;
	KBFormViewer		*m_viewer	;
	QGuardedPtr<KBNode>	m_opener	;

private slots :

	void	widgetClosing () ;

public	:

	KBFormBase	(QObject * = 0, cchar * = 0) ;
	virtual		~KBFormBase ()	;


	virtual	bool		build
		(		const KBLocation	&,
				bool			,
				KBError 		&
		) ;

	virtual	KB::ShowRC	show
		(		KB::ShowAs		,
				const QDict<QString> 	&,
				QWidget 		*,
				KBError 		&,
				const KBValue		& = KBValue(),
				QDict<QString>		* = 0	
		) ;

	virtual	QString		def		()		;
	virtual	void		setOpener	(KBNode *)	;

	virtual	KBNode		*getTopNode ()
	{
		return	m_docRoot ;
	}

	inline	KBFormViewer	*viewer	()
	{
		return	m_viewer	;
	}

	inline	KBNode		*opener	()
	{
		return	m_opener	;
	}
}	;

KBPARTFACTORY(KBFormFactory,"formviewer")

#endif	// __KB_FORMBASE_H
