/***************************************************************************
    file	         : kb_formlist.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		_KB_FORMLIST_H
#define		_KB_FORMLIST_H


#include	<qvaluelist.h>

#include	"kb_filelist.h"
#include	"kb_popupmenu.h"

#include	"kb_testalldlg.h"

class	RKVBox			;
class	KBScriptTestResult	;
class	KBTestSuiteResultsDlg	;


/*  KBFormList								*/
/*  ----------								*/
/*  Widget used to list all the forms in a database			*/

class	KBFormList : public KBFileList
{
	Q_OBJECT

	KBPopupMenu			m_objectMenu	;
	Qt::ButtonState			m_buttonState	;

	QStringPairList			listAllSuites		(const QString &, const QString &) ;

protected :

	virtual	void			showServerMenu		(int)	;
	virtual	void			showObjectMenu		(int)	;

#if	! __KB_RUNTIME
	void				addTestMenu		(KBPopupMenu   &) ;
	virtual	void			createByWizard		(KBListItem    *) ;
	virtual KBMessageBoxYNAC::ActRC	saveObjToWeb		(const KBLocation &, const QString &, KBMessageBoxYNAC::ActRC = KBMessageBoxYNAC::ActYes) ;

	KBScriptTestResult		*executeTestSuite
					(	KBLocation		&,
						const QString		&,
						bool			,
						KBTest::ErrorOpt	,
						KBTestSuiteResultsDlg	&
					)	;

#endif

protected slots :

	virtual	void			renameForm		()	;
	virtual	void			deleteForm		()	;
	void				slotExecuteTestAll	()	;
	void				slotExecuteAllSuites	()	;
	void				slotExecuteInServer	(int)	;
	void				slotExecuteTestSuite	(int)	;

public	:

	KBFormList  (QWidget *, KBDBInfo *) ;
       ~KBFormList  () ;
}	;

#endif	// _KB_FORMLIST_H
