/***************************************************************************
    file	         : kb_macrobase.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_MACROBASE_H
#define	__KB_MACROBASE_H


#include	"kb_libloader.h"
#include	"kb_objbase.h"
#include	"kb_macroviewer.h"

class	KBMacroBase : public KBObjBase
{
	Q_OBJECT

	QByteArray	m_doc		;
	KBMacroViewer	*m_viewer	;

private slots :

	void	widgetClosing () ;

public	:

	KBMacroBase	(QObject * = 0, cchar * = 0) ;
	virtual		~KBMacroBase ()	;

	virtual	bool		build
		(		const KBLocation 	&,
				bool			,
				KBError 		&
		) ;

	virtual	KB::ShowRC	show
		(		KB::ShowAs		,
				const QDict<QString>	&,
				QWidget			*,
				KBError			&,
				const KBValue		& = KBValue(),
				QDict<QString>		* = 0
		) ;

	virtual	QString		def	() ;
}	;


KBPARTFACTORY(KBMacroFactory,"macroviewer")

#endif	// __KB_MACROBASE_H
