/***************************************************************************
    file	         : kb_macrolst.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/



#include	"kb_classes.h"
#include	"kb_location.h"
#include	"kb_dbinfo.h"
#include	"kb_listitem.h"
#include	"kb_viewer.h"
#include	"kb_callback.h"
#include	"kb_macro.h"
#include	"kb_script.h"
#include	"kb_appptr.h"
#include	"kb_popupmenu.h"

#include	<qcursor.h>

#if		__KB_AUTOMOC
#include	"kb_macrolist.moc"
#else
#include 	"kb_macrolist.h"
#endif

#include	"tk_icons.h"


/*  KBMacoList								*/
/*  KBMacoList	: Constructor for macro list widget			*/
/*  parent	: QWidget *	  : Parent widget			*/
/*  dbInfo	: KBDBInfo *	  : Database information object		*/
/*  (returns)	: KBMacoList	  :					*/

KBMacroList::KBMacroList
	(	QWidget		*parent,
		KBDBInfo	*dbInfo
	)
	:
	KBFileList
	(	parent,
		dbInfo,
		"Create new macro",
		"macro",
		"macro",
		"Macro name"
	)
{
}

/*  KBMacroList								*/
/*  ~KBMacroList: Destructor for macro list widget			*/
/*  (returns)	:		:					*/

KBMacroList::~KBMacroList ()
{
}

/*  KBMacroList								*/
/*  showServerMenu : Show popup menu for server entries			*/
/*  (returns)	   : void	:					*/

void	KBMacroList::showServerMenu
	(	int
	)
{
	KBPopupMenu pop (0) ;

	if ((m_curItem != 0) && (m_curItem->type() == KBListItem::Server))
		pop.setTitle   (QString(TR("Macro: %1")).arg(m_curItem->text(0))) ;
	else	pop.setTitle   (TR("Macross")) ;

	pop.insertItem
	(	getSmallIcon("reload"),
		TR("&Reload macro list"),
		this,
		SLOT(reloadServer ())
	)	;
	pop.insertItem
	(	getSmallIcon("editcopy"),
		TR("&Copy to server ..."),
		this,
		SLOT(copyToServer ())
	)	;

	pop.exec (QCursor::pos()) ;
}

/*  KBMacroList								*/
/*  showObjectMenu : Show popup menu for server entries			*/
/*  (returns)	   : void	:					*/

void	KBMacroList::showObjectMenu
	(	int
	)
{
	KBPopupMenu pop (0) ;

	if ((m_curItem != 0) && (m_curItem->type() == KBListItem::Object))
		pop.setTitle   (QString(TR("Macro: %1")).arg(m_curItem->text(0))) ;
	else	pop.setTitle   (TR("Macros")) ;

	pop.insertItem
	(	getSmallIcon("dataview"),
		TR("&Execute macro"),
		this,
		SLOT(showAsData   ())
	)	;
	pop.insertItem
	(	getSmallIcon("designview"),
		TR("Ed&it macro"),
		this,
		SLOT(showAsDesign ())
	)	;
	pop.insertItem
	(	TR("&Rename macro"),
		this,
		SLOT(renameMacro   ())
	)	;
	pop.insertItem
	(	getSmallIcon("editdelete"),
		TR("De&lete macro"),
		this,
		SLOT(deleteMacro  ())
	)	;
	pop.exec (QCursor::pos()) ;
}

/*  KBMacroList								*/
/*  renamemacro	: Rename a macro					*/
/*  (returns)	: void		:					*/

void	KBMacroList::renameMacro ()
{
	rename	(m_curItem) ;
}

/*  KBMacroList								*/
/*  deleteComponment							*/
/*		: Delete a macro					*/
/*  (returns)	: void		:					*/

void	KBMacroList::deleteMacro ()
{
	delobj	(m_curItem) ;
}

void	KBMacroList::showObjectAs
	(	KBListItem	*item,
		KB::ShowAs	showAs
	)
{
	if (showAs == KB::ShowAsData)
	{
		KBLocation	location ;
		KBError		error 	 ;

		if (!itemToLocation (m_curItem, location))
			return ;

		KBScriptError *rc = KBMacroExec::execute (location, "standard") ;
		if (rc != 0)
			KBScriptError::processError (rc, KBScriptError::Normal) ;

		return	;
	}

	KBFileList::showObjectAs (item, showAs) ;
}
