/***************************************************************************
    file	         : kb_macroviewer.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef  _KB_MACROVIEWER_H
#define  _KB_MACROVIEWER_H



#include	"kb_classes.h"
#include	"kb_attrdict.h"
#include	"kb_viewer.h"
#include	"kb_macro.h"
#include	"kb_macroeditor.h"


/*  KBMacroViewer							*/
/*  -------------							*/
/*  This class is the MDI child wrapper for viewing macros (only in	*/
/*  design mode).							*/

class	KBMacroViewer : public KBViewer
{
	Q_OBJECT

	KBaseGUI		*m_gui		;
	KBMacroEditor		*m_editor	;

public	:

	KBMacroViewer		(KBObjBase*, QWidget *)	;
	virtual	~KBMacroViewer	() ;

	virtual	cchar		*getChanged	(bool)	;
	virtual	bool		queryClose	()	;

	KB::ShowRC		startup		(QByteArray &, KBError &) ;

public	slots	:

	void		slotChanged		()		;
	virtual	void	showAs			(KB::ShowAs)	;

	void		saveDocument		()     		;
	void		saveDocumentAs		()     		;

	QString		def			()		;
}	;


#endif // _KB_MACROVIEWER_H
