/***************************************************************************
    file	         : kb_querylist.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/



#include	"kb_classes.h"
#include	"kb_location.h"
#include	"kb_dbinfo.h"
#include	"kb_listitem.h"
#include	"kb_viewer.h"
#include 	"kb_popupmenu.h"

#include	"tk_icons.h"

#if		__KB_AUTOMOC
#include	"kb_querylist.moc"
#else
#include	"kb_querylist.h"
#endif

#include	"kb_queryviewer.h"

#include 	<qcursor.h>


/*  KBQueryList								*/
/*  KBQueryList	: Constructor for query list widget			*/
/*  parent	: QWidget *	: Parent widget				*/
/*  dbInfo	: KBDBInfo *	: Database information object		*/
/*  (returns)	: KBQueryList	:					*/

KBQueryList::KBQueryList
	(	QWidget		*parent,
		KBDBInfo	*dbInfo
	)
	:
	KBFileList
	(	parent,
		dbInfo,
		"Create new query",
		"querylog",
		"query",
		"Query name"
	)
{
}

/*  KBQueryList								*/
/*  ~KBQueryList: Destructor for query list widget			*/
/*  (returns)	:		:					*/

KBQueryList::~KBQueryList ()
{
}

/*  KBQueryList								*/
/*  showServerMenu : Show popup menu for server entries			*/
/*  (returns)	   : void	:					*/

void	KBQueryList::showServerMenu
	(	int
	)
{
	KBPopupMenu pop (0) ;

	if ((m_curItem != 0) && (m_curItem->type() == KBListItem::Server))
		pop.setTitle   (QString(TR("Queries: %1")).arg(m_curItem->text(0))) ;
	else	pop.setTitle   (TR("Query")) ;

	pop.insertItem
	(	getSmallIcon("reload"),
		TR("&Reload query list"),
		this,
		SLOT(reloadServer())
	)	;
#if	! __KB_RUNTIME
	pop.insertItem
	(	getSmallIcon("editcopy"),
		TR("&Copy to server ..."),
		this,
		SLOT(copyToServer())
	)	;
	pop.insertItem
	(	getSmallIcon("filesave"),
		TR("Save to &web ..."),
		this,
		SLOT(saveAllToWeb())
	)	;
#endif
	pop.exec (QCursor::pos()) ;
}

/*  KBQueryList								*/
/*  showObjectMenu : Show popup menu for server entries			*/
/*  (returns)	   : void	:					*/

void	KBQueryList::showObjectMenu
	(	int
	)
{
	KBPopupMenu pop (0) ;

	if ((m_curItem != 0) && (m_curItem->type() == KBListItem::Object))
		pop.setTitle   (QString(TR("Queries: %1")).arg(m_curItem->text(0))) ;
	else	pop.setTitle   (TR("Query")) ;

	pop.insertItem
	(	getSmallIcon("dataview"),
		TR("&Data view"),
		this,
		SLOT(showAsData   ())
	)	;
#if	! __KB_RUNTIME
	pop.insertItem
	(	getSmallIcon("designview"),
		TR("D&esign view"),
		this,
		SLOT(showAsDesign ())
	)	;
	pop.insertItem
	(	TR("&Rename query"),
		this,
		SLOT(renameQuery  ())
	)	;
	pop.insertItem
	(	getSmallIcon("editdelete"),
		TR("De&lete query"),
		this,
		SLOT(deleteQuery  ())
	)	;
	pop.insertItem
	(	getSmallIcon("filesave"),
		TR("&Save to file"),
		this,
		SLOT(saveObjToFile())
	)	;
	pop.insertItem
	(	getSmallIcon("www"),
		TR("Save to &web"),
		this,
		SLOT(saveObjToWeb ())
	)	;
#endif
	pop.exec       (QCursor::pos()) ;
}



/*  KBQueryList								*/
/*  renameQuery	: Rename a query					*/
/*  (returns)	: void		:					*/

void	KBQueryList::renameQuery ()
{
	rename	(m_curItem) ;
}

/*  KBQueryList								*/
/*  deleteQuery	: Delete a query					*/
/*  (returns)	: void		:					*/

void	KBQueryList::deleteQuery ()
{
	delobj	(m_curItem) ;
}
