/***************************************************************************
    file	         : kb_filterdlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_FILTERDLG_H
#define	__KB_FILTERDLG_H


#include	"kb_dialog.h"


class	KBTableInfo	;
class	KBTableSpec	;

class	RKListBox	;
class	RKPushButton	;


/*  KBFilterDlg								*/
/*  -----------								*/
/*  This is the "outer" dialog for filter (sort/select/view) creation	*/
/*  and editing. Displays lists of the available filters, and provides	*/
/*  access to the create, edit and delete functions.			*/

class	KBFilterDlg : public KBDialog
{
	Q_OBJECT

	RKListBox	*m_sortNames	;
	RKPushButton	*m_sortEdit	;
	RKPushButton	*m_sortNew	;
	RKPushButton	*m_sortDelete	;

	RKListBox	*m_selectNames	;
	RKPushButton	*m_selectEdit	;
	RKPushButton	*m_selectNew	;
	RKPushButton	*m_selectDelete	;

	RKListBox	*m_viewNames	;
	RKPushButton	*m_viewEdit	;
	RKPushButton	*m_viewNew	;
	RKPushButton	*m_viewDelete	;

	RKPushButton	*m_bClose	;
	KBTableSpec	&m_tableSpec	;
	KBTableInfo	*m_tableInfo	;

	void		loadSortList	() ;
	void		loadSelectList	() ;
	void		loadViewList	() ;

protected slots :

	void		slotEditSort	() ;
	void		slotEditSelect	() ;
	void		slotEditView	() ;

	void		slotNewSort	() ;
	void		slotNewSelect	() ;
	void		slotNewView	() ;

	void		slotDeleteSort	() ;
	void		slotDeleteSelect() ;
	void		slotDeleteView	() ;

	void		slotHiliteSort	() ;
	void		slotHiliteSelect() ;
	void		slotHiliteView  () ;

	void		slotClickClose	() ;

public	:

	KBFilterDlg	(KBTableSpec &, KBTableInfo *) ;
}	;

#endif	// __KB_FILTERDLG_H
