/***************************************************************************
    file	         : kb_tablefilterdlg.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_TABLEFILTERDLG_H
#define	__KB_TABLEFILTERDLG_H



#include	"kb_classes.h"
#include	"kb_dialog.h"
#include	"kb_tableinfo.h"


class	KBTableSpec	;
class	KBTableSort	;
class	KBTableSelect	;
class	KBTableView	;

class	RKLineEdit	;
class	RKComboBox	;
class	RKPushButton	;
class	RKHBox		;
class	QListView	;
class	QListViewItem	;

/*  KBTableFilterDlg							*/
/*  ----------------							*/
/*  This is the base class for the dialogs used to edit filter sort,	*/
/*  order and view sets.						*/

class	KBTableFilterDlg : public KBDialog
{
	Q_OBJECT

protected :

	RKLineEdit	*m_name		;

	QListView	*m_filterSet	;

	RKPushButton	*m_bMoveUp	;
	RKPushButton	*m_bMoveDown	;
	RKPushButton	*m_bAdd		;
	RKPushButton	*m_bRemove	;
	RKPushButton	*m_bOK		;
	RKPushButton	*m_bCancel	;

	RKHBox		*m_layCols	;

	KBTableSpec	&m_tableSpec	;
	KBTableInfo	*m_tableInfo	;

	bool		checkOK			(void *,  void *) ;

protected slots :

	void		slotSelectItem		(QListViewItem *) ;

	void		slotClickMoveUp		() ;
	void		slotClickMoveDown	() ;
	void		slotClickRemove		() ;
	void		slotClickCancel		() ;

	virtual	void	slotClickAdd		() = 0 ;
	virtual	void	slotClickOK		() = 0 ;

public	:

	KBTableFilterDlg
	(	KBTableSpec	&,
		KBTableInfo	*,
		const QString	&
	)	;
}	;


/*  KBTableSortDlg							*/
/*  --------------							*/
/*  Dialog for table sorting						*/

class	KBTableSortDlg : public KBTableFilterDlg
{
	Q_OBJECT

	RKComboBox	*m_columns	;
	RKComboBox	*m_order	;

	KBTableSort	*&m_tableSort	;

public	:

	KBTableSortDlg
	(	KBTableSpec	&,
		KBTableInfo	*,
		KBTableSort	*&
	) ;

protected slots :

	virtual	void	slotClickAdd		()  ;
	virtual	void	slotClickOK		()  ;
}	;


/*  KBTableSelectDlg							*/
/*  --------------							*/
/*  Dialog for table sorting						*/

class	KBTableSelectDlg : public KBTableFilterDlg
{
	Q_OBJECT

	RKComboBox	*m_columns	;
	RKComboBox	*m_oper		;
	RKLineEdit	*m_value	;

	KBTableSelect	*&m_tableSelect	;

public	:

	KBTableSelectDlg
	(	KBTableSpec	&,
		KBTableInfo	*,
		KBTableSelect	*&
	) ;

protected slots :

	virtual	void	slotClickAdd		()  ;
	virtual	void	slotClickOK		()  ;
}	;


/*  KBTableViewDlg							*/
/*  --------------							*/
/*  Dialog for table sorting						*/

class	KBTableViewDlg : public KBTableFilterDlg
{
	Q_OBJECT

	RKComboBox	*m_columns	;

	KBTableView	*&m_tableView	;

public	:

	KBTableViewDlg
	(	KBTableSpec	&,
		KBTableInfo	*,
		KBTableView	*&
	) ;

protected slots :

	virtual	void	slotClickAdd		()  ;
	virtual	void	slotClickOK		()  ;
}	;


#endif	// __KB_TABLEFILTERDLG_H
