/***************************************************************************
    file	         : rk_application.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	__RK_APPLICATION_H
#define	__RK_APPLICATION_H

#include	<qmap.h>
#include	<qapplication.h>

#include 	"libtkkde_exports.h"



/*  RKNotifyFilter							*/
/*  --------------							*/
/*  Helper class, used so we can hook the QApplication ::notify method	*/
/*  and pass calls to specified objects.				*/

class	LIBTKKDE_API	RKNotifyFilter : public QObject
{
	Q_OBJECT

public	:

	RKNotifyFilter	(QObject * = 0, const char * = 0) ;

	virtual	bool	notifyFilter	(QObject *, QEvent *)	;

}	;


/*  RKApplication							*/
/*  -------------							*/
/*  Application wrapper, needed to provide a few application level	*/
/*  hooks.								*/

class	LIBTKKDE_API	RKApplication : public QApplication
{
	Q_OBJECT

	QMap<QObject *, RKNotifyFilter*>	m_mousePressFilters	;

protected slots	:

	void	slotDestroyed	(QObject *)	;

public	:

	RKApplication	(int, char *[]) ;

	virtual	bool	notify
		(	QObject		*o,
			QEvent		*e
		)	;

	void	installMousePressFilter	(QObject *, RKNotifyFilter *) ;
	void	removeMousePressFilter	(QObject *) ;

	static	RKApplication	*self	()	;
}	;

#endif	// __RK_APPLICATION_H
