/***************************************************************************
    file	         : rk_box.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#if		__KB_AUTOMOC
#include	"rk_box.moc"
#else
#include	"rk_box.h"
#endif

RKBoxLayout::RKBoxLayout
	(	QWidget			*parent,
		QBoxLayout::Direction	direction,
		bool			noMargin
	)
	:
	QBoxLayout	(parent, direction),
	m_noMargin	(noMargin)
{
}

void	RKBoxLayout::setMargin
	(	int		margin
	)
{
	QBoxLayout::setMargin (m_noMargin ? 0 : margin) ;
}

void	RKBoxLayout::setNoMargin
	(	bool		noMargin
	)
{
	m_noMargin = noMargin ;
}

void	RKBoxLayout::addItem
	(	QLayoutItem	*item
	)
{
	if (qstrcmp (item->widget()->className(), "KBSizerBlob") != 0)
		QBoxLayout::addItem (item) ;
}

RKBox::RKBox
	(	QWidget		*parent,
		const char	*name,
		WFlags		flags
	)
	:
	QFrame	(parent, name, flags)
{
}

bool	RKBox::isNestedBox()
{
	if (parentWidget() != 0)
		return	parentWidget()->inherits("RKBox"	) ||
			parentWidget()->inherits("QWidgetStack" ) ;

	return	false	;
}

void	RKBox::setTracking ()
{
	(new QVBoxLayout (parentWidget()))->addWidget (this) ;
}
