/***************************************************************************
    file	         : rk_checkbox.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#if		__KB_AUTOMOC
#include	"rk_checkbox.moc"
#else
#include	"rk_checkbox.h"
#endif

RKCheckBox::RKCheckBox
	(	QWidget		*parent,
		const char	*name
	)
	:
	QCheckBox (parent, name)
{
	m_readOnly 	= false ;
}

RKCheckBox::RKCheckBox
	(	const QString	&text,
		QWidget		*parent,
		const char	*name
	)
	:
	QCheckBox (text, parent, name)
{
	m_readOnly 	= false ;
}

bool	RKCheckBox::isNavigationKey
	(	QKeyEvent	*
	)
{
	return	false	;
}
	
/*  RKCheckBox								*/
/*  setReadOnly	: Set read-only state					*/
/*  readOnly	: bool		: State					*/
/*  (returns)	: void		:					*/

void	RKCheckBox::setReadOnly
	(	bool		readOnly
	)
{
	m_readOnly = readOnly ;
}

bool	RKCheckBox::isReadOnly ()
{
	return	m_readOnly ;
}

/*  KBComboBox								*/
/*  event	: Event handler						*/
/*  e		: QEvent *	: Event received			*/
/*  (returns)	: bool		: Event consumed			*/

bool	RKCheckBox::event
	(	QEvent		*e
	)
{
	if (m_readOnly)
		switch (e->type())
		{
			case QEvent::MouseButtonPress	:
			case QEvent::MouseButtonRelease :
			case QEvent::MouseButtonDblClick:
				return	true	;

			case QEvent::KeyPress		:
			case QEvent::KeyRelease		:
				if (!isNavigationKey ((QKeyEvent *)e))
					return	true	;
				break	;

			default	:
				break	;
		}

	return	QCheckBox::event (e) ;
}
