/***************************************************************************
    file	         : rk_combobox.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#if		__KB_AUTOMOC
#include	"rk_combobox.moc"
#else
#include	"rk_combobox.h"
#endif

RKComboBox::RKComboBox
	(	QWidget		*parent,
		const char	*name
	)
	:
	QComboBox (parent, name)
{
	m_fullWidth	= -1	;
	m_readOnly 	= false ;
}

RKComboBox::RKComboBox
	(	bool		rw,
		QWidget		*parent,
		const char	*name
	)
	:
	QComboBox (rw, parent, name)
{
	m_fullWidth	= -1	;
	m_readOnly 	= false ;
}

QSize	RKComboBox::sizeHint ()
{
	QSize	hint	= QComboBox::sizeHint() ;
	if (m_fullWidth > 0) hint.setWidth (m_fullWidth) ;
	return	hint	;
}

bool	RKComboBox::isNavigationKey
	(	QKeyEvent	*
	)
{
	return	false	;
}
	
/*  RKComboBox								*/
/*  setReadOnly	: Set read-only state					*/
/*  readOnly	: bool		: State					*/
/*  (returns)	: void		:					*/

void	RKComboBox::setReadOnly
	(	bool		readOnly
	)
{
	m_readOnly = readOnly ;
}

bool	RKComboBox::isReadOnly ()
{
	return	m_readOnly ;
}

/*  KBComboBox								*/
/*  event	: Event handler						*/
/*  e		: QEvent *	: Event received			*/
/*  (returns)	: bool		: Event consumed			*/

bool	RKComboBox::event
	(	QEvent		*e
	)
{
	if (m_readOnly)
		switch (e->type())
		{
			case QEvent::MouseButtonPress	:
			case QEvent::MouseButtonRelease :
			case QEvent::MouseButtonDblClick:
				return	true	;

			case QEvent::KeyPress		:
			case QEvent::KeyRelease		:
				if (!isNavigationKey ((QKeyEvent *)e))
					return	true	;
				break	;

			default	:
				break	;
		}

	return	QComboBox::event (e) ;
}

bool	RKComboBox::setCurrentByText
	(	const QString	&value
	)
{
	for (int idx = 0 ; idx < count() ; idx += 1)
		if (text(idx) == value)
		{	setCurrentItem (idx) ;
			return	true ;
		}
	return	false	;
}
