/***************************************************************************
    file	         : rk_combobox.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	__RK_COMBOBOX_H
#define	__RK_COMBOBOX_H

#include	<qcombobox.h>

#include 	"libtkkde_exports.h"

class	LIBTKKDE_API	RKComboBox : public QComboBox
{
	Q_OBJECT

	int		m_fullWidth	;
	bool		m_readOnly	;

public	:

	RKComboBox	(QWidget * = 0, const char * = 0) ;
	RKComboBox	(bool, QWidget * = 0, const char * = 0) ;

	virtual	QSize	sizeHint	()		;
	virtual	bool	isNavigationKey	(QKeyEvent *)	;

	inline	void	setFullWidth
		(	int	fullWidth
		)
	{
		m_fullWidth = fullWidth ;
	}

	virtual	bool	event		(QEvent *)	;
	void		setReadOnly	(bool)		;
	bool		isReadOnly	()		;
	bool		setCurrentByText(const QString &) ;
}	;

#endif	// __RK_COMBOBOX_H
