#include "rk_datevalidator.h"

RKDateValidator::RKDateValidator( QObject* parent, const char* name )
    : QValidator( parent, name )
{
}

QValidator::State RKDateValidator::validate( QString& text, int& ) const
{
	QDate temp;

	return date( text, temp );
}

QValidator::State RKDateValidator::date( const QString& text, QDate& d ) const
{
	QDate tmp = QDate::fromString( text );

	if ( ! tmp.isNull() || tmp.isValid() )
    {
		d = tmp;
		return Acceptable;
    } 
	else
		return Valid;
}

void RKDateValidator::fixup( QString& ) const
{
}
