/***************************************************************************
    file	         : rk_dialog.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef		__RK_DIALOG
#define		__RK_DIALOG

#include 	"libtkkde_exports.h"

#include	<qapplication.h>
#include	<qlayout.h>
#include	<qdialog.h>


class		RKPushButton		;

/*  RKDialog								*/
/*  ---------								*/
/*  This class is a wrapper for QDialog. It exists to to set the	*/
/*  handle layout (margin and spacing); the implementation handles the	*/
/*  desktop and embedded cases.						*/

class	LIBTKKDE_API	RKDialog : public QDialog
{
	Q_OBJECT

	QString		m_name		;
	QSize		m_lastSize	;

protected :

	bool		m_showMaxed	;

	virtual int	getSpacing	(QLayout *  = 0);
	virtual int	getMargin	(QLayout *  = 0);

	virtual	void	resizeEvent	(QResizeEvent *);

public	:

	RKDialog 	(QWidget *, const char * = 0, bool = false, WFlags = 0) ;
       ~RKDialog	() ;

	int		exec		() ;
	virtual	void	show		() ;

	/* Static versions for use in dialogs (such as tabbed dialogs)	*/
	/* which are not derived from RKDialog.				*/
	static	void	resizeLayout	(QLayout *, int, int)	;
	static	void	resizeLayout	(QWidget *, int, int)	;

	/* Get the active window to use as a dialog parent. Generally	*/
	/* we use this to avoid having to keep track of parenting when	*/
	/* popping up dialogs from forms and suchlike. It is needed	*/
	/* most on Mac OS/X where unparented dialogs are Bad News(tm).	*/
	static	QWidget	*activeWindow	(QWidget * = 0) ;
}	;

#endif	// __RK_DIALOG
