/***************************************************************************
    file	         : rk_gridbox.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__RK_GRIDBOX_H
#define	__RK_GRIDBOX_H

#include 	"rk_box.h"

#include 	"libtkkde_exports.h"

class	RKGridLayout	;

/*  RKGridBox								*/
/*  ---------								*/
/*  This class is a local replacement for RKGridBox, which allows a	*/
/*  little more control, for instance adding a filler row.		*/

class	LIBTKKDE_API	RKGridBox : public RKBox
{
	Q_OBJECT

	RKGridLayout	*m_layout	;

protected:

	virtual	void	frameChanged	()	;

public	:

	RKGridBox	(int, QWidget *, const char * = 0, WFlags = 0) ;

	void		setNoMargin	(bool)		;

	void		addFillerRow	()		;
	void		setSpacing	(int)		;
	void		setMargin	(int)		;
		
	void		setRowStretch	(int, int)	;
	void		setColStretch	(int, int)	;

	virtual	QSize	sizeHint	() const	;
}	;


#endif	// __RK_GRIDBOX_H
