/***************************************************************************
    file	         : rk_hbox.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__RK_HBOX_H
#define	__RK_HBOX_H

#include 	"rk_box.h"

#include 	"libtkkde_exports.h"

/*  RKHBox								*/
/*  ------								*/
/*  This class is a local replacement for QHBox, which allows a little	*/
/*  more control, for instance adding a filler.				*/

class	LIBTKKDE_API	RKHBox : public RKBox
{
	Q_OBJECT

	RKBoxLayout	*m_layout	;

protected:

	virtual	void	frameChanged	()	;

public	:

	RKHBox		(QWidget *, const char * = 0, WFlags = 0) ;

	void		setNoMargin	(bool)		;
	void		setSpacing	(int)		;
	void		addFiller	()		;
	void		setStretchFactor(QWidget *, int);
	void		fixToChildHeight(int = 0)	;

	virtual	QSize	sizeHint	() const	;
}	;


#endif	// __RK_HBOX_H
