/***************************************************************************
    file	         : rk_listbox.cpp
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#if		__KB_AUTOMOC
#include	"rk_listbox.moc"
#else
#include	"rk_listbox.h"
#endif

RKListBox::RKListBox
	(	QWidget		*parent,
		const char	*name
	)
	:
	QListBox (parent, name)
{
	m_readOnly 	= false ;
}

bool	RKListBox::isNavigationKey
	(	QKeyEvent	*
	)
{
	return	false	;
}
	
/*  RKListBox								*/
/*  setReadOnly	: Set read-only state					*/
/*  readOnly	: bool		: State					*/
/*  (returns)	: void		:					*/

void	RKListBox::setReadOnly
	(	bool		readOnly
	)
{
	m_readOnly = readOnly ;
}

bool	RKListBox::isReadOnly ()
{
	return	m_readOnly ;
}

/*  KBListBox								*/
/*  event	: Event handler						*/
/*  e		: QEvent *	: Event received			*/
/*  (returns)	: bool		: Event consumed			*/

bool	RKListBox::event
	(	QEvent		*e
	)
{
	if (m_readOnly)
		switch (e->type())
		{
			case QEvent::MouseButtonPress	:
			case QEvent::MouseButtonRelease :
			case QEvent::MouseButtonDblClick:
				return	true	;

			case QEvent::KeyPress		:
			case QEvent::KeyRelease		:
				if (!isNavigationKey ((QKeyEvent *)e))
					return	true	;
				break	;

			default	:
				break	;
		}

	return	QListBox::event (e) ;
}
