/*
	This file is part of the KDE libraries
    Copyright (C) 1997 Tim D. Gilman (tdgilman@best.org)
              (C) 1998-2001 Mirko Boehm (mirko@kde.org)
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.

	Modified by John Dean, July 2005

	RKMonthSelector is a 100% pure Qt port of KDateTable, which is part of the KDELibs.
	Class, function and variable names have been changed to make them consistent
	with those found in Rekall
*/

#ifndef RK_MONTHSELECTOR_H
#define RK_MONTHSELECTOR_H

#include <qvalidator.h>
#include <qdatetime.h>
#include <qgridview.h>
#include <qdatetime.h>
#include <qcolor.h>

#include "libtkkde_exports.h"

class LIBTKKDE_API RKMonthSelector : public QGridView
{
	Q_OBJECT

protected:

	int			m_Result;
  
	short int	m_ActiveCol;
	short int	m_ActiveRow;
  
	QRect max;

signals:
  
	void shutDown( int );

public:
 
	RKMonthSelector( const QDate& date, QWidget* parent, const char* name = 0 );
    ~RKMonthSelector();
  
	QSize sizeHint() const;
    int result() const;

protected:
  
	void setupPainter( QPainter*pPainter );
 
	virtual void viewportResizeEvent( QResizeEvent* );
    virtual void paintCell( QPainter* painter, int row, int col );
    virtual void contentsMousePressEvent( QMouseEvent* pEvent );
	virtual void contentsMouseMoveEvent( QMouseEvent* pEvent );
    virtual void contentsMouseReleaseEvent( QMouseEvent* pEvent );

private:

	int			m_Year;
	int			m_Month;
	int			m_Day;

};

#endif // RK_MONTHSELECTOR_H
