#include <qapplication.h>

#if __KB_AUTOMOC
#include "rk_popupframe.moc"
#else
#include "rk_popupframe.h"
#endif

RKPopupFrame::RKPopupFrame( QWidget* parent, const char* name )
  : QFrame( parent, name, WType_Popup ), m_Result( 0 ), m_pMain( 0 )
{
	setFrameStyle( QFrame::Box | QFrame::Raised );
	setMidLineWidth( 2 );
}

void RKPopupFrame::keyPressEvent( QKeyEvent* pEvent )
{
	if ( pEvent->key()==Key_Escape )
    {
		m_Result = 0; // rejected
		qApp->exit_loop();
    }
}

void RKPopupFrame::close( int r )
{
	m_Result = r;
	qApp->exit_loop();
}

void RKPopupFrame::setMainWidget( QWidget* m )
{
	m_pMain = m;
  
	if ( m_pMain )
    {
		resize( m_pMain->width() + 2 * frameWidth(), m_pMain->height() + 2 * frameWidth() );
    }
}

void RKPopupFrame::resizeEvent( QResizeEvent* )
{
	if ( m_pMain )
    {
		m_pMain->setGeometry( frameWidth(), frameWidth(),
			width() - 2 * frameWidth(), height() - 2 * frameWidth() );
    }
}

void RKPopupFrame::popup( const QPoint& pos )
{
    QRect d = QApplication::desktop()->screenGeometry( pos );

	int x = pos.x();
	int y = pos.y();
	int w = width();
	int h = height();
  
	if ( x + w > d.x() + d.width() )
		x = d.width() - w;

	if ( y + h > d.y() + d.height() )
		y = d.height() - h;
  
	if ( x < d.x() )
		x = 0;
  
	if ( y < d.y() )
		y = 0;

    move( x, y );
	show();
}

int RKPopupFrame::exec( QPoint pos )
{
	popup(pos);
	repaint();
	qApp->enter_loop();
	hide();
  
	return m_Result;
}

int RKPopupFrame::exec( int x, int y )
{
	return exec( QPoint( x, y ) );
}
