/*
    This file is part of the KDE libraries
    Copyright (C) 1997 Tim D. Gilman (tdgilman@best.org)
              (C) 1998-2001 Mirko Boehm (mirko@kde.org)
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.

	Modified by John Dean, July 2005

	RKDateGrid is a 100% pure Qt port of KDateTable, which is part of the KDELibs.
	Class, function and variable names have been changed to make them consistent
	with those found in Rekall
*/

#ifndef RK_POPUPFRAME_H
#define RK_POPUPFRAME_H

#include <qframe.h>

#include "libtkkde_exports.h"

class LIBTKKDE_API RKPopupFrame : public QFrame
{
	Q_OBJECT

protected:
  
	int			m_Result;
  
	virtual void keyPressEvent(QKeyEvent* e);
  
	QWidget*	m_pMain;

public slots:
  
	void close( int r );

public:
  
	RKPopupFrame( QWidget* parent = 0, const char* name = 0 );

	/**
     * Set the main widget. You cannot set the main widget from the constructor,
     * since it must be a child of the frame itself.
     * Be careful: the size is set to the main widgets size. It is up to you to
     * set the main widgets correct size before setting it as the main
     * widget.
     */

	void setMainWidget(QWidget* m);
  	virtual void resizeEvent( QResizeEvent* );
  	void popup( const QPoint& pos );
	int exec( QPoint p );
	int exec( int x, int y );

private:

	virtual bool close( bool alsoDelete ) { return QFrame::close( alsoDelete ); }

protected:

	//virtual void virtual_hook( int id, void* data );

};
#endif // RK_POPUPFRAME_H
