/***************************************************************************
    file	         : rk_vbox.cpp
    copyright            : (C) 1999,2000,2001,2002,2003,2004 by Mike Richardson
			   (C) 2000,2001,2002,2003,2004 by theKompany.com
			   (C) 2001,2002,2003,2004 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<qapplication.h>
#include	<qlayout.h>
#include	<qobjectlist.h>

#if		__KB_AUTOMOC
#include	"rk_vbox.moc"
#else
#include	"rk_vbox.h"
#endif

RKVBox::RKVBox
	(	QWidget		*parent,
		const char	*name,
		WFlags		flags
	)
	:
	RKBox	(parent, name, flags)
{
	m_layout = new RKBoxLayout (this, QBoxLayout::TopToBottom, isNestedBox()) ;
	m_layout->setAutoAdd (true) ;

	setMargin (0) ;
}


void	RKVBox::setSpacing
	(	int		space
	)
{
	m_layout->setSpacing (space)	;
}


void	RKVBox::frameChanged ()
{
	m_layout->setMargin (frameWidth()) ;
}


QSize	RKVBox::sizeHint() const
{
	QApplication::sendPostedEvents
	(	(QWidget *)this,
		QEvent::ChildInserted
	)	;
	return	RKBox::sizeHint() ;
}

void	RKVBox::addFiller ()
{
	QApplication::sendPostedEvents
	(	this,
		QEvent::ChildInserted
	)	;
	m_layout->addStretch (1) ;
}

void	RKVBox::setStretchFactor
	(	QWidget 	*widget,
		int		factor
	)
{
	QApplication::sendPostedEvents
	(	this,
		QEvent::ChildInserted
	)	;
	m_layout->setStretchFactor (widget, factor) ;
}

void	RKVBox::fixToChildWidth
	(	int		extra
	)
{
	QObjectList   *clist = queryList ("QWidget", 0, false, false) ;
	if (clist == 0) return ;

	int		maxw	= 0   ;
	QObjectListIt	iter (*clist) ;
	QObject		*obj ;

	while ((obj = iter.current()) != 0)
	{
		int	w = ((QWidget *)obj)->sizeHint().width() ;
		if (w > maxw) maxw = w ;
		iter	+= 1 ;
	}

	if (maxw > 0) setFixedWidth (maxw + extra) ;
}

void	RKVBox::setNoMargin
	(	bool		noMargin
	)
{
	m_layout->setNoMargin (noMargin) ;
}
