#include <qapplication.h>

#if	__KB_AUTOMOC
#include "rk_weekselector.moc"
#else
#include "rk_weekselector.h"
#endif

RKWeekSelector::RKWeekSelector( QWidget* parent, const char* name )
  : QLineEdit( parent, name ), m_pValidator( new QIntValidator( this ) ), m_Result( 0 )
{
	QFont font;

	font = QApplication::font();
	QApplication::setFont( font );
	setFrameStyle( QFrame::NoFrame );
	setValidator( m_pValidator );
  
	connect(this, SIGNAL( returnPressed() ), SLOT( slotWeekEntered() ) );
}

void RKWeekSelector::slotWeekEntered()
{
	bool ok;
	int week;
	
	// ----- check if this is a valid week:
	
	week = text().toInt( &ok );
  
	if( !ok )
    {
		QApplication::beep();
		return;
    }
  
	m_Result = week;
	emit( shutDown( 1 ) );
}

int RKWeekSelector::week()
{
  return m_Result;
}

void RKWeekSelector::setWeek( int week )
{
	QString temp;

	temp.setNum(week);
	setText( temp );
}

void RKWeekSelector::slotSetMaxWeek( int max )
{
	m_pValidator->setRange( 1, max );
}
