#include <qapplication.h>

#if __KB_AUTOMOC
#include "rk_yearselector.moc"
#else
#include "rk_yearselector.h"
#endif

RKYearSelector::RKYearSelector( QWidget* parent, const char* name )
  : QLineEdit( parent, name ), m_pValidator( new QIntValidator( this ) ), m_Result( 0 )
{
	QFont font;

	font = QApplication::font();
	QApplication::setFont( font );
	setFrameStyle( QFrame::NoFrame );

	m_pValidator->setRange( 0, 8000 );
	setValidator( m_pValidator );
  
	connect( this, SIGNAL( returnPressed() ), SLOT(yearEnteredSlot() ) );
}

void RKYearSelector::slotYearEntered()
{
	bool ok;
	int year;
	QDate date;

	year = text().toInt( &ok );
  
	if( ! ok )
    {
		QApplication::beep();
		return;
    }
  
	date.setYMD( year, 1, 1 );

	if( ! date.isValid() )
    {
		QApplication::beep();
		return;
    }
  
	m_Result = year;
	emit( shutDown( 1 ) );
}

int RKYearSelector::year()
{
	return m_Result;
}

void RKYearSelector::setYear( int year )
{
	QString temp;

	temp.setNum( year );
	setText( temp );
}
