/***************************************************************************
    file	         : tk_dialogs.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	<qnamespace.h>
#include	<qcolordialog.h>
#include	<qfontdialog.h>

#include	"tk_filedialog.h"
#include	"tk_colordialog.h"
#include	"tk_fontdialog.h"
#include	"rk_dialog.h"


TKColorDialog::TKColorDialog
	(	QWidget		*parent,
		const char 	*name,
		bool
	)
	:
	m_parent (parent),
	m_name	 (name)
{
	m_color	= Qt::black	;
}

void	TKColorDialog::setColor
	(	const QColor	&color
	)
{
	m_color	 = color ;
}

bool	TKColorDialog::exec ()
{
	m_color	= QColorDialog::getColor (m_color, m_parent, m_name) ;
	return	m_color != QColor () ;
}

QColor	TKColorDialog::color ()
{
	return	m_color	;
}

int	TKColorDialog::getColor
	(	QColor		&color,
		QWidget		*parent
	)
{
	color	= QColorDialog::getColor
			(	color,
				RKDialog::activeWindow (parent)
			)	;
	return	color == QColor() ? Rejected : Accepted  ;
}


TKFontDialog::TKFontDialog
	(	QWidget			*parent,
		const char		*name,
		bool			,
		bool			,
		const QStringList	&,
		bool
	)
	:
	m_parent	(RKDialog::activeWindow (parent)),
	m_name		(name)
{
}

void	TKFontDialog::setFont
	(	const QFont	&font,
		bool
	)
{
	m_font	= font	;
}

bool	TKFontDialog::exec ()
{
	bool	ok	;
	m_font	= QFontDialog::getFont (&ok, m_font, m_parent, m_name) ;
	return	ok	;
}

QFont	TKFontDialog::font ()
{
	return	m_font	;
}



