/***************************************************************************
    file	         : tk_messagebox.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	<qnamespace.h>
#include	<qmessagebox.h>

#include	"rk_dialog.h"
#include	"tk_messagebox.h"


int	TKMessageBox::questionYesNo
	(	QWidget		*parent,
		const QString	&text,
		const QString	&caption,
		const QString	&buttonYes,
		const QString	&buttonNo,
		bool		
	)
{
	QString	bYes	= buttonYes	;
	QString	bNo	= buttonNo	;

	if (bYes.isEmpty()) bYes = "Yes" ;
	if (bNo .isEmpty()) bNo  = "No " ;

	QMessageBox mb
		(	caption,
			text,
			QMessageBox::Information,
        		QMessageBox::Yes | QMessageBox::Default,
        		QMessageBox::No,
			0L,
			RKDialog::activeWindow (parent)
		)	;

	mb.setButtonText(QMessageBox::Yes, bYes);
	mb.setButtonText(QMessageBox::No, bNo);

	return	mb.exec() ==  QMessageBox::Yes ?
			     TKMessageBox::Yes : TKMessageBox::No ;
}


int	TKMessageBox::questionYesNoCancel
	(	QWidget		*parent,
		const QString	&text,
		const QString	&caption,
		const QString	&buttonYes,
		const QString	&buttonNo,
		bool		
	)
{
	QString	bYes	= buttonYes	;
	QString	bNo	= buttonNo	;

	if (bYes.isEmpty()) bYes = "Yes" ;
	if (bNo .isEmpty()) bNo  = "No " ;

	QMessageBox mb
		(	caption,
			text,
			QMessageBox::Information,
        		QMessageBox::Yes | QMessageBox::Default,
        		QMessageBox::No,
			QMessageBox::Cancel,
			RKDialog::activeWindow (parent)
		)	;

	mb.setButtonText(QMessageBox::Yes, bYes);
	mb.setButtonText(QMessageBox::No,  bNo);

	switch (mb.exec())
	{
		case QMessageBox::Yes : return TKMessageBox::Yes ;
		case QMessageBox::No  : return TKMessageBox::No  ;
		default		      : break  ;
	}

	return	TKMessageBox::Cancel ;
}

void	TKMessageBox::sorry
	(	QWidget		*parent,
		const QString	&text,
		const QString	&caption,
		bool		
	)
{
	QMessageBox::information
	(	RKDialog::activeWindow (parent),
		caption,
		text
	)	;
}

void	TKMessageBox::information
	(	QWidget		*parent,
		const QString	&text,
		const QString	&caption,
		const QString	&,
		bool		
	)
{
	QMessageBox::information
	(	RKDialog::activeWindow (parent),
		caption,
		text
	)	;
}

