/***************************************************************************
    file	         : tk_messagebox.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	__TK_MESSAGEBOX_H
#define	__TK_MESSAGEBOX_H

#include	<qstring.h>

#include	"libtkkde_exports.h"

class		QWidget	;

class	LIBTKKDE_API TKMessageBox
{
public	:

	static	int	questionYesNo
		(	QWidget		*parent,
			const QString	&text,
			const QString	&caption	= QString::null,
			const QString	&buttonYes	= QString::null,
			const QString	&buttonNo	= QString::null,
			bool		notify		= true
		)	;

	static	int	questionYesNoCancel
		(	QWidget		*parent,
			const QString	&text,
			const QString	&caption	= QString::null,
			const QString	&buttonYes	= QString::null,
			const QString	&buttonNo	= QString::null,
			bool		notify		= true
		)	;

	static	void	sorry
		(	QWidget		*parent,
			const QString	&text,
			const QString	&caption	= QString::null,
			bool		notify		= true
		)	;

	static	void	information
		(	QWidget		*parent,
			const QString	&text,
			const QString	&caption	= QString::null,
			const QString	&notAgain	= QString::null,
			bool		notify		= true
		)	;

	enum
	{	Ok		= 1,
		Cancel		= 2,
		Yes		= 3,
		No		= 4,
		Continue	= 5
	}	;
}	;

#endif	// __TK_MESSAGEBOX_H
