#include	<stdio.h>

#include	<qcstring.h>
#include	<qstring.h>
#include	<qvariant.h>
#include	<qvaluelist.h>


#define	USAGE	"usage: rkdcop target func(a1,a2,...) ....\n"


/*  main	: Entry routine						*/
/*  argc	: int		 : Argument count			*/
/*  argv	: const char *[] : Argument vector			*/
/*  (returns)	: int		 : Return code				*/

int	main
	(	int		argc,
		const char	*argv[]
	)
{
	extern	QString	rkDCOPCall
		(	const char		*host,
			const char		*target,
			const char		*func,
			QValueList<QCString>	&args,
			QVariant		&resv
		)	;

	argc	-= 1	;
	argv	+= 1	;

	/* Host, target object and function specification are		*/
	/* required, subsequent arguments are optional.			*/
	if (argc < 3)
	{
		fprintf	(stderr, USAGE)	;
		return	1 ;
	}

	QValueList<QCString> args ;
	for (int a = 3 ; a < argc ; a += 1)
		args.append (argv[a]) ;

	QVariant rv	;
	QString	 rc	= rkDCOPCall
			  (	argv[0],
				argv[1],
				argv[2],
				args,
				rv
			  )	;

	if (!rc.isEmpty())
	{
		fprintf	(stderr, "%s\n", rc.latin1()) ;
		return	1 ;
	}

	switch (rv.type())
	{
		case QVariant::StringList :
		{
			QStringList sl = rv.toStringList() ;
			for (uint idx = 0 ; idx < sl.count() ; idx += 1)
				printf	("%s\n", sl[idx].latin1()) ;
			return	0 ;
		}

		case QVariant::String	  :
		{
			printf	("%s\n", rv.toString().latin1()) ;
			return	0 ;
		}

		case QVariant::Int	  :
		{
			printf	("%d\n", rv.toInt()) ;
			return	0 ;
		}

		default	:
			break	;
	}

	fprintf	(stderr, "rkdcop: %d: unknown return type\n", rv.type()) ;
	return	1 ;
}

