/***************************************************************************
    file	         : browser.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef 	__SOHELPBROWSER_H
#define 	__SOHELPBROWSER_H

#include <qtextbrowser.h>
#include <qtabwidget.h>

class	SOHelpViewer	;
class	QCursor		;
class	QColor		;

class	SOHelpPage : public QTextBrowser
{
	Q_OBJECT

	SOHelpViewer	*m_viewer	;
	bool		m_noScroll	;

	QStringList	m_sources	;
	QStringList	m_names		;
	QStringList	m_titles	;
	unsigned int	m_current	;

	QString		findWebBrowser		() ;

protected slots:

	void		ensureCursorVisible	() ;
	virtual void	setSource		(const QString &) ;

public	:

	SOHelpPage		(QWidget *, SOHelpViewer *, const char * = 0) ;

	QString	showHelp	(const QString &, const QString &, const QString &) ;
	void	blockScrolling	(bool)	;

	QString	nextpage	()	;
	QString	prevpage	()	;
}	;

class	SOHelpBrowser : public QTabWidget
{
	Q_OBJECT

	SOHelpViewer	*m_viewer	;
	SOHelpPage	*m_currentPage	;

public slots :

	void	nextpage		()	;
	void	prevpage		()	;
	void	openpage		()	;
	void	closepage		()	;
	void	pagechanged		()	;

public	:

	SOHelpBrowser		(QWidget *, SOHelpViewer *, const char * = 0) ;

	void	showHelp		(const QString &, const QString &, const QString &) ;
	void	blockScrolling		(bool)	;
	QString	source			()	;
	void	sync			()	;
	void	reload			()	;
	void	setColor		(const QColor  &) ;
	void	setCursor		(const QCursor &) ;
	void	setUpdatesEnabled	(bool)	;
	void	updateContents		()	;
	void	setCursorPosition	(int, int) ;
	bool	find			(const QString &, bool, bool, bool, int * = 0, int * = 0) ;
}	;

#endif		// __SOHELPBROWSER_H
