/***************************************************************************
    file	         : chooser.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef		__SOHELPCHOOSER_H
#define 	__SOHELPCHOOSER_H

#include 	"index.h"
#include 	"browser.h"
#include 	"parser.h"

#include 	<qlistbox.h>
#include 	<qlistview.h>
#include 	<qstringlist.h>
#include 	<qdict.h>
#include 	<qmime.h>

class	SOHelpViewer	;
class	QTabWidget	;

class	ContentsItem : public QListViewItem
{
	QString	m_link	;

public:

	ContentsItem	(QListView	*, const QString &, const QString &) ;
	ContentsItem	(QListViewItem	*, const QString &, const QString &) ;

	inline	QString	link() const
	{
		return	m_link	;
	}
}	;


class	SOHelpChooser : public QWidget
{
	Q_OBJECT

	QTabWidget	*m_tabber	;
	SOHelpViewer	*m_viewer	;
	SOHelpBrowser	*m_browser	;
	SOSearcher	*m_searchIndex	;

	QStringList	m_searchTerms	;
	QStringList	m_searchDocs	;

	QListView	*m_contentsList	;
	QWidget		*m_indexWidget	;

	QLineEdit	*m_indexEdit	;
	QListView	*m_indexList	;

	QLineEdit	*m_searchEdit	;
	QListBox	*m_searchList	;

	bool		m_display	;

	void		loadHelp	() ;
	bool		setHelpKey	(const QString &, ContentsItem *) ;

public	:

	SOHelpChooser	(QWidget *, SOHelpViewer *, SOHelpBrowser *) ;

	void		initialise	()	;
	void		setHelpKey	(const QString &) ;
	void		showContents	()	;
	void		showIndex	()	;

	virtual bool	eventFilter	(QObject *, QEvent *) ;

private slots:

	void	showIndexTopic		()		  ;
	void	showIndexTopic		(QListViewItem *) ;
	void	showContentsTopic	(QListViewItem *) ;


private slots :

	void 		scanIndex	(const QString &) ;
	void		startSearch	()		  ;
	void		showSearch	(int)		  ;
}	;

#endif		// __SOHELPCHOOSER_H
