/***************************************************************************
    file	         : parser.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef		__SOHELPPARSER_H
#define		__SOHELPPARSER_H

#include	<qxml.h>
#include	<qptrlist.h>
#include	<qptrstack.h>
#include	<qasciidict.h>

class	QListView	;
class	QListViewItem	;
class	QListBox	;
class	ContentsItem	;
class	SOHelpIndex	;

class SOHelpParser : public QXmlDefaultHandler
{
	QListView		*m_contentsList		;
	QListViewItem		*m_contentsPart		;

	QListView		*m_indexList		;
	QAsciiDict<SOHelpIndex>	&m_dictionary		;

	QPtrStack<ContentsItem>	m_currentContents	;
	QPtrStack<ContentsItem>	m_currentIndex		;

	SOHelpIndex		*m_currentKeyword	;
	QPtrList<QString>	m_keywordFiles		;

	QString			m_bookTitle		;
	QString			m_errors		;

public:

	SOHelpParser
	(	QListView		*conentsList,
		QListView		*indexList,
		QAsciiDict<SOHelpIndex>	&dictionary
	)	;
	SOHelpParser
	(	QListViewItem		*conentsPart,
		QListView		*indexList,
		QAsciiDict<SOHelpIndex>	&dictionary
	)	;

	virtual	bool	startDocument	() ;
	virtual	bool	startElement	(const QString &, const QString &, const QString &, const QXmlAttributes &) ;
	virtual	bool	endElement	(const QString &, const QString &, const QString &) ;
	virtual	bool	characters	(const QString &) ;
	virtual	bool	fatalError	(const QXmlParseException &) ;

	inline	const QString	&bookTitle ()
	{
		return	m_bookTitle	;
	}

	inline	const QString	&getErrors ()
	{
		return	m_errors	;
	}
}	;

#endif		// __SOHELPPARSER_H
