/***************************************************************************
    file	         : viewer.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef 	__SOHELPVIEWER_H
#define 	__SOHELPVIEWER_H

#include 	<qmainwindow.h>
#include 	<qsocket.h>

class	QSplitter	;
class	SOHelpBrowser	;
class	SOHelpChooser	;

class	SOHelpViewer : public QMainWindow
{
	Q_OBJECT

	SOHelpBrowser	*m_browser	;
	SOHelpChooser	*m_chooser	;
	QSplitter	*m_splitter	;
	QSocket		m_socket	;

	void		saveSettings	() ;

public:

	SOHelpViewer	(uint, QWidget * = 0, const char * = 0, WFlags = WType_TopLevel) ;
	~SOHelpViewer	() ;

	void		showLink	(const QString &, const QString &) ;
	void		setHelpKey	(const QString &) ;
	virtual	bool	close		(bool)		  ;

public slots	:

	virtual	void	about		()	;
	void		slotReadyRead	()	;
	void		slotLinkClosed	()	;

};

#endif		// __SOHELPVIEWER_H
