/***************************************************************************
    file	         : kb_blockproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_BLOCKPROXY_H
#define	__KB_BLOCKPROXY_H


class	KBKJSInterpreter	;

/*  KBBlockProxy							*/
/*  ------------							*/
/*  Proxy class for Rekall blocks ....					*/

class	KBBlockProxy : public KBItemProxy
{
protected :

	KBBlock		*m_block	;

public	:

	KBBlockProxy	(KBKJSInterpreter *, KBBlock *) ;
	~KBBlockProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;

	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;

protected :

	class MethodImp : public KBItemProxy::MethodImp
	{
	protected :

		virtual	KJS::Value callBase
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		const KBBlockProxy	*m_block	;

	public	:

		MethodImp	(KBMethodSpec *, const KBBlockProxy *) ;
		~MethodImp()	{}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		static	const uint	id_getNumRows	   = IDB_BLOCK + 13 ;
		static	const uint	id_getQueryRow	   = IDB_BLOCK + 14 ;
		static	const uint	id_overLimit	   = IDB_BLOCK + 15 ;
		static	const uint	id_getRowValue	   = IDB_BLOCK + 17 ;
		static	const uint	id_setRowValue	   = IDB_BLOCK + 18 ;
		static	const uint	id_setUserFilter   = IDB_BLOCK + 20 ;
		static	const uint	id_setUserSorting  = IDB_BLOCK + 21 ;
	}	;

	friend	class	MethodImp ;
}	;

#endif	// __KB_BLOCKPROXY_H
