/***************************************************************************
    file	         : kb_buttonproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_BUTTONPROXY_H
#define	__KB_BUTTONPROXY_H


/*  KBButtonProxy							*/
/*  -------------							*/
/*  Proxy class for Rekall buttons.					*/

class	KBButtonProxy : public KBObjectProxy
{
protected :

	KBButton		*m_button	;

public	:

	KBButtonProxy	(KBKJSInterpreter *, KBButton *) ;
	~KBButtonProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;

	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;


protected :

	class MethodImp : public KBObjectProxy::MethodImp
	{
	protected :

		const KBButtonProxy	*m_button	;

	public	:


		MethodImp	(KBMethodSpec *, const KBButtonProxy *) ;
		~MethodImp()	{}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		static	const uint	id_getText	= IDB_BUTTON + 1 ;
		static	const uint	id_setText	= IDB_BUTTON + 2 ;
		static	const uint	id_isOn		= IDB_BUTTON + 3 ;
		static	const uint	id_setOn	= IDB_BUTTON + 4 ;
		static	const uint	id_setPixmaps	= IDB_BUTTON + 5 ;
		static	const uint	id_setToolTip	= IDB_BUTTON + 6 ;
	}	;

	friend	class	MethodImp ;
}	;

#endif	// __KB_BUTTONPROXY_H
