/***************************************************************************
    file	         : kb_checkproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_CHECKPROXY_H
#define	__KB_CHECKPROXY_H


/*  KBCheckProxy							*/
/*  -------------							*/
/*  Proxy class for checkbox controls.					*/

class	KBCheckProxy : public KBItemProxy
{
protected :

	KBCheck		*m_check	;

public	:

	KBCheckProxy	(KBKJSInterpreter *, KBCheck *) ;
	~KBCheckProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;

	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;


protected :

	class MethodImp : public KBItemProxy::MethodImp
	{
	protected :

		virtual	KJS::Value callBase
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		const KBCheckProxy	*m_check	;

	public	:

		MethodImp	(KBMethodSpec *, const KBCheckProxy *) ;
		~MethodImp()	{}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		static	const uint	id_isChecked	= IDB_CHECK  + 1 ;
		static	const uint	id_setChecked	= IDB_CHECK  + 2 ;
	}	;

	friend	class	MethodImp ;
}	;

#endif	// __KB_CHECKPROXY_H
