/***************************************************************************
    file	         : kb_eventsproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	__KB_EVENTSPROXY_H
#define	__KB_EVENTSPROXY_H


class	KBKJSInterpreter	;


/*  KBEventsProxy							*/
/*  -------------							*/
/*  Proxy class for the "object.__events__" pseudo-property.		*/


class	KBEventsProxy : public KJS::ObjectImp
{
protected :

	KBKJSInterpreter	*m_interp	;
	KBObject		*m_object 	;
	
public	:

	KBEventsProxy	(KBKJSInterpreter *, KBObject *) ;
	~KBEventsProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;

	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;

protected :

	inline	KBKJSInterpreter *interpreter () const
	{
		return	m_interp ;
	}

	class MethodImp : public KJS::ObjectImp
	{

	protected :

		KBEvent			*m_event	;
		const KBEventsProxy	*m_proxy	;

	public	:

		MethodImp	(KBEvent *, const KBEventsProxy *) ;
		~MethodImp()	{}

		virtual	bool	implementsCall () const
		{
			return	true	;
		}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;
	}	;

	friend	class	MethodImp ;
}	;

#endif	// __KB_EVENTSPROXY_H
