/***************************************************************************
    file	         : kb_fieldproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_FIELDPROXY_H
#define	__KB_FIELDPROXY_H


/*  KBFieldProxy							*/
/*  -------------							*/
/*  Proxy class for Rekall fields.					*/

class	KBFieldProxy : public KBItemProxy
{
protected :

	KBField		*m_field	;

public	:

	KBFieldProxy	(KBKJSInterpreter *, KBField *) ;
	~KBFieldProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;

	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;


protected :

	class MethodImp : public KBItemProxy::MethodImp
	{
	protected :

		virtual	KJS::Value callBase
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		const KBFieldProxy	*m_field	;

	public	:

		MethodImp	(KBMethodSpec *, const KBFieldProxy *) ;
		~MethodImp()	{}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		static	const uint	id_setSelection	  = IDB_FIELD  + 1 ;
	}	;

	friend	class	MethodImp ;
}	;

#endif	// __KB_FIELDPROXY_H
