/***************************************************************************
    file	         : kb_fileproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	__KB_FILEPROXY_H
#define	__KB_FILEPROXY_H


class		KBKJSInterpreter	;

#include	<qfile.h>
#include	<qtextstream.h>
#include	"kb_idbase.h"

/*  KBFileProxy								*/
/*  -------------							*/
/*  Proxy class for Rekall file objects.				*/

class	KBFileProxy : public KJS::ObjectImp
{
protected :

	KBKJSInterpreter	*m_interp	;
	QFile			m_file	 	;
	QTextStream		m_stream	;

public	:

	KBFileProxy	(KBKJSInterpreter *)	;
	~KBFileProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;
	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;

protected :

	inline	KBKJSInterpreter *interpreter () const
	{
		return	m_interp ;
	}

	class MethodImp : public KJS::ObjectImp
	{

		KJS::Value		fireSlot
					(	KJS::ExecState	*,
						const KJS::List	&
					)	;

	protected :

		int			m_id		;
		KBFileProxy		*m_file		;

	public	:

		/* The constructor arguments are the method name and	*/
		/* code and the actual object proxy. The argument	*/
		/* specification is optional.				*/
		MethodImp	(int, KBFileProxy *)	;
		~MethodImp()	{}

		virtual	bool	implementsCall () const
		{
			return	true	;
		}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		static	const uint	id_open		= IDB_FILE + 1	;
		static	const uint	id_read		= IDB_FILE + 2  ;
		static	const uint	id_readLine	= IDB_FILE + 3  ;
		static	const uint	id_write	= IDB_FILE + 4  ;
		static	const uint	id_close	= IDB_FILE + 5  ;
	}	;

	friend	class	MethodImp ;
}	;

#endif	// __KB_FILEPROXY_H
