/***************************************************************************
    file	         : kb_formblockproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_FORMBLOCKPROXY_H
#define	__KB_FORMBLOCKPROXY_H


class	KBKJSInterpreter	;

/*  KBFormBlockProxy							*/
/*  ----------------							*/
/*  Proxy class for Rekall blocks ....					*/

class	KBFormBlockProxy : public KBBlockProxy
{
protected :

	KBFormBlock		*m_formBlock	;

public	:

	KBFormBlockProxy	(KBKJSInterpreter *, KBFormBlock *) ;
	~KBFormBlockProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;

	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;

protected :

	class MethodImp : public KBBlockProxy::MethodImp
	{
	protected :

		virtual	KJS::Value callBase
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		const KBFormBlockProxy	*m_formBlock	;

	public	:

		MethodImp	(KBMethodSpec *, const KBFormBlockProxy *) ;
		~MethodImp()	{}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		static	const uint	id_gotoQueryRow	   = IDB_FORMBLOCK +  1 ;
		static	const uint	id_doAction	   = IDB_FORMBLOCK +  2 ;
		static	const uint	id_firstRecord	   = IDB_FORMBLOCK +  3 ;
		static	const uint	id_previousRecord  = IDB_FORMBLOCK +  4 ;
		static	const uint	id_nextRecord	   = IDB_FORMBLOCK +  5 ;
		static	const uint	id_lastRecord	   = IDB_FORMBLOCK +  6 ;
		static	const uint	id_addRecord	   = IDB_FORMBLOCK +  7 ;
		static	const uint	id_saveRecord	   = IDB_FORMBLOCK +  8 ;
		static	const uint	id_deleteRecord	   = IDB_FORMBLOCK +  9 ;
		static	const uint	id_startQuery	   = IDB_FORMBLOCK + 10 ;
		static	const uint	id_executeQuery	   = IDB_FORMBLOCK + 11 ;
		static	const uint	id_cancelQuery	   = IDB_FORMBLOCK + 12 ;
		static	const uint	id_isInQuery	   = IDB_FORMBLOCK + 16 ;
		static	const uint	id_invalidControls = IDB_FORMBLOCK + 19 ;
		static	const uint	id_reload          = IDB_FORMBLOCK + 22 ;
		static	const uint	id_saveAsNew       = IDB_FORMBLOCK + 23 ;
		static	const uint	id_saveUnchecked   = IDB_FORMBLOCK + 24 ;
		static	const uint	id_gotoQueryRowByKey
							   = IDB_FORMBLOCK + 25 ;
		static	const uint	id_changedControls = IDB_FORMBLOCK + 26 ;
	}	;

	friend	class	MethodImp ;
}	;

#endif	// __KB_FORMBLOCKPROXY_H
