/***************************************************************************
    file	         : kb_formproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_FORMPROXY_H
#define	__KB_FORMPROXY_H


class	KBKJSInterpreter	;
class	KBGlobalProxy		;

/*  KBFormProxy								*/
/*  ------------							*/
/*  Proxy class for Rekall forms ....					*/

class	KBFormProxy : public KBFormBlockProxy
{
protected :

	KBForm			*m_form 	;
	KBGlobalProxy		*m_global	;

public	:

	KBFormProxy	(KBKJSInterpreter *, KBForm *) ;
	~KBFormProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;

	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;

protected :

	class MethodImp : public KBFormBlockProxy::MethodImp
	{
	protected :

		virtual	KJS::Value callBase
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		const KBFormProxy	*m_form	;

	public	:

		MethodImp	(KBMethodSpec *, const KBFormProxy *) ;
		~MethodImp()	{}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		static	const uint	id_openForm	   = IDB_FORM +  1  ;
		static	const uint	id_openReport	   = IDB_FORM +  2  ;
		static	const uint	id_close	   = IDB_FORM +  3  ;
		static	const uint	id_getOpener	   = IDB_FORM +  4  ;
		static	const uint	id_getParameter	   = IDB_FORM +  5  ;
		static	const uint	id_showMessage	   = IDB_FORM +  6  ;
		static	const uint	id_parameterDict   = IDB_FORM +  7  ;
		static	const uint	id_closeAll	   = IDB_FORM +  8  ;
		static	const uint	id_getGlobalCtrl   = IDB_FORM +  9  ;
		static	const uint	id_getSkinFGColor  = IDB_FORM +  10 ;
		static	const uint	id_getSkinBGColor  = IDB_FORM +  11 ;
		static	const uint	id_getSkinFont     = IDB_FORM +  12 ;
	}	;

	friend	class	MethodImp ;
}	;

#endif	// __KB_FORMPROXY_H
