/***************************************************************************
    file	         : kb_framerproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_FRAMERPROXY_H
#define	__KB_FRAMERPROXY_H


class	KBKJSInterpreter	;

/*  KBFramerProxy							*/
/*  ------------							*/
/*  Proxy class for Rekall framers ....					*/

class	KBFramerProxy : public KBObjectProxy
{
protected :

	KBFramer		*m_framer	;

public	:

	KBFramerProxy	(KBKJSInterpreter *, KBFramer *) ;
	~KBFramerProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;

	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;

protected :

	class MethodImp : public KBObjectProxy::MethodImp
	{
	protected :

		const KBFramerProxy	*m_framer	;

	public	:

		MethodImp	(KBMethodSpec *, const KBFramerProxy *) ;
		~MethodImp()	{}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		static	const uint	id_getNumRows	= IDB_FRAMER + 1 ;
		static	const uint	id_getQueryRow	= IDB_FRAMER + 2 ;
		static	const uint	id_getRowValue	= IDB_FRAMER + 3 ;
		static	const uint	id_setRowValue	= IDB_FRAMER + 4 ;
		static	const uint	id_setBackgroundGraphic
							= IDB_FRAMER + 5 ;
	}	;

	friend	class	MethodImp ;
}	;

#endif	// __KB_FRAMERPROXY_H
