/***************************************************************************
    file	         : kb_kjdebug.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	__KB_KJDEBUG_H
#define	__KB_KJDEBUG_H

#include	"kjs/debugger.h"

class	QTime		;

class	KBKJSDebugger : public KJS::Debugger
{
	int			m_lastSourceID		;
	int			m_lastLine		;
	QString			m_exceptionName		;
	QString			m_exceptionMessage	;

	static	KBKJSDebugger	*m_self			;
	static	QTime		*m_timer		;

public	:

	KBKJSDebugger	()	;

	virtual	bool	sourceParsed
			(	KJS::ExecState		*exec,
				int			sourceId,
				const KJS::UString	&source,
				int			errorLine
			)	;

	virtual	bool	atStatement
			(	KJS::ExecState		*exec
			)	;

	virtual	bool	enterContext
			(	KJS::ExecState		*exec
			)	;

	virtual	bool	exitContext
			(	KJS::ExecState		*exec,
				const KJS::Completion	&completion
			)	;

	virtual	bool	exception
			(	KJS::ExecState		*exec,
				const KJS::Value	&value,
				bool			inTryCatch
			)	;

	inline	int	lastSourceID	() { return m_lastSourceID	; }
	inline	int	lastLine	() { return m_lastLine		; }
	inline	QString	exceptionName	() { return m_exceptionName	; }
	inline	QString	exceptionMessage() { return m_exceptionMessage	; }

	static	KBKJSDebugger	*self ();
}	;

#endif	// __KB_KJDEBUG_H
