/***************************************************************************
    file	         : kb_labelproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_LABELPROXY_H
#define	__KB_LABELPROXY_H


/*  KBLabelProxy							*/
/*  -------------							*/
/*  Proxy class for Rekall labels.					*/

class	KBLabelProxy : public KBObjectProxy
{
protected :

	KBLabel		*m_label	;

public	:

	KBLabelProxy	(KBKJSInterpreter *, KBLabel *) ;
	~KBLabelProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;

	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;


protected :

	class MethodImp : public KBObjectProxy::MethodImp
	{
	protected :

		const KBLabelProxy	*m_label	;

	public	:


		MethodImp	(KBMethodSpec *, const KBLabelProxy *) ;
		~MethodImp()	{}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		static	const uint	id_getText	= IDB_LABEL + 1 ;
		static	const uint	id_setText	= IDB_LABEL + 2 ;
	}	;

	friend	class	MethodImp ;
}	;

#endif	// __KB_LABELPROXY_H
