/***************************************************************************
    file	         : kb_linkproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_LINKPROXY_H
#define	__KB_LINKPROXY_H



/*  KBLinkProxy								*/
/*  -------------							*/
/*  Proxy class for Rekall link controls.				*/

class	KBLinkProxy : public KBLinkTreeProxy
{
protected :

	KBLink		*m_link	;

public	:

	KBLinkProxy	(KBKJSInterpreter *, KBLink *) ;
	~KBLinkProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;

	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;


protected :

	class MethodImp : public KBLinkTreeProxy::MethodImp
	{
	protected :

		const KBLinkProxy	*m_link	;

	public	:

		MethodImp	(KBMethodSpec *, const KBLinkProxy *) ;
		~MethodImp()	{}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		static	const uint	id_currentItem	     = IDB_LINK  + 1 ;
		static	const uint	id_setCurrentItem    = IDB_LINK  + 2 ;
		static	const uint	id_setCurrentDisplay = IDB_LINK  + 3 ;
	}	;

	friend	class	MethodImp ;
}	;

#endif	// __KB_LINKPROXY_H
