/***************************************************************************
    file	         : kb_listboxproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef	__KB_LISTBOXPROXY_H
#define	__KB_LISTBOXPROXY_H


/*  KBListBoxProxy							*/
/*  -------------							*/
/*  Proxy class for Rekall list boxes.					*/

class	KBListBoxProxy : public KBItemProxy
{
protected :

	KBListBox		*m_listbox	;

public	:

	KBListBoxProxy	(KBKJSInterpreter *, KBListBox *) ;
	~KBListBoxProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;

	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;


protected :

	class MethodImp : public KBItemProxy::MethodImp
	{
	protected :

		virtual	KJS::Value callBase
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		const KBListBoxProxy	*m_listbox	;

	public	:

		MethodImp	(KBMethodSpec *, const KBListBoxProxy *) ;
		~MethodImp()	{}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		static	const uint	id_currentItem	  = IDB_LISTBOX  + 1 ;
		static	const uint	id_setCurrentItem = IDB_LISTBOX  + 2 ;
		static	const uint	id_getValues	  = IDB_LISTBOX  + 3 ;
		static	const uint	id_setValues	  = IDB_LISTBOX  + 4 ;
		static	const uint	id_getNumValues	  = IDB_LISTBOX  + 5 ;
	}	;

	friend	class	MethodImp ;
}	;

#endif	// __KB_LISTBOXPROXY_H
