/***************************************************************************
    file	         : kb_rekallmain.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	"kjs/object_object.h"
#include	"kjs/internal.h"

using	namespace	KJS	;

class	RekallMainObjectImp : public ObjectImp
{
public	:

	static	const	ClassInfo	info ;

	RekallMainObjectImp	(ExecState *, ObjectPrototypeImp *) ;

	Value	get		(ExecState *, const Identifier &) const	;
	Value	getValueProperty(ExecState *, int) const	;

	virtual	const ClassInfo *classInfo ()
	{
		return	&info	;
	}

	enum
	{
		messageBox,
		queryBox,
		choiceBox,
		print,
		file,
		showPopupHelper,
		showPopupPrompt,
		showPopupChoice,
		webMode,
		URLRequest
	}	;
}	;

class	RekallMainFunctionImp : public InternalFunctionImp
{
	int	m_id	;

public	:

	RekallMainFunctionImp	(ExecState *, int, int) ;

	virtual	bool	implementsCall	()	const	;

	virtual	Value	call
			(	ExecState	*,
				Object		&,
				const List	&
			)	;
}	;
