/***************************************************************************
    file	         : kb_richtextproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	__KB_RICHTEXTPROXY_H
#define	__KB_RICHTEXTPROXY_H


/*  KBRichTextProxy							*/
/*  -------------							*/
/*  Proxy class for Rekall labels.					*/

class	KBRichTextProxy : public KBItemProxy
{
protected :

	KBRichText		*m_richtext	;

public	:

	KBRichTextProxy	(KBKJSInterpreter *, KBRichText *) ;
	~KBRichTextProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;

	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;


protected :

	class MethodImp : public KBItemProxy::MethodImp
	{
	protected :

		virtual	KJS::Value callBase
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		const KBRichTextProxy	*m_richtext	;

	public	:

		MethodImp	(KBMethodSpec *, const KBRichTextProxy *) ;
		~MethodImp()	{}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		static	const uint	id_makeSimpleLink = IDB_RICHTEXT  + 1 ;
	}	;

	friend	class	MethodImp ;
}	;

#endif	// __KB_RICHTEXTPROXY_H
