/***************************************************************************
    file	         : kb_stackproxy.h
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#ifndef	__KB_STACKPROXY_H
#define	__KB_STACKPROXY_H


class	KBKJSInterpreter	;


/*  KBStackProxy							*/
/*  -------------							*/
/*  Proxy class for Rekall objects. All other proxy classes are derived	*/
/*  from this.								*/

class	KBStackProxy : public KBObjectProxy
{
protected :

	KBStack		*m_stack 	;

public	:

	KBStackProxy	(KBKJSInterpreter *, KBStack *) ;
	~KBStackProxy	() ;


	virtual	void		addBindings
				(	KJS::ExecState		*,
					KJS::Object		&
				)	;

	virtual	KJS::Value	get
				(	KJS::ExecState		*,
					const KJS::Identifier	&
				)
				const	;

	virtual	void		put
				(	KJS::ExecState		*,
					const KJS::Identifier	&,
					const KJS::Value	&,
					int			= KJS::None
				)	;

protected :

	inline	KBKJSInterpreter *interpreter () const
	{
		return	m_interp ;
	}

	class MethodImp : public KBObjectProxy::MethodImp
	{

		KJS::Value	fireSlot	(KJS::ExecState *, const KJS::List &) ;

	protected :

		const KBStackProxy	*m_stack	;

		virtual	KJS::Value callBase
					(	KJS::ExecState	*,
						KJS::Object	&,
						const KJS::List &
					)	;

	public	:

		MethodImp	(KBMethodSpec *, const KBStackProxy *) ;
		~MethodImp()	{}

		virtual	bool	implementsCall () const
		{
			return	true	;
		}

		virtual	KJS::Value call
			(	KJS::ExecState	*,
				KJS::Object	&,
				const KJS::List &
			)	;

		static	const uint	id_currentPage	= IDB_STACK + 1  ;
	}	;

	friend	class	MethodImp ;

public	:

	static	KJS::Value	fromKBValue
				(	KJS::ExecState		*,
					const KBValue		&
				)	;

	static	KBValue		fromKJSValue
				(	KJS::ExecState		*,
					const KJS::Value	&
				)	;
}	;

#endif	// __KB_STACKPROXY_H
