/***************************************************************************
    file	         : kb_pycheck.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<Python.h>

#include	"kb_classes.h"
#include	"kb_type.h"
#include	"kb_value.h"
#include	"kb_check.h"
#include	"kb_block.h"

#include	"kb_pybase.h"
#include	"kb_pyvalue.h"

/*  PyKBCheck_isChecked							*/
/*		: Get current item					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Button text				*/

static	PyObject*PyKBCheck_isChecked
	(	PyObject	*,
		PyObject	*args
	)
{
	int	 qRow	 ;
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBCheck.isChecked",
					PyKBBase::m_object,
					args,
					"Oi",
					&qRow
				) ;
	if (pyBase == 0) return 0 ;

	KBCheck *kbCheck = (KBCheck *)pyBase->m_kbObject ;
	bool	checked	 ;
	qRow	= PyKBBase::getCurQRow (kbCheck, qRow) ;


	API_CALL(kbCheck,"KBCheck.isChecked") ;
	checked	= kbCheck->isChecked(qRow) ;
	API_DONE ;

	return	PyLong_FromLong (checked) ;
}

/*  PyKBCheck_setChecked						*/
/*		: Set current item					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Button text				*/

static	PyObject*PyKBCheck_setChecked
	(	PyObject	*,
		PyObject	*args
	)
{
	int	 qRow	 ;
	int	 checked ;
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBCheck.setChecked",
					PyKBBase::m_object,
					args,
					"Oii",
					&qRow,
					&checked
				) ;
	if (pyBase == 0) return 0 ;

	KBCheck *kbCheck = (KBCheck *)pyBase->m_kbObject ;
	qRow	= PyKBBase::getCurQRow (kbCheck, qRow) ;

	API_CALL(kbCheck,"KBCheck.setChecked") ;
	kbCheck->setChecked (qRow, checked) ;
	API_DONE ;

	return	PY_NONE	;
}

/*  ------------------------------------------------------------------	*/

static	PyMethodDef pyKBCheck_methods[] =
{
	PY_METHOD	(setChecked,		PyKBCheck	),
	PY_METHOD	(isChecked,		PyKBCheck	),
	PY_METHOD_END
}	;
static	const char *pyKBCheck_names  [] =
{
	"KBCheck",
	0
}	;

void	initPyKBCheck
	(	PyObject	*module
	)
{
	PyKBBase::makePythonClass
	(	"PyKBCheck",
		module,
		pyKBCheck_methods,
		"KBItem",
		pyKBCheck_names
	)	;
}
