/***************************************************************************
    file	         : kb_pydebug.h
    copyright            : (C) 1999,2000,2001,2002,2003 by Mike Richardson
			   (C) 2000,2001,2002,2003 by theKompany.com
			   (C) 2001,2002,2003 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#ifndef  _KB_PYDEBUG_H
#define  _KB_PYDEBUG_H


#include	"kb_classes.h"
#include	"kb_debug.h"

#include	"tkc_pydebugwidget.h"

/*  KBPYDebug								*/
/*  ---------								*/
/*  Python debugger class for Rekall					*/

class	KBPYDebug : public KBDebug
{
	Q_OBJECT

	TKCPyDebugWidget *m_debWidget	;
	KBaseGUI	 *m_gui		;

protected slots :

	void		breakAction	(int)	;
	void		setExcSkipList	()	;
	void		slotClose	()	;
	void		saveDocument	()	;
	void		doCompile	()	;
	void		toggleBreakpoint()	;
	void		trapExceptions	(bool)	;

	void		showingFile	(bool)	;
	void		fileChanged	(bool)	;
	void		enterTrap	(bool, bool, bool) ;
	void		exitTrap	()	;

public	:

		 KBPYDebug (TKToggleAction *, bool &) ;
	virtual	~KBPYDebug () ;

	virtual	bool	queryClose () ;
	virtual	bool	debugScript     (KBLocation &, KBError &) ;
}	;

#endif // _KB_PYDEBUG_H
