/***************************************************************************
    file	         : kb_pyfield.cpp
    copyright            : (C) 1999,2000,2001,2002,2003,2004 by Mike Richardson
			   (C) 2001,2002,2003,2004 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<Python.h>

#include	"kb_classes.h"
#include	"kb_type.h"
#include	"kb_value.h"
#include	"kb_field.h"
#include	"kb_block.h"

#include	"kb_pybase.h"


/*  PyKBField_setSelection						*/
/*		: Set text selection					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Item on				*/

static	PyObject*PyKBField_setSelection
	(	PyObject	*,
		PyObject	*args
	)
{
	int	row	;
	int	start	;
	int	length	;

	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"PyKBField.setSelection",
					PyKBBase::m_object,
					args,
					"Oiii",
					&row,
					&start,
					&length
				) ;
	if (pyBase == 0) return 0 ;

	KBField	*field	= (KBField *)pyBase->m_kbObject ;

	API_CALL(field,"PyKBField.setSelection") ;
	field->setSelection (row, start, length) ;
	API_DONE ;

	return	PY_NONE	;
}

/*  ------------------------------------------------------------------	*/

static	PyMethodDef pyKBField_methods[] =
{
	PY_METHOD	(setSelection,	PyKBField	),
	PY_METHOD_END
}	;

static	const char *pyKBField_names  [] =
{
	"KBField",
	0
}	;

void	initPyKBField
	(	PyObject	*module
	)
{
	PyKBBase::makePythonClass
	(	"PyKBField",
		module,
		pyKBField_methods,
		"KBItem",
		pyKBField_names
	)	;
}
