/***************************************************************************
    file	         : kb_pylabel.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<Python.h>

#include	"kb_classes.h"
#include	"kb_type.h"
#include	"kb_value.h"
#include	"kb_label.h"

#include	"kb_pybase.h"
#include	"kb_pyvalue.h"


/*  PyKBLabel_getText							*/
/*		: Get button text					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Button text				*/

static	PyObject*PyKBLabel_getText
	(	PyObject	*,
		PyObject	*args
	)
{
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBLabel.getText",
					PyKBBase::m_object,
					args,
					"O"
				) ;
	if (pyBase == 0) return 0 ;

	QString	text	;
	KBLabel	*label	= (KBLabel *)pyBase->m_kbObject ;

	API_CALL(label,"KBLabel.getText") ;
	text = label->getText() ;
	API_DONE;

	return  kb_qStringToPyString(text);
}

/*  PyKBLabel_setText							*/
/*		: Set button text					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: None or zero on error			*/

static	PyObject*PyKBLabel_setText
	(	PyObject	*,
		PyObject	*args
	)
{
	PyObject *text	 ;
	QString	 qText	 ;
	bool	 error	 ;
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBLabel.setText",
					PyKBBase::m_object,
					args,
					"OO",
					&text
				) ;
	if (pyBase == 0) return 0 ;
	
	qText = kb_pyStringToQString(text, error);
	if (error) return 0;

	KBLabel	*label	= (KBLabel *)pyBase->m_kbObject ;

	API_CALL(label,"KBLabel.setText") ;
	label->setText (qText) ;
	API_DONE;

	return	PY_NONE ;
}

/*  ------------------------------------------------------------------	*/

static	PyMethodDef pyKBLabel_methods[] =
{
	PY_METHOD	(getText,	PyKBLabel	),
	PY_METHOD	(setText,	PyKBLabel	),
	PY_METHOD_END
}	;
static	const char *pyKBLabel_names  [] =
{
	"KBLabel",
	0
}	;

void	initPyKBLabel
	(	PyObject	*module
	)
{
	PyKBBase::makePythonClass
	(	"PyKBLabel",
		module,
		pyKBLabel_methods,
		"KBObject",
		pyKBLabel_names
	)	;
}
