/***************************************************************************
    file	         : kb_pylink.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<Python.h>

#include	"kb_classes.h"
#include	"kb_type.h"
#include	"kb_value.h"
#include	"kb_link.h"
#include	"kb_block.h"

#include	"kb_pybase.h"
#include	"kb_pyvalue.h"


/*  PyKBLink_currentItem						*/
/*		: Get current item					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Button text				*/

static	PyObject*PyKBLink_currentItem
	(	PyObject	*,
		PyObject	*args
	)
{
	int	 qRow	 ;
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBLink.currentItem",
					PyKBBase::m_object,
					args,
					"Oi",
					&qRow
				) ;
	if (pyBase == 0) return 0 ;

	KBLink *kbLink = (KBLink *)pyBase->m_kbObject ;
	qRow	= PyKBBase::getCurQRow (kbLink, qRow) ;

	int	current	;

	API_CALL(kbLink,"KBLink.currentItem") ;
	current	= kbLink->currentItem(qRow)   ;
	API_DONE ;

	return	PyLong_FromLong (current) ;
}

/*  PyKBLink_setCurrentItem						*/
/*		: Set current item					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Button text				*/

static	PyObject*PyKBLink_setCurrentItem
	(	PyObject	*,
		PyObject	*args
	)
{
	int	 qRow	 ;
	int	 current ;
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBLink.currentItem",
					PyKBBase::m_object,
					args,
					"Oii",
					&qRow,
					&current
				) ;
	if (pyBase == 0) return 0 ;

	KBLink *kbLink = (KBLink *)pyBase->m_kbObject ;
	qRow	= PyKBBase::getCurQRow (kbLink, qRow) ;

	API_CALL(kbLink,"KBLink.currentItem") ;
	kbLink->setCurrentItem(qRow, current) ;
	API_DONE ;

	return	PY_NONE	;
}

/*  PyKBLink_setCurrentDisplay						*/
/*		: Get display values					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Button text				*/

static	PyObject*PyKBLink_setCurrentDisplay
	(	PyObject	*,
		PyObject	*args
	)
{
	int	 qRow	 ;
	PyObject *pyValue;
	bool	 error	 ;

	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBLink.setCurrentDisplay",
					PyKBBase::m_object,
					args,
					"OiO",
					&qRow,
					&pyValue
				) ;
	if (pyBase == 0) return 0 ;


	KBLink	*kbLink	= (KBLink *)pyBase->m_kbObject ;
	QString	text	= kb_pyStringToQString (pyValue, error) ;
	if (error) return 0 ;

	API_CALL(kbLink,"KBLink.setCurrentDisplay") ;
	kbLink->setCurrentDisplay (qRow, text) ;
	API_DONE ;

	return	PY_NONE	;
}

static	PyMethodDef pyKBLink_methods[] =
{
	PY_METHOD	(currentItem,		PyKBLink	),
	PY_METHOD	(setCurrentItem,	PyKBLink	),
	PY_METHOD	(setCurrentDisplay,	PyKBLink	),
	PY_METHOD_END
}	;

static	const char *pyKBLink_names  [] =
{
	"KBLink",
	0
}	;

void	initPyKBLink
	(	PyObject	*module
	)
{
	PyKBBase::makePythonClass
	(	"PyKBLink",
		module,
		pyKBLink_methods,
		"KBLinkTree",
		pyKBLink_names
	)	;
}
