/***************************************************************************
    file	         : kb_pyrichtext.cpp
    copyright            : (C) 1999,2000,2001,2002,2003,2004 by Mike Richardson
			   (C) 2001,2002,2003,2004 by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<Python.h>

#include	"kb_classes.h"
#include	"kb_type.h"
#include	"kb_value.h"
#include	"kb_richtext.h"
#include	"kb_block.h"

#include	"kb_pybase.h"


/*  ------------------------------------------------------------------	*/

/*  PyKBRichText_makeSimpleLink						*/
/*		: Get button text					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Button text				*/

static	PyObject*PyKBRichText_makeSimpleLink
	(	PyObject	*,
		PyObject	*args
	)
{
	cchar	 *legend ;
	cchar	 *link	 ;
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBRichText.makeSimpleLink",
					PyKBBase::m_object,
					args,
					"Oss",
					&legend,
					&link
				) ;

	if (pyBase == 0) return 0 ;

//	QString	 text	= QString("<a href='link:///%1'>%2</a>")
//				.arg(link)
//				.arg(legend)
//				;
	QString	 text	;
	text.sprintf	("<a href='link:///%s'>%s</a>", link, legend) ;
	return	PyString_FromString ((cchar *)text) ;
}

/*  ------------------------------------------------------------------	*/

static	PyMethodDef pyKBRichText_methods[] =
{
	PY_METHOD	(makeSimpleLink,	PyKBRichText	),
	PY_METHOD_END
}	;
static	const char *pyKBRichText_names  [] =
{
	"KBRichText",
	0
}	;

void	initPyKBRichText
	(	PyObject	*module
	)
{
	PyKBBase::makePythonClass
	(	"PyKBRichText",
		module,
		pyKBRichText_methods,
		"KBItem",
		pyKBRichText_names
	)	;
}
