/***************************************************************************
    file	         : kb_pyslot.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<Python.h>

#include	"kb_classes.h"
#include	"kb_type.h"
#include	"kb_value.h"
#include	"kb_object.h"
#include	"kb_slot.h"
#include	"kb_script.h"

#include	"kb_pybase.h"


extern	QString	getPythonString	(PyObject *)	;


static	PyObject*PyKBSlot_call
	(	PyObject	*,
		PyObject	*args
	)
{
	PyObject   	*pyInst			;
	PyObject	*pyCaller		;
	cchar		*event			;

	PyObject	*pyValue[MAX_CALL_ARGS]	;
	memset	(pyValue, 0, sizeof(pyValue))	;

//	fprintf
//	(	stderr,
//		"PyKBSlot_call: called, calling PyArg_ParseTuple\n"
//	)	;
//
//	for (int index = 0 ; index < PyTuple_GET_SIZE(args) ; index += 1)
//	{
//		PyObject *a = PyTuple_GET_ITEM(args, index) ;
//		fprintf
//		(	stderr,
//			"	%2d: %s\n",
//			index,
//			(cchar *)getPythonString(a)
//		)	;
//	}

	if (!PyArg_ParseTuple
		(	args,
			"OOs|OOOOOO",
			&pyInst,
			&pyCaller,
			&event,
			&pyValue[0],
			&pyValue[1],
			&pyValue[2],
			&pyValue[3],
			&pyValue[4],
			&pyValue[5]
		))
	{
//		fprintf
//		(	stderr,
//			"PyKBSlot_call: parse args failed\n"
//		)	;
		return	0	;
	}

//	fprintf
//	(	stderr,
//		"PyKBSlot.call: p0=%p p1=%p p2=%p p3=%p p4=%p p5=%p\n",
//		(void *)pyValue[0],
//		(void *)pyValue[1],
//		(void *)pyValue[2],
//		(void *)pyValue[3],
//		(void *)pyValue[4],
//		(void *)pyValue[5]
//	)	;

	cchar	 *error	 ;
	PyKBBase *pySlot = PyKBBase::getPyBaseFromPyInst (pyInst, PyKBBase::m_slot, error) ;
	if (pySlot == 0)
	{
		PyErr_SetString (PyKBRekallError, error) ;
		return	0 ;
	}

//	fprintf
//	(	stderr,
//		"PyKBSlot_call: slot   is [%p]k=[%p]p=[%p]\n",
//		(void *)pySlot,
//		(void *)pySlot->m_kbObject,
//		(void *)pySlot->m_pyInstance
//	)	;


	PyKBBase *caller  = PyKBBase::getPyBaseFromPyInst (pyCaller, PyKBBase::m_object, error) ;
	if (caller == 0) return 0 ;

//	fprintf
//	(	stderr,
//		"PyKBSlot_call: caller is [%p]k=[%p]p=[%p]\n",
//		(void *)caller,
//		(void *)caller->m_kbObject,
//		(void *)caller->m_pyInstance
//	)	;

	KBValue		kbValue [MAX_CALL_ARGS]	;

	bool	 pyErr;
	unsigned int	nArgs	;
	for (nArgs = 0 ; nArgs < MAX_CALL_ARGS ; nArgs += 1)
		if (pyValue[nArgs] != 0)
		{
			kbValue[nArgs]	= PyKBBase::fromPyObject (pyValue[nArgs], pyErr) ;
			if (pyErr) return 0;
		}
		else	break	;

//	fprintf
//	(	stderr,
//		"PyKBSlot_call: about to call event signal: nArgs=%d\n",
//		nArgs
//	)	;

	KBValue		resval	;
	KBScriptError	*rc 	= 0 ;
	KBSlot		*slot	= (KBSlot *)pySlot->m_kbObject ;

	API_CALL(slot->parent(),"PyKBSlot.call") ;

	slot->eventSignal
		(	(KBObject *)caller->m_kbObject,
			event,
			nArgs,
			kbValue,
			resval,
			rc,
			-1
		) 	;

	API_DONE;

	if (rc != 0)
	{
		KBScriptError::processError (rc, KBScriptError::Normal) ;
		PyErr_SetString (PyKBRekallError, "Slot error") ;
		return	0 ;
	}

	return	PyKBBase::fromKBValue (resval) ;
}



static	PyMethodDef pyKBSlot_methods[] =
{
{	"call", 	PyKBSlot_call,		METH_VARARGS,	"PyKBSlot.call"	},
{	0,		0,			0,		0		}
}	;
static	const char *pyKBSlot_names  [] =
{
	"KBSlot",
	0
}	;

void	initPyKBSlot
	(	PyObject	*module
	)
{
	PyKBBase::makePythonClass
	(	"PyKBSlot",
		module,
		pyKBSlot_methods,
		0,
		pyKBSlot_names
	)	;
}
