/***************************************************************************
    file	         : kb_pysqldelete.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<Python.h>

#include	"kb_classes.h"
#include	"kb_type.h"
#include	"kb_value.h"
#include	"kb_dblink.h"

#include	"kb_pybase.h"
#include	"kb_pyvalue.h"


/*  PyKBSQLInsert_execute						*/
/*		: Executew query					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Item on				*/

static	PyObject*PyKBSQLDelete_execute
	(	PyObject	*,
		PyObject	*args
	)
{
	PyObject *alist	 = 0 ;
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBSQLDelete.execute",
					PyKBBase::m_sql,
					args,
					"O|O",
					&alist
				) ;
	if (pyBase == 0) return 0 ;

	extern	bool	getQueryArguments (PyObject *, uint &, KBValue *&) ;
	uint	nvals	;
	KBValue	*values	;
	if (!getQueryArguments (alist, nvals, values))
		return	0 ;

	bool	rc	;

	//Py_BEGIN_ALLOW_THREADS
	rc	= ((KBSQLDelete *)pyBase->m_kbObject)->execute (nvals, values) ;
	//Py_END_ALLOW_THREADS

	delete	[] values ;
	return	PyInt_FromLong (rc) ;
}

/*  PyKBSQLDelete_getNumRows						*/
/*		: Get number of rows returned				*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Item on				*/

static	PyObject*PyKBSQLDelete_getNumRows
	(	PyObject	*,
		PyObject	*args
	)
{
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBSQLDelete.getNumRows",
					PyKBBase::m_sql,
					args,
					"O"
				) ;
	if (pyBase == 0) return 0 ;

	int	nRows	;

	//Py_BEGIN_ALLOW_THREADS
	nRows	= ((KBSQLDelete *)pyBase->m_kbObject)->getNumRows() ;
	//Py_END_ALLOW_THREADS

	return	PyLong_FromLong (nRows) ;
}

/*  PyKBSQLDelete_lastError						*/
/*		: Get last query error					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Item on				*/

static	PyObject*PyKBSQLDelete_lastError
	(	PyObject	*,
		PyObject	*args
	)
{
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBSQLDelete.lastError",
					PyKBBase::m_sql,
					args,
					"O"
				) ;
	if (pyBase == 0) return 0 ;

	QString	error	;

	//Py_BEGIN_ALLOW_THREADS
	error	= PyKBBase::decodeError (((KBSQLDelete *)pyBase->m_kbObject)->lastError()) ;
	//Py_END_ALLOW_THREADS

	return	kb_qStringToPyString (error) ;
}

/*  PyKBSQLDelete___repr__						*/
/*		: Get __repr__						*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Element type				*/

static	PyObject*PyKBSQLDelete___repr__
	(	PyObject	*,
		PyObject	*args
	)
{
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBSQLDelete.__repr__",
					PyKBBase::m_sql,
					args,
					"O"
				) ;
	if (pyBase == 0) return 0 ;
	KBSQLDelete *obj  = (KBSQLDelete *)pyBase->m_kbObject ;

	QString	repr	= QString ("[SQLDelete @ 0x%1]")
				.arg((ulong)(void *)obj, 0, 16)
				;

	return	kb_qStringToPyString (repr) ;
}

/*  ------------------------------------------------------------------	*/

static	PyMethodDef PyKBSQLDelete_methods[] =
{
	PY_METHOD	(execute,	PyKBSQLDelete	),
	PY_METHOD	(getNumRows,	PyKBSQLDelete	),
	PY_METHOD	(lastError,	PyKBSQLDelete	),
	PY_METHOD	(__repr__,	PyKBSQLDelete	),
	PY_METHOD_END
}	;

static	const char *PyKBSQLDelete_names  [] =
{
	"KBSQLDelete",
	0
}	;

void	initPyKBSQLDelete
	(	PyObject	*module
	)
{
	PyKBBase::makePythonClass
	(	"PyKBSQLDelete",
		module,
		PyKBSQLDelete_methods,
		"KBBase",
		PyKBSQLDelete_names
	)	;
}
