/***************************************************************************
    file	         : kb_pysqlupdate.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<Python.h>

#include	"kb_classes.h"
#include	"kb_type.h"
#include	"kb_value.h"
#include	"kb_dblink.h"

#include	"kb_pybase.h"
#include	"kb_pyvalue.h"



/*  PyKBSQLUpdate_execute						*/
/*		: Executew query					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Item on				*/

static	PyObject*PyKBSQLUpdate_execute
	(	PyObject	*,
		PyObject	*args
	)
{
	PyObject *alist  = 0 ;
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBSQLUpdate.execute",
					PyKBBase::m_sql,
					args,
					"O|O",
					&alist
				) ;

//	fprintf
//	(	stderr,
//		"PyKBSQLUpdate_execute: pyBase=%p\n",
//		(void *)pyBase
//	)	;

	if (pyBase == 0) return 0 ;

	extern	bool	getQueryArguments (PyObject *, uint &, KBValue *&) ;
	uint	nvals	;
	KBValue	*values	;
	if (!getQueryArguments (alist, nvals, values))
		return	0 ;

	bool	rc	;

	//Py_BEGIN_ALLOW_THREADS
	rc	= ((KBSQLUpdate *)pyBase->m_kbObject)->execute (nvals, values) ;
	//Py_END_ALLOW_THREADS

	delete	[] values ;
	return	PyInt_FromLong (rc) ;
}

/*  PyKBSQLUpdate_getNumRows						*/
/*		: Get number of rows returned				*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Item on				*/

static	PyObject*PyKBSQLUpdate_getNumRows
	(	PyObject	*,
		PyObject	*args
	)
{
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBSQLUpdate.getNumRows",
					PyKBBase::m_sql,
					args,
					"O"
				) ;
	if (pyBase == 0) return 0 ;

	int	nRows	;

	//Py_BEGIN_ALLOW_THREADS
	nRows	= ((KBSQLUpdate *)pyBase->m_kbObject)->getNumRows() ;
	//Py_END_ALLOW_THREADS

	return	PyLong_FromLong (nRows) ;
}

/*  PyKBSQLUpdate_lastError						*/
/*		: Get last query error					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Item on				*/

static	PyObject*PyKBSQLUpdate_lastError
	(	PyObject	*,
		PyObject	*args
	)
{
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBSQLUpdate.lastError",
					PyKBBase::m_sql,
					args,
					"O"
				) ;
	if (pyBase == 0) return 0 ;

	QString	error	;

	//Py_BEGIN_ALLOW_THREADS
	error	= PyKBBase::decodeError (((KBSQLUpdate *)pyBase->m_kbObject)->lastError()) ;
	//Py_END_ALLOW_THREADS

	return	kb_qStringToPyString (error) ;
}

/*  PyKBSQLUpdate___repr__						*/
/*		: Get __repr__						*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Element type				*/

static	PyObject*PyKBSQLUpdate___repr__
	(	PyObject	*,
		PyObject	*args
	)
{
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBSQLUpdate.__repr__",
					PyKBBase::m_sql,
					args,
					"O"
				) ;
	if (pyBase == 0) return 0 ;
	KBSQLUpdate *obj  = (KBSQLUpdate *)pyBase->m_kbObject ;

	QString	repr	= QString ("[SQLUpdate @ 0x%1]")
				.arg((ulong)(void *)obj, 0, 16)
				;

	return	kb_qStringToPyString (repr) ;
}

/*  ------------------------------------------------------------------	*/

static	PyMethodDef PyKBSQLUpdate_methods[] =
{
	PY_METHOD	(execute,	PyKBSQLUpdate	),
	PY_METHOD	(getNumRows,	PyKBSQLUpdate	),
	PY_METHOD	(lastError,	PyKBSQLUpdate	),
	PY_METHOD	(__repr__,	PyKBSQLUpdate	),
	PY_METHOD_END
}	;

static	const char *PyKBSQLUpdate_names  [] =
{
	"KBSQLUpdate",
	0
}	;

void	initPyKBSQLUpdate
	(	PyObject	*module
	)
{
	PyKBBase::makePythonClass
	(	"PyKBSQLUpdate",
		module,
		PyKBSQLUpdate_methods,
		"KBBase",
		PyKBSQLUpdate_names
	)	;
}
