/***************************************************************************
    file	         : kb_pystack.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<Python.h>

#include	"kb_classes.h"
#include	"kb_type.h"
#include	"kb_value.h"
#include	"kb_stack.h"


#include	"kb_pybase.h"
#include	"kb_pyscript.h"


/*  PyKBStack_currentPage						*/
/*		: Get current page					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Button text				*/

static	PyObject*PyKBStack_currentPage
	(	PyObject	*,
		PyObject	*args
	)
{
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBStack.currentPage",
					PyKBBase::m_object,
					args,
					"O"
				) ;
	if (pyBase == 0) return 0 ;

	KBStack		*stack	 = (KBStack *)pyBase->m_kbObject ;
	KBStackPage	*current ;

	API_CALL(stack,"KBStack.currentPage") ;
	current	= stack->currentPage() ;
	API_DONE;

	if (current == 0)
		return	PY_NONE	;

	return	PyKBBase::makePythonInstance (current) ;
}

/*  ------------------------------------------------------------------	*/

static	PyMethodDef pyKBStack_methods[] =
{
	PY_METHOD	(currentPage,	PyKBStack	),
	PY_METHOD_END
}	;
static	const char *pyKBStack_names  [] =
{
	"KBStack",
	0
}	;

void	initPyKBStack
	(	PyObject	*module
	)
{
	PyKBBase::makePythonClass
	(	"PyKBStack",
		module,
		pyKBStack_methods,
		"KBFramer",
		pyKBStack_names
	)	;
}
