/***************************************************************************
    file	         : kb_pystackpage.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<Python.h>

#include	"kb_classes.h"
#include	"kb_type.h"
#include	"kb_value.h"
#include	"kb_stack.h"


#include	"kb_pybase.h"


/*  PyKBStackPage_setCurrent						*/
/*		: Set as current page					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Button text				*/

static	PyObject*PyKBStackPage_setCurrent
	(	PyObject	*,
		PyObject	*args
	)
{
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBStackPage.setCurrent",
					PyKBBase::m_object,
					args,
					"O"
				) ;
	if (pyBase == 0) return 0 ;

	KBStackPage *page = (KBStackPage *)pyBase->m_kbObject ;

	API_CALL(page,"KBStackPage.setCurrent") ;
	page->setCurrent() ;
	API_DONE;

	return	PY_NONE	;
}

/*  ------------------------------------------------------------------	*/

static	PyMethodDef pyKBStackPage_methods[] =
{
	PY_METHOD	(setCurrent,	PyKBStackPage	),
	PY_METHOD_END
}	;
static	const char *pyKBStackPage_names  [] =
{
	"KBStackPage",
	0
}	;

void	initPyKBStackPage
	(	PyObject	*module
	)
{
	PyKBBase::makePythonClass
	(	"PyKBStackPage",
		module,
		pyKBStackPage_methods,
		"KBFramer",
		pyKBStackPage_names
	)	;
}
