/***************************************************************************
    file	         : kb_pytabber.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<Python.h>

#include	"kb_classes.h"
#include	"kb_type.h"
#include	"kb_value.h"
#include	"kb_tabber.h"


#include	"kb_pybase.h"
#include	"kb_pyscript.h"


/*  PyKBTabber_currentPage						*/
/*		: Get current page					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Button text				*/

static	PyObject*PyKBTabber_currentPage
	(	PyObject	*,
		PyObject	*args
	)
{
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBTabber.currentPage",
					PyKBBase::m_object,
					args,
					"O"
				) ;
	if (pyBase == 0) return 0 ;

	KBTabber	*tabber	 = (KBTabber *)pyBase->m_kbObject ;
	KBTabberPage	*current ;

	API_CALL(tabber,"KBTabber.currentPage") ;
	current	= tabber->currentPage() ;
	API_DONE;

	if (current == 0)
		return	PY_NONE	;

	return	PyKBBase::makePythonInstance (current) ;
}

/*  ------------------------------------------------------------------	*/

static	PyMethodDef pyKBTabber_methods[] =
{
	PY_METHOD	(currentPage,	PyKBTabber	),
	PY_METHOD_END
}	;
static	const char *pyKBTabber_names  [] =
{
	"KBTabber",
	0
}	;

void	initPyKBTabber
	(	PyObject	*module
	)
{
	PyKBBase::makePythonClass
	(	"PyKBTabber",
		module,
		pyKBTabber_methods,
		"KBFramer",
		pyKBTabber_names
	)	;
}
