/***************************************************************************
    file	         : kb_pytabberpage.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#include	<Python.h>

#include	"kb_classes.h"
#include	"kb_type.h"
#include	"kb_value.h"
#include	"kb_tabber.h"


#include	"kb_pybase.h"


/*  PyKBTabberPage_setCurrent						*/
/*		: Set as current page					*/
/* 		: PyObject *	:					*/
/*  args	: PyObject *	: Arguments				*/
/*  (returns)	: PyObject *	: Button text				*/

static	PyObject*PyKBTabberPage_setCurrent
	(	PyObject	*,
		PyObject	*args
	)
{
	PyKBBase *pyBase = PyKBBase::parseTuple
				(	"KBTabberPage.setCurrent",
					PyKBBase::m_object,
					args,
					"O"
				) ;
	if (pyBase == 0) return 0 ;

	KBTabberPage *page = (KBTabberPage *)pyBase->m_kbObject ;

	API_CALL(page,"KBTabberPage.setCurrent") ;
	page->setCurrent() ;
	API_DONE

	return	PY_NONE	;
}

/*  ------------------------------------------------------------------	*/

static	PyMethodDef pyKBTabberPage_methods[] =
{
	PY_METHOD	(setCurrent,	PyKBTabberPage	),
	PY_METHOD_END
}	;
static	const char *pyKBTabberPage_names  [] =
{
	"KBTabberPage",
	0
}	;

void	initPyKBTabberPage
	(	PyObject	*module
	)
{
	PyKBBase::makePythonClass
	(	"PyKBTabberPage",
		module,
		pyKBTabberPage_methods,
		"KBFramer",
		pyKBTabberPage_names
	)	;
}
