/***************************************************************************
    file	         : tkc_excskipdlg.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/

#if		__KB_AUTOMOC
#include	"tkc_excskipdlg.moc"
#else
#include	"tkc_excskipdlg.h"
#endif

#include	<qlabel.h>
#include	<qtextbrowser.h>

#include	"rk_vbox.h"
#include	"rk_hbox.h"
#include	"rk_lineedit.h"
#include	"rk_pushbutton.h"
#include	"rk_listbox.h"

#include	"kb_sidepanel.h"

/*  TKCExcSkipDlg							*/
/*  TKCExcSkipDlg: Constructor for exceptions skip list dialog		*/
/*  excSkipList	 : QStringList & : Current skip list			*/
/*  (returns)	 : TKCExcSkipDlg :					*/

TKCExcSkipDlg::TKCExcSkipDlg
	(	QStringList	&excSkipList
	)
	:
	KBDialog	(TR("Exceptions skip list"), true),
	m_excSkipList	(excSkipList)
{
	RKVBox	*layTop		= new RKVBox	  (this)   ;
	layTop->setTracking ()	;

	RKHBox	*layMain	= new RKHBox	  (layTop) ;
	new KBSidePanel (layMain, caption()) ;

	QTextBrowser	*info	= new QTextBrowser(layMain)	;

	RKVBox	*layAddRem	= new RKVBox	  (layMain)	;
	m_edit			= new RKLineEdit  (layAddRem)	;
	m_bAdd			= new RKPushButton(TR("Add >>"   ), layAddRem) ;
	m_bRemove		= new RKPushButton(TR("<< Remove"), layAddRem) ;
	layAddRem->addFiller ()	;

	m_list			= new RKListBox	  (layMain)	;

	addOKCancel (layTop)	;

	m_addRemCtl	= new TKCListAddRem (m_edit, m_list, m_bAdd, m_bRemove, false) ;

	m_list->insertStringList (m_excSkipList) ;

	info->setText
	(	TR
		(	"<qt>"
			"When exception trapping is enabled, any exceptions "
			"raised from modules whose path is prefixed by an "
			"entry in the list will be ignored"
			"</qt>"
		)
	)	;
	info->polish	     () ;
	info->setMinimumSize (info->sizeHint()) ;
}

TKCExcSkipDlg::~TKCExcSkipDlg ()
{
	delete	m_addRemCtl ;
}

/*  TKCExcSkipDlg							*/
/*  accept	: User clicks OK					*/
/*  (returns)	: void		:					*/

void	TKCExcSkipDlg::accept ()
{
	m_excSkipList.clear () ;
	for (uint idx = 0 ; idx < m_list->count() ; idx += 1)
		m_excSkipList.append (m_list->text(idx)) ;

	done	(1) ;
}

