/***************************************************************************
    file	         : tkc_pyvalue.cpp
    copyright            : (C)	1999,2000,2001,2002,2003,2004,2005
				 by Mike Richardson
			   (C)	2001,2002,2003,2004,2005
				by John Dean
    license              : This file is released under the terms of
                           the GNU General Public License, version 2. The
                           copyright holders retain the right to release
                           this code under diffenent non-exclusive licences.
    email                : mike@quaking.demon.co.uk                                     
 ***************************************************************************/


#include	"kb_python.h"


#if		__KB_AUTOMOC
#include	"tkc_pyvalue.moc"
#else
#include 	"tkc_pyvalue.h"
#endif

#include	"tkc_pydebugbase.h"


QPtrDict<TKCPyValue>	TKCPyValue::allValues  ;


/*  TKCPyValue								*/
/*  TKCPyValue	: Constructor for interpreter python value object	*/
/*  pvalue	: PyObject *	: The value object			*/
/*  (returns)	: TKCPyValue	:					*/

TKCPyValue::TKCPyValue
	(	PyObject	*pvalue
	)
	:
	m_pvalue	(pvalue),
	m_ptype		(TKCPyDebugBase::getPythonType (pvalue))
{
	Py_INCREF	(m_pvalue) ;
	allValues.insert(m_pvalue, this) ;

//	fprintf
//	(	stderr,
//		"TKCPyValue::TKCPyValue: p=%p r=%4d %s\n",
//		(void *)m_pvalue,
//		m_pvalue->ob_refcnt,
//		m_ptype->simpleVal ?
//			 (const char *)TKCPyDebugBase::getPythonString(m_pvalue) :
//			 ""
//	)	;
}

/*  TKCPyValue								*/
/*  TKCPyValue	: Destructor for interpreter python value object	*/
/*  (returns)	:		:					*/

TKCPyValue::~TKCPyValue ()
{
//	fprintf
//	(	stderr,
//		"TKCPyValue::~TKCPyValue: p=%p n=%p\n",
//		 (void *)m_pvalue,
//		 (void *)m_pnode
//	)	;

	if (m_pvalue != 0)
	{
		allValues.remove (m_pvalue) ;
		Py_DECREF 	 (m_pvalue) ;
	}
}


/*  The following two methods are used to get a value. These should be	*/
/*  used, rather than directly calling the constructors, so that values	*/
/*  can be shared.							*/

/*  TKCPyValue	:							*/
/*  allocValue	: Get or allocate a value				*/
/*  pvalue	: PyObject *	: The value object			*/
/*  (returns)	: TKCPyValue	:					*/

TKCPyValue
	*TKCPyValue::allocValue
	(	PyObject	*pvalue
	)
{
	TKCPyValue *v ;

	if ((v = allValues.find (pvalue)) != 0)
		v->ref () ;
	else	v = new TKCPyValue (pvalue) ;

	return	v ;
}

