#include	<stdio.h>
#include	<qmetaobject.h>
#include	<qobjectlist.h>
#include	<qvariant.h>
#include	<qwidget.h>
#include	<qlabel.h>



static	void	printLabel
	(	QWidget		*widget,
		const char	*klass,
		uint		indent,
		FILE		*out
	)
{
	QMetaObject *meta = widget->metaObject    () ;

	while ((meta != 0) && (qstrcmp (meta->className(), klass) != 0))
		meta = meta->superClass() ;

	if (meta == 0) return ;

	QStrList    props = meta->propertyNames () ;

	for (const char *prop = props.first() ; prop != 0 ; prop = props.next())
		fprintf
		(	out,
			"%*s%-16s: %s\n",
			indent,
			"",
			prop,
			widget->property(prop).asString().latin1()
		)	;
}



void	printWidgetTree
	(	QWidget		*widget,
		uint		indent,
		FILE		*out
	)
{
	fprintf
	(	out,
		"%*s%s (%s) %s (%d,%d)(%d,%d)\n",
		indent,
		"",
		widget->className(),
		widget->name("noname"),
		widget->isVisible() ? "visible" : "hidden ",
		widget->x(),
		widget->y(),
		widget->width(),
		widget->height()
	)	;

	static	const char *klasses[] =
	{
		"QLabel",
		"QLineEdit",
		"QPushButton",
		0
	}	;


	for (const char **klass = &klasses[0] ; *klass != 0 ; klass += 1)
		if (widget->inherits (*klass))
		{	printLabel (widget, *klass, indent + 4, out) ;
			break	;
		}


	QObjectList *children = widget->queryList("QWidget", 0, true, false) ;
	if (children == 0) return ;

	QObjectListIt iter (*children) ;
	QObject	      *obj ;

	while ((obj = iter.current()) != 0)
	{	*++iter ;
		printWidgetTree ((QWidget *)obj, indent + 2, out) ;
	}

	delete	children ;
}
